<?php // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listbookmarks.php,v 1.3 2006/03/13 03:01:38 luis Exp $
 * 
 * Copyright (c) 2003 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$checkSession = true;
require_once('../includes/library.php');

if (isset($_GET['view'])) {
    $view = $_GET['view'];
} else {
    $view = "all";
}

require_once('../themes/' . THEME . '/header.php');
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../bookmarks/listbookmarks.php?view=all', lang_strings('bookmarks'), in));

if ($view == 'all') {
    $blockPage->itemBreadcrumbs(lang_strings('bookmarks_all') . ' | ' . $blockPage->buildLink('../bookmarks/listbookmarks.php?view=my', lang_strings('my'), in) . ' | ' . $blockPage->buildLink('../bookmarks/listbookmarks.php?view=private', lang_strings('bookmarks_private'), in));
} else if ($view == 'my') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../bookmarks/listbookmarks.php?view=all', lang_strings('bookmarks_all'), in) . ' | ' . lang_strings('my') . ' | ' . $blockPage->buildLink('../bookmarks/listbookmarks.php?view=private', lang_strings('bookmarks_private'), in));
} else if ($view == 'private') {
    $blockPage->itemBreadcrumbs($blockPage->buildLink('../bookmarks/listbookmarks.php?view=all', lang_strings('bookmarks_all'), in) . ' | ' . $blockPage->buildLink('../bookmarks/listbookmarks.php?view=my', lang_strings('my'), in) . ' | ' . lang_strings('bookmarks_private'));
}

$blockPage->closeBreadcrumbs();

if (isset($_GET['msg'])) {
    $msg = $_GET['msg'];
    require_once('../includes/messages.php');
    $blockPage->messagebox($msgLabel);
}

$block1 = new block();
$block1->form = 'saJ';
$block1->openForm('../bookmarks/listbookmarks.php?view=' . $view . '#' . $block1->form . 'Anchor');
$block1->heading(lang_strings('bookmarks'));
$block1->openPaletteIcon();
$block1->paletteIcon(0, 'add', lang_strings('add'));

if ($view == 'my') {
    $block1->paletteIcon(1, 'remove', lang_strings('delete'));
}

$block1->paletteIcon(5, 'info', lang_strings('view'));

if ($view == 'my') {
    $block1->paletteIcon(6, 'edit', lang_strings('edit'));
}

$block1->closePaletteIcon();

if ($view == 'my') {
    $block1->sorting('bookmarks', $sortingUser->sor_bookmarks[0], 'boo.name ASC', $sortingFields = array(0 => 'boo.name', 1 => 'boo.category', 2 => 'boo.shared'));
} else {
    $block1->sorting('bookmarks', $sortingUser->sor_bookmarks[0], 'boo.name ASC', $sortingFields = array(0 => 'boo.name', 1 => 'boo.category', 2 => 'mem.login'));
}

if ($view == 'my') {
    $tmpquery = "WHERE boo.owner = '$idSession' ORDER BY $block1->sortingValue";
} else if ($view == 'private') {
    $tmpquery = "WHERE boo.users LIKE '%|$idSession|%' ORDER BY $block1->sortingValue";
} else {
    $tmpquery = "WHERE boo.shared = '1' OR boo.owner = '$idSession' ORDER BY $block1->sortingValue";
}

$listBookmarks = new request();
$listBookmarks->openBookmarks($tmpquery);
$comptListBookmarks = count($listBookmarks->boo_id);

if ($comptListBookmarks != '0') {
    $block1->openResults();

    if ($view == 'my') {
        $block1->labels($labels = array(0 => lang_strings('name'), 1 => lang_strings('bookmark_category'), 2 => lang_strings('shared')), 'false');
    } else {
        $block1->labels($labels = array(0 => lang_strings('name'), 1 => lang_strings('bookmark_category'), 2 => lang_strings('owner')), 'false');
    } 

    for ($i = 0;$i < $comptListBookmarks;$i++) {
        $block1->openRow();
        $block1->checkboxRow($listBookmarks->boo_id[$i]);
        $block1->cellRow($blockPage->buildLink('../bookmarks/viewbookmark.php?view=' . $view . '&amp;id=' . $listBookmarks->boo_id[$i], $listBookmarks->boo_name[$i], in) . ' ' . $blockPage->buildLink($listBookmarks->boo_url[$i], '(' . lang_strings('url') . ')', out));
        $block1->cellRow($listBookmarks->boo_boocat_name[$i]);

        if ($view == 'my') {
            if ($listBookmarks->boo_shared[$i] == '1') {
                $printShared = lang_strings('yes');
            } else {
                $printShared = lang_strings('no');
            } 

            $block1->cellRow($printShared);
        } else {
            $block1->cellRow($blockPage->buildLink($listBookmarks->boo_mem_email_work[$i], $listBookmarks->boo_mem_login[$i], mail));
        } 

        $block1->closeRow();
    } 

    $block1->closeResults();
} else {
    $block1->noresults();
} 

$block1->closeFormResults();
$block1->openPaletteScript();
$block1->paletteScript(0, 'add', '../bookmarks/editbookmark.php?', 'true,false,false', lang_strings('add'));

if ($view == 'my') {
    $block1->paletteScript(1, 'remove', '../bookmarks/deletebookmarks.php?', 'false,true,true', lang_strings('delete'));
} 

$block1->paletteScript(5, 'info', '../bookmarks/viewbookmark.php?', 'false,true,false', lang_strings('view'));

if ($view == 'my') {
    $block1->paletteScript(6, 'edit', '../bookmarks/editbookmark.php?', 'false,true,false', lang_strings('edit'));
} 

$block1->closePaletteScript($comptListBookmarks, $listBookmarks->boo_id);
require_once('../themes/' . THEME . '/footer.php');

?>
