<?php // $Revision: 1.4.2.2 $
/* vim: set expandtab ts=4 sw=4 sts=4: */
/**
 * $Id: defines.lib.php,v 1.4.2.2 2007/05/03 04:08:00 luis Exp $
 *
 * Copyright (c) 2005 by the NetOffice developers
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
/**
 * DEFINES VARIABLES & CONSTANTS
 * Overview:
 *    NETOFFICE_USR_OS               (string) - the plateform (os) of the user
 *    NETOFFICE_USR_BROWSER_AGENT    (string) - the browser of the user
 *    NETOFFICE_USR_BROWSER_VER      (double) - the version of this browser
 */
// Determines platform (OS), browser and version of the user
// Based on a phpBuilder article:
//   see http://www.phpbuilder.net/columns/tim20000821.php
if (!defined('NETOFFICE_USR_OS')) {
    // loic1 - 2001/25/11: use the new globals arrays defined with
    // php 4.1+
    if (!empty($_SERVER['HTTP_USER_AGENT'])) {
        $HTTP_USER_AGENT = $_SERVER['HTTP_USER_AGENT'];
    } else if (!empty($HTTP_SERVER_VARS['HTTP_USER_AGENT'])) {
        $HTTP_USER_AGENT = $HTTP_SERVER_VARS['HTTP_USER_AGENT'];
    }
    // 1. Platform
    if (strstr($HTTP_USER_AGENT, 'Win')) {
        define('NETOFFICE_USR_OS', 'Win');
    } else if (strstr($HTTP_USER_AGENT, 'Mac')) {
        define('NETOFFICE_USR_OS', 'Mac');
    } else if (strstr($HTTP_USER_AGENT, 'Linux')) {
        define('NETOFFICE_USR_OS', 'Linux');
    } else if (strstr($HTTP_USER_AGENT, 'Unix')) {
        define('NETOFFICE_USR_OS', 'Unix');
    } else if (strstr($HTTP_USER_AGENT, 'OS/2')) {
        define('NETOFFICE_USR_OS', 'OS/2');
    } else {
        define('NETOFFICE_USR_OS', 'Other');
    }
    // 2. browser and version
    if (ereg('MSIE ([0-9].[0-9]{1,2})', $HTTP_USER_AGENT, $log_version)) {
        define('NETOFFICE_USR_BROWSER_VER', $log_version[1]);
        define('NETOFFICE_USR_BROWSER_AGENT', 'IE');
    } else if (ereg('Opera(/| )([0-9].[0-9]{1,2})', $HTTP_USER_AGENT, $log_version)) {
        define('NETOFFICE_USR_BROWSER_VER', $log_version[2]);
        define('NETOFFICE_USR_BROWSER_AGENT', 'OPERA');
    } else if (ereg('OmniWeb/([0-9].[0-9]{1,2})', $HTTP_USER_AGENT, $log_version)) {
        define('NETOFFICE_USR_BROWSER_VER', $log_version[1]);
        define('NETOFFICE_USR_BROWSER_AGENT', 'OMNIWEB');
    } else if (ereg('Mozilla/([0-9].[0-9]{1,2})', $HTTP_USER_AGENT, $log_version)) {
        define('NETOFFICE_USR_BROWSER_VER', $log_version[1]);
        define('NETOFFICE_USR_BROWSER_AGENT', 'MOZILLA');
    } else if (ereg('Konqueror/([0-9].[0-9]{1,2})', $HTTP_USER_AGENT, $log_version)) {
        define('NETOFFICE_USR_BROWSER_VER', $log_version[1]);
        define('NETOFFICE_USR_BROWSER_AGENT', 'KONQUEROR');
    } else {
        define('NETOFFICE_USR_BROWSER_VER', 0);
        define('NETOFFICE_USR_BROWSER_AGENT', 'OTHER');
    }
}

// Defines for status
DEFINE("ST_CLIENT_COMPLETED", "0");
DEFINE("ST_COMPLETED", "1");
DEFINE("ST_NOT_STARTED", "2");
DEFINE("ST_OPEN", "3");
DEFINE("ST_SUSPENDED", "4");

// Defines for profile
DEFINE("PF_ADMINISTRATOR", "0");
DEFINE("PF_PROJECT_MANAGER", "1");
DEFINE("PF_USER", "2");
DEFINE("PF_CLIENT_USER", "3");
DEFINE("PF_DISABLED", "4");
DEFINE("PF_PROJECT_MANAGER_ADMINISTRATOR", "5");
DEFINE("PF_HR_MANAGER", "6");
DEFINE("PF_DELETED", "9");

// Defines for priority
DEFINE("PR_NONE", "0");
DEFINE("PR_VERY_LOW", "1");
DEFINE("PR_LOW", "2");
DEFINE("PR_MEDIUM", "3");
DEFINE("PR_HIGH", "4");
DEFINE("PR_VERY_HIGH", "5");

// Defines for publish status
DEFINE("PB_YES", "0");
DEFINE("PB_NO", "1");

// Defines for file status
DEFINE("FS_APPROVED", "0");
DEFINE("FS_APPROVED_WITH_CHANGES", "1");
DEFINE("FS_NEEDS_APPROVAL", "2");
DEFINE("FS_NO_APPROVALS_NEEDED", "3");
DEFINE("FS_NOT_APPROVED", "4");

// Defines for phase status
DEFINE("PS_NOT_STARTED", "0");
DEFINE("PS_OPEN", "1");
DEFINE("PS_COMPLETE", "2");
DEFINE("PS_SUSPENDED", "3");

// Defines for request status
DEFINE("RQ_NEW", "0");
DEFINE("RQ_OPEN", "1");
DEFINE("RQ_COMPLETE", "2");

// Defines for project type
DEFINE("PT_INTERNAL_PROJECT", "0");
DEFINE("PT_EXTERNAL_PROJECT", "1");

// Defines for fixed duration status
DEFINE("FD_YES", "0");
DEFINE("FD_NO", "1");

// Defines for milestone status
DEFINE("MS_YES", "0");
DEFINE("MS_NO", "1");

// Defines for task group status
DEFINE("TG_YES", "0");
DEFINE("TG_NO", "1");

// Defines for person evaluation status
DEFINE("PE_SUBMITTED", "0");
DEFINE("PE_OPEN", "1");

// Defines for work hours type
DEFINE("WT_PROJECT", "0");
DEFINE("WT_OTHERS", "1");
DEFINE("WT_SALES", "100");
DEFINE("WT_LEAVE", "101");

// Defines for timesheet status
DEFINE("TS_OPEN", "0");
DEFINE("TS_SUBMITTED", "1");
DEFINE("TS_APPROVED", "2");
DEFINE("TS_REJECTED", "3");

// Defines for day type
DEFINE("DT_WEEKEND", "0");
DEFINE("DT_STATUTORY_HOLIDAY", "1");
DEFINE("DT_MAKEUP_HOLIDAY", "2");
DEFINE("DT_WORKDAY", "3");

// Defines for billing flag
DEFINE("BF_YES", "0");
DEFINE("BF_NO", "1");

// Defines for action type
DEFINE("AT_TIMESHEET", "0");
DEFINE("AT_LEAVE", "1");

// Defines for layout type
DEFINE("LT_LONGLIST", "1");
DEFINE("LT_TWOPAGES", "0");

// Defines for leave type
DEFINE("LV_ANNUAL", 10100);
DEFINE("LV_SICK", 10101);
DEFINE("LV_ABSENCE", 10102);
DEFINE("LV_BANKHOLIDAY", 10103);
DEFINE("LV_MOURNING", 10104);
DEFINE("LV_HONEYMOON", 10105);
DEFINE("LV_MATERNITY", 10106);

// Defines for work type
DEFINE("WT_NONSPECIFIC_TASK", "0");
DEFINE("WT_SPECIFIC_TASK", "1");
DEFINE("WT_SPECIFIC_MEETING", "2");
?>
