<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: notification.class.php,v 1.9 2006/09/13 07:03:07 luis Exp $
 * 
 * Copyright (c) 2003 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

require_once('../includes/phpmailer/class.phpmailer.php');

class notification extends phpmailer {
    function notification()
    {
        global $strings, $root, $notificationMethod, $setCharset;

        $this->Mailer = $notificationMethod;
        $this->PluginDir = '../includes/phpmailer/';
        // Sets the CharSet of the message
        $this->CharSet = $setCharset;

        if ($this->Mailer == 'smtp') {
            $this->Host = SMTPSERVER;
            $this->Username = SMTPLOGIN;
            $this->Password = SMTPPASSWORD;
        }

        $this->footer = "--\n" . lang_strings('noti_foot1') . "\n\n" . lang_strings('noti_foot2');
        $this->To = array();
    }

    function getUserinfo($idUser, $type)
    {
        $tmpquery = "WHERE mem.id = '$idUser'";
        $detailUser = new request();
        $detailUser->openMembers($tmpquery);

        if ($type == "from") {
            $this->From = $detailUser->mem_email_work[0];
            $this->FromName = $detailUser->mem_name[0];
            $this->signature = $detailUser->mem_name[0] . "\n";

            if ($detailUser->mem_title[0] == '') {
                $this->signature .= $detailUser->mem_org_name[0] . "\n";
            } else {
                $this->signature .= $detailUser->mem_title[0] . ", " . $detailUser->mem_org_name[0] . "\n";
            }

            if ($detailUser->mem_phone_work[0] != "") {
                $this->signature .= lang_strings("work_phone") . " : " . $detailUser->mem_phone_work[0] . "\n";
            }

            if ($detailUser->mem_mobile[0] != "") {
                $this->signature .= lang_strings("mobile_phone") . " : " . $detailUser->mem_mobile[0] . "\n";
            }

            if ($detailUser->mem_fax[0] != "") {
                $this->signature .= lang_strings("fax") . " : " . $detailUser->mem_fax[0] . "\n";
            }
        }

        if ($type == 'to') {
            $this->AddAddress($detailUser->mem_email_work[0], $detailUser->mem_name[0]);
            $this->To[] = $detailUser->mem_name[0];
        }
    }

    function openBody()
    {
        $this->Body = "<body>\n";
        $this->AltBody = "";

        if (count($this->To) > 0) {
            $this->Body .= lang_strings("dear");
            $this->AltBody .= lang_strings("dear");

            foreach ($this->To as $usr) {
                $this->Body .= " $usr,";
                $this->AltBody .= " $usr,";
            }

            $this->Body .= "<br><br>\n";
            $this->AltBody .= "\n\n";
        }

        $this->Body .= $this->partMessage . "<br><br>\n";
        $this->AltBody .= $this->partMessage . "\n\n";
    }

    function note($url)
    {
        global $strings;

        $this->Body .= "<p>" . lang_strings("noti_moreinfo") . "<br><a href=\"$url\">" . lang_strings("here") . "</a></p>\n";
        $this->AltBody .= "\n" . lang_strings("noti_moreinfo") . "\n$url\n\n";
    }

    function heading($title)
    {
        $this->Body .= "<b>" . $title . "</b><br>\n";
        $this->AltBody .= $title . "\n";
    }

    /**
     * Start a table to display sheet/form
     * 
     * @see block::contentRow()
     * @access public 
     */
    function openContent()
    {
        $this->Body .= "<table width=\"100%\" cellspacing=\"0\" cellpadding=\"0\">\n";
    } 

    /**
     * Display a table line in sheet/form
     * 
     * @param string $left Text in left cell
     * @param string $right Text in right cell
     * @access public 
     */
    function contentRow($left, $right)
    {
        if ($left != "") {
            $this->Body .= "<tr><td valign=\"top\" align=\"right\" width=\"27%\">" . $left . " :</td><td>&nbsp;" . $right . "</td></tr>\n";
            $this->AltBody .= sprintf("%40s : %s\n", $left, $right);
        } else {
            $this->Body .= "<tr><td valign=\"top\" align=\"right\" width=\"27%\">&nbsp;</td><td>&nbsp;" . $right . "</td></tr>\n";
            $this->AltBody .= sprintf("%40s   %s\n", "", $right);
        } 
    }

    function contentTitle($title)
    {
        $this->Body .= "<tr><th colspan=\"2\">" . $title . "</th></tr>\n";
        $this->AltBody .= $title . "\n";
    }

    function closeContent()
    {
        $this->Body .= "</table>\n<hr/>\n";
        $this->AltBody .= "\n";
    }

    function closeBody()
    {
        global $strings, $root;

        $this->Body .= "<br>\n" . nl2br($this->signature) . "<br>\n" . nl2br($this->footer) . "<br><a href=\"$root/\">" . lang_strings("here") . "</a>\n</body>";
        $this->AltBody .= "\n" . $this->signature . "\n" . $this->footer . "\n$root/";
    }

    function openResults()
    {
        $this->Body .= "<table cellpadding=\"0\" cellspacing=\"0\" border=\"1\">\n";
        $this->AltBody .= "\n";
    }

    function closeResults()
    {
        $this->Body .= "</table>\n</hr>\n";
        $this->AltBody .= "\n";
    }

    function noresults()
    {
        $this->Body .= "<table cellspacing=\"0\" border=\"1\" cellpadding=\"2\">\n<tr><td colspan=\"4\">" . lang_strings("no_items") . "</td></tr>\n</table>\n<hr/>\n";
        $this->AltBody .= lang_strings("no_items") . "\n";
    }

    function openRow()
    {
        $this->Body .= "<tr>";
    }

    function cellRow($content = null)
    {
        $this->Body .= "<td>$content</td>";
        $this->AltBody .= $content . "\t";
    }

    function closeRow()
    {
        $this->Body .= "</tr>\n";
        $this->AltBody .= "\n";
    }
}

?>
