<?php // $Revision: 1.16.2.2 $
/* vim: set expandtab ts=4 sw=4 sts=4: */
/**
 * $Id: setup.php,v 1.16.2.2 2007/11/22 01:17:18 luiswang Exp $
 * 
 * Copyright (c) 2007 by the netOffice Dwins developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

require_once('../languages/help_en.php');
$version = 'Dwins-1.3';
$dateheure = date("Y-m-d H:i");
$dateheures = date("Y-m-d H:i:s");
$step = $_REQUEST['step'];

if ($step == "") {
    $step = "1";
}

$dbTypList = array("pg","my");
$checkList = array(
    "/administration/systeminfo.php" => "File",
    "/administration/updatesettings.php" => "File",
    "/installation/db_var.inc.php" => "File",
    "/installation/setup_db.php" => "File",
    "/installation/setup_settings.php" => "File",
    "/includes/library.php" => "File",
    "/includes/request.class.php" => "File",
    "/includes/settings.php" => "File",
    "/includes/jpgraph" => "Directory",
    "/files" => "Directory",
    "/logos_clients" => "Directory");
$setTitle = "netOffice Dwins Web-Based Installer";
define('THEME', 'sitespring');
$blank = "true";
require_once("../themes/" . THEME . "/block.class.php");
require_once("../themes/" . THEME . "/header.php");
$block1 = new block();
$block1->form = "setup";
$block1->openForm("../installation/setup.php?#" . $block1->form . "Anchor");

switch ($step) {
    case "1":
        $block1->heading("License");
        $block1->openContent();
        $block1->contentTitle("&nbsp;");
        $copying = file_get_contents("../docs/copying.txt");
        $block1->contentRow("", "<pre>$copying</pre>");
        echo "<input type=\"hidden\" name=\"step\" value=\"2\">";
        $submitName = "check file permissions";
        break;
    case "2":
        $error = false;

        foreach ($checkList as $fileChk => $fileTyp) {
            if (is_writable(".." . $fileChk) == false) {
                $error = true;
                break;
            }
        }

        if ($error) {
            $block1->headingError("Errors found!");
            $block1->contentError("In order for the package to work correctly, the following files must be writeable by the server. Please change the permission setting for these files. (i.e. 'chmod 666 file_name' and 'chmod 777 dir_name' on a UNIX/LINUX server, or check the properties of the file and make sure the read-only flag is not set on a Windows server)");
            echo "<input type=\"hidden\" name=\"step\" value=\"2\">";
            $submitName = "Reload";
        } else {
            echo "<input type=\"hidden\" name=\"step\" value=\"3\">";
            $submitName = "Settings";
        }

        $block1->heading("Check File Permissions");
        $block1->openContent();
        $block1->contentTitle("&nbsp;");

        foreach($checkList as $fileChk => $fileTyp) {
            if (is_writable(".." . $fileChk)) {
                $block1->contentRow("<img src=\"ok.gif\"/>", "$fileTyp $fileChk is writable.", "false", "");
            } else {
                $block1->contentRow("<img src=\"wrong.gif\"/>", "<b>$fileTyp $fileChk is NOT writable.</b>", "false", "");
            }
        }

        if (!$error) {
            $block1->contentRow("", "");
            $block1->contentRow("", "No errors detected.");
        }

        break;
    case "3":
        $connexion = $_REQUEST['connexion'];
        $action = $_REQUEST['action'];
        $updatechecker = $_REQUEST['updatechecker'];
        $installationType = $_REQUEST['installationType'];
        $dbtype = $_REQUEST['dbtype'];
        $dbserver = $_REQUEST['dbserver'];
        $dblogin = $_REQUEST['dblogin'];
        $dbpasswd = $_REQUEST['dbpasswd'];
        $dbname = $_REQUEST['dbname'];
        $tbprefix = $_REQUEST['tbprefix'];
        $mkdirMethod = $_REQUEST['mkdirMethod'];
        $notifications = $_REQUEST['notifications'];
        $ftpserver = $_REQUEST['ftpserver'];
        $ftplogin = $_REQUEST['ftplogin'];
        $ftppassword = $_REQUEST['ftppassword'];
        $ftpRoot = $_REQUEST['ftpRoot'];
        $forcedlogin = $_REQUEST['forcedlogin'];
        $langdefault = $_REQUEST['langdefault'];
        $root = $_REQUEST['root'];
        $loginMethod = $_REQUEST['loginMethod'];
        $adminLogin = $_REQUEST['adminLogin'];
        $adminPwd = $_REQUEST['adminPwd'];
        $adminPwa = $_REQUEST['adminPwa'];
        $cryptKey = get_crypt_key();
        $basedir = preg_replace('/installation$/i', '', str_replace('\\', '/', dirname(__FILE__)), 1);

        if (substr($root, -1) == "/") {
            $root = substr($root, 0, -1);
        }

        if (substr($ftpRoot, -1) == "/") {
            $ftpRoot = substr($ftpRoot, 0, -1);
        }

        if ($action == "save") {
            if ($dbserver == '') {
                $error = 'Must be insert the database Server';
            } else if ($dblogin == '') {
                $error = 'Must be insert the database Login';
            } else if ($dbname == '') {
                $error = 'Must be insert the database Name';
            } else if ($tbprefix == '') {
                $error = 'Must be insert the Table prefix';
            } else if ($root == '') {
                $error = 'Must be insert the Root path';
            } else if ($adminLogin == '') {
                $error = 'Must be insert the Admin login name';
            } else if ($adminPwd == '') {
                $error = 'Must be insert the Admin password';
            } else if ($adminPwd != $adminPwa) {
                $error = 'The two passwords you entered did not match';
            }

            if ($installationType == "offline") {
                $updatechecker = "false";
            }
        }

        if ($error != '') {
            $block1->headingError("Errors found!");
            $block1->contentError($error);
            $action = "";
        }

        if ($action != "save") {
            $block1->heading("Settings");
            $block1->openContent();
            $block1->contentTitle("&nbsp;");

            if ($connexion == "off") {
                echo "<input value=\"false\" name=\"updatechecker\" type=\"hidden\">";
            } else if (@join('', file("http://netofficedwins.sourceforge.net/version.txt"))) {
                echo "<input value=\"true\" name=\"updatechecker\" type=\"hidden\">";
            } else {
                echo "<input value=\"false\" name=\"updatechecker\" type=\"hidden\">";
            }

            if ($connexion == "off") {
                $installCheckOffline = "checked";
            } else {
                $installCheckOnline = "checked";
            }

            $block1->contentRow("* Installation type", "<input type=\"radio\" name=\"installationType\" value=\"offline\" $installCheckOffline> Offline (firewall/intranet, no update checker)&nbsp;<input type=\"radio\" name=\"installationType\" value=\"online\" $installCheckOnline> Online");
            $block1->contentRow("* Database type", "<input type=\"radio\" name=\"dbtype\" value=\"pg\" checked> PostgreSQL&nbsp;&nbsp;<input type=\"radio\" name=\"dbtype\" value=\"my\"> MySQL");
            $block1->contentRow("* Database server", "<input size=\"44\" value=\"$dbserver\" style=\"width: 200px\" name=\"dbserver\" maxlength=\"100\" type=\"text\">");
            $block1->contentRow("* Database login", "<input size=\"44\" value=\"$dblogin\" style=\"width: 200px\" name=\"dblogin\" maxlength=\"100\" type=\"text\">");
            $block1->contentRow("Database password", "<input size=\"44\" value=\"$dbpasswd\" style=\"width: 200px\" name=\"dbpasswd\" maxlength=\"100\" type=\"password\">");
            $block1->contentRow("* Database name", "<input size=\"44\" value=\"$dbname\" style=\"width: 200px\" name=\"dbname\" maxlength=\"100\" type=\"text\">");
            $block1->contentRow("* Table prefix [<a href=\"javascript:void(0);\" onmouseover=\"return overlib('" . addslashes($help["setup_myprefix"]) . "',ABOVE,SNAPX,550,BGCOLOR,'#5B7F93',FGCOLOR,'#C4D3DB');\" onmouseout=\"return nd();\">Help</a>]", "<input size=\"44\" value=\"$tbprefix\" style=\"width: 200px\" name=\"tbprefix\" maxlength=\"100\" type=\"text\">");
            $safemodeTest = ini_get("safe_mode");

            if ($safemodeTest == "1") {
                $checked2_a = "checked"; //true
                $safemode = "on";
            } else {
                $checked1_a = "checked"; //false
                $safemode = "off";
            }

            $notificationsTest = function_exists('mail');

            if ($notificationsTest == "true") {
                $checked2_b = "checked"; //false
                $gdlibrary = "on";
            } else {
                $checked1_b = "checked"; //true
                $gdlibrary = "off";
            }

            $block1->contentRow("* Create folder method [<a href=\"javascript:void(0);\" onmouseover=\"return overlib('" . addslashes($help["setup_mkdirMethod"]) . "',SNAPX,550,BGCOLOR,'#5B7F93',FGCOLOR,'#C4D3DB');\" onmouseout=\"return nd();\">Help</a>]", "<table cellpadding=0 cellspacing=0><tr><td valign=top><input type=\"radio\" name=\"mkdirMethod\" value=\"PHP\" $checked1_a> PHP&nbsp;<input type=\"radio\" name=\"mkdirMethod\" value=\"FTP\" $checked2_a> FTP<br>[Safe-mode $safemode]</td><td align=right>Ftp server <input size=\"44\" value=\"$ftpserver\" style=\"width: 200px\" name=\"ftpserver\" maxlength=\"100\" type=\"text\"><br>
Ftp login <input size=\"44\" value=\"$ftplogin\" style=\"width: 200px\" name=\"ftplogin\" maxlength=\"100\" type=\"text\"><br>
Ftp password <input size=\"44\" value=\"$ftppassword\" style=\"width: 200px\" name=\"ftppassword\" maxlength=\"100\" type=\"password\"><br>
Ftp root <input size=\"44\" value=\"$ftpRoot\" style=\"width: 200px\" name=\"ftpRoot\" maxlength=\"100\" type=\"text\"></td></tr></table>");
            $block1->contentRow("* Notifications [<a href=\"javascript:void(0);\" onmouseover=\"return overlib('" . addslashes($help["setup_notifications"]) . "',SNAPX,550,BGCOLOR,'#5B7F93',FGCOLOR,'#C4D3DB');\" onmouseout=\"return nd();\">Help</a>]", "<table cellpadding=0 cellspacing=0><tr><td valign=top><input type=\"radio\" name=\"notifications\" value=\"false\" $checked1_b> False</td><td><input type=\"radio\" name=\"notifications\" value=\"true\" $checked2_b> True</td></tr><tr><td></td><td>[Mail $gdlibrary]</td></tr></table>");
            $block1->contentRow("* Forced login [<a href=\"javascript:void(0);\" onmouseover=\"return overlib('" . addslashes($help["setup_forcedlogin"]) . "',SNAPX,550,BGCOLOR,'#5B7F93',FGCOLOR,'#C4D3DB');\" onmouseout=\"return nd();\">Help</a>]", "<input type=\"radio\" name=\"forcedlogin\" value=\"false\" checked> False&nbsp;<input type=\"radio\" name=\"forcedlogin\" value=\"true\"> True");
            $block1->contentRow("Default language [<a href=\"javascript:void(0);\" onmouseover=\"return overlib('" . addslashes($help["setup_langdefault"]) . "',SNAPX,550,BGCOLOR,'#5B7F93',FGCOLOR,'#C4D3DB');\" onmouseout=\"return nd();\">Help</a>]", "<select name=langdefault>
    <option value=\"\">Blank</option>
	<option value=az>Azerbaijani</option>
	<option value=pt-br>Brazilian Portuguese</option>
	<option value=bg>Bulgarian</option>
	<option value=ca>Catalan</option>
	<option value=zh>Chinese simplified</option>
	<option value=zh-tw>Chinese traditional</option>
	<option value=cs-iso>Czech (iso)</option>
	<option value=cs-win1250>Czech (win1250)</option>
	<option value=da>Danish</option>
	<option value=nl>Dutch</option>
	<option value=en>English</option>
	<option value=et>Estonian</option>
	<option value=fr>French</option>
	<option value=de>German</option>
	<option value=hu>Hungarian</option>
	<option value=is>Icelandic</option>
	<option value=in>Indonesian</option>
	<option value=it>Italian</option>
	<option value=ko>Korean</option>
	<option value=lv>Latvian</option>
	<option value=no>Norwegian</option>
	<option value=pl>Polish</option>
	<option value=pt>Portuguese</option>
	<option value=ro>Romanian</option>
	<option value=ru>Russian</option>
	<option value=sk-win1250>Slovak (win1250)</option>
	<option value=es>Spanish</option>
	<option value=sv>Swedish</option>
	<option value=tr>Turkish</option>
	<option value=uk>Ukrainian</option>
   </select>");
            $url = $_SERVER['SERVER_NAME'];

            if ($_SERVER['SERVER_PORT'] != 80 && $_SERVER['SERVER_PORT'] != 443) {
                $url .= ":" . $_SERVER['SERVER_PORT'];
            }

            if ($_SERVER['HTTPS'] == "on") {
                $protocol = "https://";
            } else {
                $protocol = "http://";
            }

            $root = $protocol . $url . dirname($_SERVER['PHP_SELF']);
            $root = str_replace("installation", "", $root);
            $block1->contentRow("* Root", "<input size=\"44\" value=\"$root\" style=\"width: 200px\" name=\"root\" maxlength=\"100\" type=\"text\">");
            $block1->contentRow("* Login method [<a href=\"javascript:void(0);\" onmouseover=\"return overlib('" . addslashes($help["setup_loginmethod"]) . "',SNAPX,550,BGCOLOR,'#5B7F93',FGCOLOR,'#C4D3DB');\" onmouseout=\"return nd();\">Help</a>]", "<input type=\"radio\" name=\"loginMethod\" value=\"PLAIN\"> Plain&nbsp;<input type=\"radio\" name=\"loginMethod\" value=\"MD5\"> Md5&nbsp;<input type=\"radio\" name=\"loginMethod\" value=\"CRYPT\" checked> Crypt");
            $block1->contentRow("* Admin login", "<input size=\"44\" value=\"$adminLogin\" style=\"width: 200px\" name=\"adminLogin\" maxlength=\"100\" type=\"text\">");
            $block1->contentRow("* Admin password", "<input size=\"44\" value=\"$adminPwd\" style=\"width: 200px\" name=\"adminPwd\" maxlength=\"100\" type=\"password\">");
            $block1->contentRow("* Confirm password", "<input size=\"44\" value=\"$adminPwa\" style=\"width: 200px\" name=\"adminPwa\" maxlength=\"100\" type=\"password\">");
            echo "<input type=\"hidden\" name=\"step\" value=\"3\">";
            echo "<input type=\"hidden\" name=\"action\" value=\"save\">";
            $submitName = "Save";
            break;
        }
    case "4":
        $error = false;
        $block1->heading("Save settings");
        $block1->openContent();
        $block1->contentTitle("&nbsp;");

        foreach ($checkList as $fileChk => $fileTyp) {
            if ($fileTyp == "File" && $fileChk != "/includes/settings.php") {
                $content = file_get_contents(".." . $fileChk . "." . $dbtype);

                if (write_file($content, ".." . $fileChk)) {
                    $block1->contentRow("<img src=\"ok.gif\"/>", "$fileTyp $fileChk copied.", "false", "");
                } else {
                    $block1->contentRow("<img src=\"wrong.gif\"/>", "<b>$fileTyp $fileChk DID NOT copy.</b>", "false", "");
                    $error = true;
                }
            }
        }

        if (!$error) {
            $htmlEntityCharset = version_compare(phpversion(), "5", ">=") == 1 ? 'UTF-8' : 'ISO-8859-1';
            require_once('./setup_settings.php');

            if (write_file($content, "../includes/settings.php")) {
                $block1->contentRow("<img src=\"ok.gif\"/>", "File /includes/settings.php created.", "false", "");
            } else {
                $block1->contentRow("<img src=\"wrong.gif\"/>", "<b>File /includes/settings.php DID NOT create.</b>", "false", "");
                $error = true;
            }
        }

        if (!$error) {
            if (version_compare(phpversion(), "5", ">=") == 1) {
                $dirCpy = "/includes/jpgraph-2.0beta";
            } else {
                $dirCpy = "/includes/jpgraph-1.19";
            }

            if (dircpy(".." . $dirCpy, "../includes/jpgraph")) {
                $block1->contentRow("<img src=\"ok.gif\"/>", "Files in /includes/jpgraph created.", "false", "");
            } else {
                $block1->contentRow("<img src=\"wrong.gif\"/>", "<b>Files in /includes/jpgraph DID NOT create.</b>", "false", "");
                $error = true;
            }
        }

        if (!$error) {
            $block1->contentRow("", "");
            $block1->contentRow("", "Configuration data has been saved successfully.");
            $submitName = "Check database";
            echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
            echo "<input type=\"hidden\" name=\"dbserver\" value=\"$dbserver\">";
            echo "<input type=\"hidden\" name=\"dblogin\" value=\"$dblogin\">";
            echo "<input type=\"hidden\" name=\"dbpasswd\" value=\"$dbpasswd\">";
            echo "<input type=\"hidden\" name=\"dbname\" value=\"$dbname\">";
            echo "<input type=\"hidden\" name=\"tbprefix\" value=\"$tbprefix\">";
            echo "<input type=\"hidden\" name=\"adminLogin\" value=\"$adminLogin\">";
            echo "<input type=\"hidden\" name=\"adminPwd\" value=\"$adminPwd\">";
            echo "<input type=\"hidden\" name=\"loginMethod\" value=\"$loginMethod\">";
            echo "<input type=\"hidden\" name=\"step\" value=\"5\">";
        } else {
            $submitName = "Restart from the beginning";
            echo "<input type=\"hidden\" name=\"step\" value=\"\">";
        }

        break;
    case "5":
        $root = $_REQUEST['root'];
        $dbserver = $_REQUEST['dbserver'];
        $dblogin = $_REQUEST['dblogin'];
        $dbpasswd = $_REQUEST['dbpasswd'];
        $dbname = $_REQUEST['dbname'];
        $tbprefix = $_REQUEST['tbprefix'];
        $adminLogin = $_REQUEST['adminLogin'];
        $adminPwd = $_REQUEST['adminPwd'];
        $loginMethod = $_REQUEST['loginMethod'];
        $block1->heading("Check database");
        $block1->openContent();
        $block1->contentTitle("&nbsp;");
        require_once("./setup_db.php");
        check_database();
        $block1->contentRow("", "");
        echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
        echo "<input type=\"hidden\" name=\"dbserver\" value=\"$dbserver\">";
        echo "<input type=\"hidden\" name=\"dblogin\" value=\"$dblogin\">";
        echo "<input type=\"hidden\" name=\"dbpasswd\" value=\"$dbpasswd\">";
        echo "<input type=\"hidden\" name=\"dbname\" value=\"$dbname\">";
        echo "<input type=\"hidden\" name=\"tbprefix\" value=\"$tbprefix\">";
        echo "<input type=\"hidden\" name=\"adminLogin\" value=\"$adminLogin\">";
        echo "<input type=\"hidden\" name=\"adminPwd\" value=\"$adminPwd\">";
        echo "<input type=\"hidden\" name=\"loginMethod\" value=\"$loginMethod\">";

        if ($error) {
            $block1->contentRow("", "Please check the database server and its configuration.");
            $submitName = "Reload";
            echo "<input type=\"hidden\" name=\"step\" value=\"5\">";
        } else {
            $block1->contentRow("", "No errors detected.");
            $block1->contentRow("<input value=\"dump\" name=\"dump\" type=\"checkbox\" checked>", "Dump SQLs", "false", "");
            $submitName = "Create tables";
            echo "<input type=\"hidden\" name=\"step\" value=\"6\">";
        }

        break;
    case "6":
        $dump = $_REQUEST['dump'];
        $root = $_REQUEST['root'];
        $dbserver = $_REQUEST['dbserver'];
        $dblogin = $_REQUEST['dblogin'];
        $dbpasswd = $_REQUEST['dbpasswd'];
        $dbname = $_REQUEST['dbname'];
        $tbprefix = $_REQUEST['tbprefix'];
        $adminLogin = $_REQUEST['adminLogin'];
        $adminPwdPlain = $_REQUEST['adminPwd'];
        $loginMethod = $_REQUEST['loginMethod'];
        $block1->heading("Create tables");
        $block1->openContent();
        $block1->contentTitle("&nbsp;");
        $error = false;
        // crypt admin and demo password
        $demoPwd = get_password("demo");
        $adminPwd = get_password($adminPwdPlain);
        require_once("./setup_db.php");
        create_tables();

        if ($error) {
            $submitName = "Check database again";
            echo "<input type=\"hidden\" name=\"step\" value=\"5\">";
            echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
            echo "<input type=\"hidden\" name=\"dbserver\" value=\"$dbserver\">";
            echo "<input type=\"hidden\" name=\"dblogin\" value=\"$dblogin\">";
            echo "<input type=\"hidden\" name=\"dbpasswd\" value=\"$dbpasswd\">";
            echo "<input type=\"hidden\" name=\"dbname\" value=\"$dbname\">";
            echo "<input type=\"hidden\" name=\"tbprefix\" value=\"$tbprefix\">";
            echo "<input type=\"hidden\" name=\"adminLogin\" value=\"$adminLogin\">";
            echo "<input type=\"hidden\" name=\"adminPwd\" value=\"$adminPwdPlain\">";
            echo "<input type=\"hidden\" name=\"loginMethod\" value=\"$loginMethod\">";
        } else {
            $block1->contentRow("", "");
            $block1->contentRow("", "Database tables created.");
            $submitName = "Finish";
            echo "<input type=\"hidden\" name=\"root\" value=\"$root\">";
            echo "<input type=\"hidden\" name=\"step\" value=\"7\">";
        }

        break;
    case "7":
        foreach ($dbTypList as $dbTyp) {
            foreach ($checkList as $fileChk => $fileTyp) {
                $pathName = ".." . $fileChk . "." . $dbTyp;

                if ($fileTyp == "File" && $fileChk != "/includes/settings.php" && file_exists($pathName)) {
                    @unlink($pathName);
                }
            }
        }

        rmdirr('../includes/jpgraph-1.19');
        rmdirr('../includes/jpgraph-2.0beta');
        $root = $_REQUEST['root'];
        $block1->heading("Installation Complete");
        $block1->openContent();
        $block1->contentTitle("&nbsp;");
        $block1->contentRow("Your site", $block1->buildLink($root, "Click HERE to see the home page of your site.", "in"));
        $block1->contentRow("Support", $block1->buildLink("http://netofficedwins.sourceforge.net", "Visit netOffice Dwins", "in"));
        break;
}

if ($step != "7") {
    $block1->contentRow("", "<input type=\"SUBMIT\" name=\"save\" value=\"$submitName\" $saveDisabled>");
}

$block1->closeContent();
$block1->closeForm();
$footerDev = false;
require_once("../themes/" . THEME . "/footer.php");

// Write file
function write_file($content, $dest)
{
    $fp = @fopen($dest, 'wb+');
    $fw = fwrite($fp, $content);
    fclose($fp);
    return $fw;
}

// Generates the unique [en|de]cryption key for your installation
function get_crypt_key()
{
  srand((double)microtime()*1000000);
  return(md5(uniqid(rand(),1)));
}

// return a password using the globally specified method
function get_password($newPassword)
{
    global $loginMethod;

    switch ($loginMethod) {
        case "MD5":
            return md5($newPassword);
        case "CRYPT":
            $salt = substr($newPassword, 0, 2);
            return crypt($newPassword, $salt);
        case "PLAIN":
            return $newPassword;
        default:
            return $newPassword;
    }
}

// copy a directory and all subdirectories and files (recursive)
// void dircpy( str 'source directory', str 'destination directory' [, bool 'overwrite existing files'] )
function dircpy($source, $dest, $overwrite = false){
    if ($handle = opendir($source)) { // if the folder exploration is sucsessful, continue
        while (false !== ($file = readdir($handle))) { // as long as storing the next file to $file is successful, continue
            if ($file != '.' && $file != '..') {
                $path = $source . '/' . $file;

                if (is_file($path)) {
                    if (!is_file($dest . '/' . $file) || $overwrite)
                        if (!@copy($path, $dest . '/' . $file)) {
                            return false;
                        }
                } elseif (is_dir($path)) {
                    if (!is_dir($dest . '/' . $file))
                        mkdir($dest . '/' . $file); // make subdirectory before subdirectory is copied

                    dircpy($path, $dest . '/' . $file, $overwrite); //recurse!
                }
            }
       }

       closedir($handle);
    }

    return true;
} // end of dircpy()

/**
 * Delete a file, or a folder and its contents
 *
 * @author      Aidan Lister <aidan@php.net>
 * @version     1.0.2
 * @param       string   $dirname    Directory to delete
 * @return      bool     Returns TRUE on success, FALSE on failure
 */
function rmdirr($dirname)
{
    // Sanity check
    if (!file_exists($dirname)) {
        return false;
    }
 
    // Simple delete for a file
    if (is_file($dirname)) {
        usleep(10);
        return unlink($dirname);
    }
 
    // Loop through the folder
    $dir = dir($dirname);
    while (false !== $entry = $dir->read()) {
        // Skip pointers
        if ($entry == '.' || $entry == '..') {
            continue;
        }
 
        // Recurse
        rmdirr("$dirname/$entry");
    }
 
    // Clean up
    $dir->close();
    usleep(10);
    return rmdir($dirname);
}

?>
