<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */
/**
 * $Id: upgrade_db2.5.3-pl1.php,v 1.9 2006/07/28 07:02:36 luis Exp $
 * 
 * Copyright (c) 2004 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

require_once('./db_var.inc.php');

// ****************************************************************************
$SQL[] = <<<STAMP
DROP TABLE IF EXISTS {$tablePrefix}assignments
, {$tablePrefix}attendants
, {$tablePrefix}calendar
, {$tablePrefix}files
, {$tablePrefix}logs
, {$tablePrefix}meetings
, {$tablePrefix}meetings_attachment
, {$tablePrefix}meetings_time
, {$tablePrefix}members
, {$tablePrefix}notes
, {$tablePrefix}notifications
, {$tablePrefix}organizations
, {$tablePrefix}posts
, {$tablePrefix}projects
, {$tablePrefix}reports
, {$tablePrefix}sorting
, {$tablePrefix}tasks
, {$tablePrefix}tasks_predecessor
, {$tablePrefix}tasks_resource
, {$tablePrefix}tasks_time
, {$tablePrefix}teams
, {$tablePrefix}topics
, {$tablePrefix}phases
, {$tablePrefix}support_posts
, {$tablePrefix}support_requests
, {$tablePrefix}updates
, {$tablePrefix}bookmarks
, {$tablePrefix}bookmarks_categories
, {$tablePrefix}services
, {$tablePrefix}sessions
, {$tablePrefix}person_evaluations
, {$tablePrefix}work_hours
, {$tablePrefix}timesheet
, {$tablePrefix}workcalendar
, {$tablePrefix}actions
, {$tablePrefix}leaves
, {$tablePrefix}leave_requests
, {$tablePrefix}timetickets
, {$tablePrefix}timetickets_detail
STAMP;

// ****************************************************************************
// create new tables
$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}assignments (
  id $db_mediumint_auto,
  task $db_mediumint,
  owner $db_mediumint,
  assigned_to $db_mediumint,
  comments $db_text,
  assigned $db_varchar19,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}attendants (
  id $db_mediumint_auto,
  project $db_mediumint,
  meeting $db_mediumint,
  member $db_mediumint,
  published $db_char1,
  attended $db_char1,
  authorized $db_char1,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}calendar (
  id $db_mediumint_auto,
  project $db_mediumint,
  owner $db_mediumint,
  subject $db_varchar155,
  description $db_text,
  shortname $db_varchar155,
  date_start $db_varchar10,
  date_end $db_varchar10,
  time_start $db_varchar155,
  time_end $db_varchar155,
  reminder $db_char1default0,
  recurring $db_char1,
  recur_day $db_char1,
  reminder_time1 $db_mediumint,
  reminder_time2 $db_mediumint,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}files (
  id $db_mediumint_auto,
  owner $db_mediumint,
  project $db_mediumint,
  task $db_mediumint,
  name $db_varchar255,
  date $db_varchar16,
  size $db_varchar155,
  extension $db_varchar155,
  comments $db_varchar255,
  comments_approval $db_varchar255,
  approver $db_mediumint,
  date_approval $db_varchar16,
  upload $db_varchar16,
  published $db_char1,
  status $db_mediumint,
  vc_status $db_varchar255a,
  vc_version $db_varchar255b,
  vc_parent $db_int,
  phase $db_mediumint,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}logs (
  id $db_mediumint_auto,
  login $db_varchar155,
  password $db_varchar155,
  ip $db_varchar155,
  session $db_varchar155,
  compt $db_mediumint,
  last_visite $db_varchar16,
  connected $db_varchar255,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}meetings (
  id $db_mediumint_auto,
  project $db_mediumint,
  priority $db_mediumint,
  status $db_mediumint,
  name $db_varchar155,
  agenda $db_text,
  location $db_text,
  minutes $db_text,
  chairman $db_mediumint,
  recorder $db_mediumint,
  date $db_varchar10,
  start_time $db_varchar5,
  end_time $db_varchar5,
  reminder $db_char1default0,
  reminder_time1 $db_mediumint,
  reminder_time2 $db_mediumint,
  created $db_varchar19b,
  modified $db_varchar19,
  published $db_char1,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}meetings_attachment (
  id $db_mediumint_auto,
  owner $db_mediumint,
  project $db_mediumint,
  meeting $db_mediumint,
  name $db_varchar255,
  date $db_varchar16,
  size $db_varchar155,
  extension $db_varchar155,
  comments $db_varchar255,
  comments_approval $db_varchar255,
  approver $db_mediumint,
  date_approval $db_varchar16,
  upload $db_varchar16,
  published $db_char1,
  status $db_mediumint,
  vc_status $db_varchar255a,
  vc_version $db_varchar255b,
  vc_parent $db_int,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}meetings_time (
  id $db_mediumint_auto,
  project $db_mediumint,
  meeting $db_mediumint,
  owner $db_mediumint,
  date $db_varchar16,
  hours $db_float,
  comments $db_text,
  created $db_varchar19b,
  modified $db_varchar19,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}members (
  id $db_mediumint_auto,
  organization $db_mediumint,
  login $db_varchar155,
  password $db_varchar155,
  name $db_varchar155,
  title $db_varchar155,
  email_work $db_varchar155,
  email_home $db_varchar155,
  phone_work $db_varchar155,
  phone_home $db_varchar155,
  mobile $db_varchar155,
  fax $db_varchar155,
  comments $db_text,
  profil $db_char1,
  created $db_varchar19b,
  logout_time $db_mediumint,
  last_page $db_varchar255,
  timezone $db_char3,
  location $db_smallint,
  supervisor $db_mediumint,
  agent $db_mediumint,
  theme $db_varchar155,
  layout $db_smallint,
  timeticket $db_mediumint,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}notes (
  id $db_mediumint_auto,
  project $db_mediumint,
  owner $db_mediumint,
  topic $db_varchar255,
  subject $db_varchar155,
  description $db_text,
  date $db_varchar10,
  published $db_char1,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}notifications (
  id $db_mediumint_auto,
  member $db_mediumint,
  taskAssignment $db_char1default0,
  removeProjectTeam $db_char1default0,
  addProjectTeam $db_char1default0,
  newTopic $db_char1default0,
  newPost $db_char1default0,
  statusTaskChange $db_char1default0,
  priorityTaskChange $db_char1default0,
  duedateTaskChange $db_char1default0,
  clientAddTask $db_char1default0,
  meetingAssignment $db_char1default0,
  statusMeetingChange $db_char1default0,
  priorityMeetingChange $db_char1default0,
  locationMeetingChange $db_char1default0,
  timeMeetingChange $db_char1default0,
  checkLogTime $db_char1default0,
  toDoList $db_char1default0,
  timesheetApproved $db_char1default0,
  timesheetRejected $db_char1default0,
  leaveApproved $db_char1default0,
  leaveRejected $db_char1default0,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}organizations (
  id $db_mediumint_auto,
  name $db_varchar255,
  address1 $db_varchar255,
  address2 $db_varchar255,
  zip_code $db_varchar155,
  city $db_varchar155,
  country $db_varchar155,
  phone $db_varchar155,
  fax $db_varchar155,
  url $db_varchar255,
  email $db_varchar155,
  comments $db_text,
  created $db_varchar19b,
  extension_logo $db_char3,
  owner $db_mediumint,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}posts (
  id $db_mediumint_auto,
  topic $db_mediumint,
  member $db_mediumint,
  created $db_varchar19b,
  message $db_text,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}projects (
  id $db_mediumint_auto,
  organization $db_mediumint,
  owner $db_mediumint,
  priority $db_mediumint,
  status $db_mediumint,
  name $db_varchar155,
  description $db_text,
  url_dev $db_varchar255,
  url_prod $db_varchar255,
  created $db_varchar19b,
  modified $db_varchar19,
  published $db_char1,
  upload_max $db_varchar155,
  phase_set $db_mediumint,
  type $db_char1default0,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}reports (
  id $db_mediumint_auto,
  owner $db_mediumint,
  name $db_varchar155,
  projects $db_varchar255,
  members $db_varchar255,
  priorities $db_varchar255,
  status $db_varchar255,
  date_due_start $db_varchar10,
  date_due_end $db_varchar10,
  created $db_varchar19b,
  date_complete_start $db_varchar10,
  date_complete_end $db_varchar10,
  clients $db_varchar255,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}sorting (
  id $db_mediumint_auto,
  member $db_mediumint,
  home_projects $db_varchar155,
  home_tasks $db_varchar155,
  home_discussions $db_varchar155,
  home_reports $db_varchar155,
  projects $db_varchar155,
  organizations $db_varchar155,
  project_tasks $db_varchar155,
  discussions $db_varchar155,
  project_discussions $db_varchar155,
  users $db_varchar155,
  team $db_varchar155,
  tasks $db_varchar155,
  report_tasks $db_varchar155,
  assignment $db_varchar155,
  reports $db_varchar155,
  files $db_varchar155,
  organization_projects $db_varchar155,
  notes $db_varchar155,
  calendar $db_varchar155,
  phases $db_varchar155,
  support_requests $db_varchar155,
  bookmarks $db_varchar155,
  tasks_time $db_varchar155,
  meetings $db_varchar155,
  meetings_attachment $db_varchar155,
  meetings_time $db_varchar155,
  predecessors $db_varchar155,
  calendar_view $db_varchar155,
  tasks_resource $db_varchar155,
  timesheets $db_varchar155,
  leaves $db_varchar155,
  timetickets $db_varchar155,
  subtasks $db_varchar155,
  person_evaluations $db_varchar155,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}tasks (
  id $db_mediumint_auto,
  project $db_mediumint,
  priority $db_mediumint,
  status $db_mediumint,
  owner $db_mediumint,
  assigned_to $db_mediumint,
  name $db_varchar155,
  description $db_text,
  start_date $db_varchar10,
  due_date $db_varchar10,
  estimated_time $db_varchar10,
  actual_time $db_varchar10,
  comments $db_text,
  completion $db_mediumint,
  created $db_varchar19b,
  modified $db_varchar19,
  assigned $db_varchar19,
  published $db_char1,
  parent_phase $db_int,
  complete_date $db_varchar10,
  service $db_mediumint,
  fixed_duration $db_char1,
  milestone $db_char1,
  type $db_mediumint,
  task_group $db_char1,
  level $db_int,
  parent_task $db_mediumint,
  subtask $db_mediumint,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}tasks_predecessor (
  id $db_mediumint_auto,
  task $db_mediumint,
  predecessor $db_mediumint,
  type $db_char2,
  lag $db_float,
  created $db_varchar19b,
  modified $db_varchar19,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}tasks_resource (
  id $db_mediumint_auto,
  task $db_mediumint,
  resource $db_mediumint,
  type $db_varchar155,
  support $db_mediumint,
  created $db_varchar19b,
  modified $db_varchar19,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}tasks_time (
  id $db_mediumint_auto,
  project $db_mediumint,
  task $db_mediumint,
  owner $db_mediumint,
  date $db_varchar16,
  hours $db_float,
  comments $db_text,
  billing $db_char1default0,
  created $db_varchar19b,
  modified $db_varchar19,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}teams (
  id $db_mediumint_auto,
  project $db_mediumint,
  member $db_mediumint,
  published $db_char1,
  authorized $db_char1,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}topics (
  id $db_mediumint_auto,
  project $db_mediumint,
  owner $db_mediumint,
  subject $db_varchar155,
  status $db_char1,
  last_post $db_varchar19,
  posts $db_smallint,
  published $db_char1,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}phases (
  id $db_mediumint_auto,
  project_id $db_mediumint,
  order_num $db_mediumint,
  status $db_varchar10,
  name $db_varchar155,
  date_start $db_varchar10,
  date_end $db_varchar10,
  comments $db_varchar255,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}support_posts (
  id $db_mediumint_auto,
  request_id $db_mediumint,
  message $db_text,
  date $db_varchar16,
  owner $db_mediumint,
  project $db_mediumint,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}support_requests (
  id $db_mediumint_auto,
  status $db_mediumint,
  member $db_mediumint,
  priority $db_mediumint,
  subject $db_varchar255,
  message $db_text,
  owner $db_mediumint,
  date_open $db_varchar16,
  date_close $db_varchar16,
  project $db_mediumint,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}updates (
  id $db_mediumint_auto,
  type $db_char1,
  item $db_mediumint,
  member $db_mediumint,
  comments $db_text,
  created $db_varchar19b,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}bookmarks (
  id $db_mediumint_auto,
  owner $db_mediumint,
  category $db_mediumint,
  name $db_varchar255,
  url $db_varchar255,
  description $db_text,
  shared $db_char1,
  home $db_char1,
  comments $db_char1,
  users $db_varchar255,
  created $db_varchar19b,
  modified $db_varchar19,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}bookmarks_categories (
  id $db_mediumint_auto,
  name $db_varchar255,
  description $db_text,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}services (
  id $db_mediumint_auto,
  name $db_varchar155,
  name_print $db_varchar155,
  hourly_rate $db_float,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}sessions (
  id $db_varchar32,
  ipaddr $db_varchar16b,
  session_data $db_longtext,
  last_access $db_int,
  PRIMARY KEY  (id, ipaddr),
  KEY  (last_access)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}person_evaluations (
  id $db_mediumint_auto,
  type $db_mediumint,
  item $db_mediumint,
  appraiser $db_mediumint,
  member $db_mediumint,
  value $db_mediumint,
  submitted $db_char1,
  comments $db_text,
  created $db_varchar16,
  modified $db_varchar16,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}work_hours (
  id $db_mediumint_auto,
  project $db_mediumint,
  work $db_mediumint,
  owner $db_mediumint,
  date $db_varchar16,
  hours $db_float,
  comments $db_text,
  billing $db_char1default0,
  service $db_mediumint,
  created $db_varchar16b,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}timesheet (
  owner $db_mediumint,
  month $db_mediumint,
  standard_hours $db_float,
  actual_hours $db_float,
  billable_hours $db_float,
  overtime_hours $db_float,
  status $db_mediumint,
  comments $db_text,
  submitted $db_varchar16,
  approved $db_varchar16,
  rejected $db_varchar16,
  created $db_varchar16b,
  modified $db_varchar16,
  PRIMARY KEY (owner, month)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}workcalendar (
  id $db_mediumint_auto,
  year $db_smallint,
  date $db_varchar10,
  type $db_mediumint,
  hours $db_float,
  comments $db_text,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}actions (
  id $db_mediumint_auto,
  owner $db_mediumint,
  action $db_mediumint,
  action_data $db_text,
  appraiser $db_mediumint,
  status $db_mediumint,
  created $db_varchar16b,
  modified $db_varchar16,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}leaves (
  id $db_mediumint_auto,
  owner $db_mediumint,
  year $db_smallint,
  type $db_mediumint,
  hours $db_float,
  due_date $db_varchar10,
  comments $db_text,
  created $db_varchar16b,
  modified $db_varchar16,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}leave_requests (
  id $db_mediumint_auto,
  owner $db_mediumint,
  type $db_mediumint,
  sdate $db_varchar16b,
  edate $db_varchar16b,
  hours $db_float,
  status $db_mediumint,
  comments $db_text,
  approved $db_varchar16,
  rejected $db_varchar16,
  created $db_varchar16b,
  modified $db_varchar16,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}timetickets (
  id $db_mediumint_auto,
  name $db_varchar155,
  hours $db_float,
  created $db_varchar16b,
  modified $db_varchar16,
  PRIMARY KEY (id)
)
STAMP;

$SQL[] = <<<STAMP
CREATE TABLE {$tablePrefix}timetickets_detail (
  id $db_mediumint_auto,
  timeticket $db_mediumint,
  stamp $db_varchar5,
  work $db_char1,
  created $db_varchar16b,
  modified $db_varchar16,
  PRIMARY KEY (id)
)
STAMP;

// ****************************************************************************
// data migration
$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}timetickets(name,hours,created) VALUES ('default','8','{$dateheure}');
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}timetickets_detail(timeticket,stamp,work,created) VALUES
 ('1','00:00','1','{$dateheure}') ,('1','00:30','1','{$dateheure}') ,('1','01:00','1','{$dateheure}')
,('1','01:30','1','{$dateheure}') ,('1','02:00','1','{$dateheure}') ,('1','02:30','1','{$dateheure}')
,('1','03:00','1','{$dateheure}') ,('1','03:30','1','{$dateheure}') ,('1','04:00','1','{$dateheure}')
,('1','04:30','1','{$dateheure}') ,('1','05:00','1','{$dateheure}') ,('1','05:30','1','{$dateheure}')
,('1','06:00','1','{$dateheure}') ,('1','06:30','1','{$dateheure}') ,('1','07:00','1','{$dateheure}')
,('1','07:30','1','{$dateheure}') ,('1','08:00','1','{$dateheure}') ,('1','08:30','1','{$dateheure}')
,('1','09:00','0','{$dateheure}') ,('1','09:30','0','{$dateheure}') ,('1','10:00','0','{$dateheure}')
,('1','10:30','0','{$dateheure}') ,('1','11:00','0','{$dateheure}') ,('1','11:30','0','{$dateheure}')
,('1','12:00','0','{$dateheure}') ,('1','12:30','0','{$dateheure}') ,('1','13:00','0','{$dateheure}')
,('1','13:30','0','{$dateheure}') ,('1','14:00','0','{$dateheure}') ,('1','14:30','0','{$dateheure}')
,('1','15:00','0','{$dateheure}') ,('1','15:30','0','{$dateheure}') ,('1','16:00','0','{$dateheure}')
,('1','16:30','0','{$dateheure}') ,('1','17:00','1','{$dateheure}') ,('1','17:30','1','{$dateheure}')
,('1','18:00','1','{$dateheure}') ,('1','18:30','1','{$dateheure}') ,('1','19:00','1','{$dateheure}')
,('1','19:30','1','{$dateheure}') ,('1','20:00','1','{$dateheure}') ,('1','20:30','1','{$dateheure}')
,('1','21:00','1','{$dateheure}') ,('1','21:30','1','{$dateheure}') ,('1','22:00','1','{$dateheure}')
,('1','22:30','1','{$dateheure}') ,('1','23:00','1','{$dateheure}') ,('1','23:30','1','{$dateheure}')
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}assignments (id,task,owner,assigned_to,comments,assigned) SELECT id,task,owner,assigned_to,comments,assigned FROM {$tablePrefixPrev}assignments
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}calendar (id,project,owner,subject,description,shortname,date_start,date_end,time_start,time_end,reminder,recurring,recur_day,reminder_time1,reminder_time2) SELECT id,0,owner,subject,description,shortname,date_start,date_end,time_start,time_end,reminder,recurring,recur_day,0,0 FROM {$tablePrefixPrev}calendar
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}files (id,owner,project,task,name,date,size,extension,comments,comments_approval,approver,date_approval,upload,published,status,vc_status,vc_version,vc_parent,phase) SELECT id,owner,project,task,name,date,size,extension,comments,comments_approval,approver,date_approval,upload,published,status,vc_status,vc_version,vc_parent,phase FROM {$tablePrefixPrev}files
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}logs (id,login,password,ip,session,compt,last_visite,connected) SELECT id,login,password,ip,session,compt,last_visite,connected FROM {$tablePrefixPrev}logs
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}members (id,organization,login,password,name,title,email_work,email_home,phone_work,phone_home,mobile,fax,comments,profil,created,logout_time,last_page,timezone,location,supervisor,agent,theme,layout,timeticket) SELECT id,organization,login,password,name,title,email_work,email_home,phone_work,phone_home,mobile,fax,comments,profil,created,logout_time,last_page,timezone,'',0,0,'default',1,1 FROM {$tablePrefixPrev}members
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}notes (id,project,owner,topic,subject,description,date,published) SELECT id,project,owner,topic,subject,description,date,published FROM {$tablePrefixPrev}notes
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}notifications (id,member,taskAssignment,removeProjectTeam,addProjectTeam,newTopic,newPost,statusTaskChange,priorityTaskChange,duedateTaskChange,clientAddTask) SELECT id,member,taskAssignment,removeProjectTeam,addProjectTeam,newTopic,newPost,statusTaskChange,priorityTaskChange,duedateTaskChange,clientAddTask FROM {$tablePrefixPrev}notifications
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}organizations (id,name,address1,address2,zip_code,city,country,phone,fax,url,email,comments,created,extension_logo,owner) SELECT id,name,address1,address2,zip_code,city,country,phone,fax,url,email,comments,created,extension_logo,owner FROM {$tablePrefixPrev}organizations
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}posts (id,topic,member,created,message) SELECT id,topic,member,created,message FROM {$tablePrefixPrev}posts
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}projects (id,organization,owner,priority,status,name,description,url_dev,url_prod,created,modified,published,upload_max,phase_set,type) SELECT id,organization,owner,priority,status,name,description,url_dev,url_prod,created,modified,published,upload_max,phase_set,type FROM {$tablePrefixPrev}projects
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}reports (id,owner,name,projects,members,priorities,status,date_due_start,date_due_end,created,date_complete_start,date_complete_end,clients) SELECT id,owner,name,projects,members,priorities,status,date_due_start,date_due_end,created,date_complete_start,date_complete_end,clients FROM {$tablePrefixPrev}reports
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}sorting (id,member,home_projects,home_tasks,home_discussions,home_reports,projects,organizations,project_tasks,discussions,project_discussions,users,team,tasks,report_tasks,assignment,reports,files,organization_projects,notes,calendar,phases,support_requests,bookmarks,tasks_time) SELECT id,member,home_projects,home_tasks,home_discussions,home_reports,projects,organizations,project_tasks,discussions,project_discussions,users,team,tasks,report_tasks,assignment,reports,files,organization_projects,notes,calendar,phases,support_requests,bookmarks,tasks_time FROM {$tablePrefixPrev}sorting
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}tasks (id,project,priority,status,owner,assigned_to,name,description,start_date,due_date,estimated_time,actual_time,comments,completion,created,modified,assigned,published,parent_phase,complete_date,service,fixed_duration,milestone,type,task_group,level,parent_task,subtask) SELECT id,project,priority,status,owner,assigned_to,name,description,start_date,due_date,estimated_time,actual_time,comments,completion,created,modified,assigned,published,parent_phase,complete_date,service,'1','1',0,'1',0,0,0 FROM {$tablePrefixPrev}tasks
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}tasks_time (id,project,task,owner,date,hours,comments,created,modified) SELECT id,project,task,owner,date,hours,comments,created,modified FROM {$tablePrefixPrev}tasks_time
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}teams (id,project,member,published,authorized) SELECT id,project,member,published,authorized FROM {$tablePrefixPrev}teams
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}topics (id,project,owner,subject,status,last_post,posts,published) SELECT id,project,owner,subject,status,last_post,posts,published FROM {$tablePrefixPrev}topics
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}phases (id,project_id,order_num,status,name,date_start,date_end,comments) SELECT id,project_id,order_num,status,name,date_start,date_end,comments FROM {$tablePrefixPrev}phases
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}support_posts (id,request_id,message,date,owner,project) SELECT id,request_id,message,date,owner,project FROM {$tablePrefixPrev}support_posts
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}support_requests (id,status,member,priority,subject,message,owner,date_open,date_close,project) SELECT id,status,member,priority,subject,message,owner,date_open,date_close,project FROM {$tablePrefixPrev}support_requests
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}updates (id,type,item,member,comments,created) SELECT id,type,item,member,comments,created FROM {$tablePrefixPrev}updates
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}bookmarks (id,owner,category,name,url,description,shared,home,comments,users,created,modified) SELECT id,owner,category,name,url,description,shared,home,comments,users,created,modified FROM {$tablePrefixPrev}bookmarks
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}bookmarks_categories (id,name,description) SELECT id,name,description FROM {$tablePrefixPrev}bookmarks_categories
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}services (id,name,name_print,hourly_rate) SELECT id,name,name_print,hourly_rate FROM {$tablePrefixPrev}services
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}sessions (id,ipaddr,session_data,last_access) SELECT id,ipaddr,session_data,last_access FROM {$tablePrefixPrev}sessions
STAMP;

$SQL[] = <<<STAMP
INSERT INTO {$tablePrefix}tasks_resource (task,resource,type,support,created) SELECT id,assigned_to,'members','10',assigned FROM {$tablePrefixPrev}tasks WHERE assigned_to<>'0'
STAMP;

$SQL[] = <<<STAMP
UPDATE {$tablePrefix}tasks SET assigned_to='1' WHERE assigned_to<>'0'
STAMP;

// ****************************************************************************

?>
