<?php // $Revision: 1.12 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editleave.php,v 1.12 2006/07/31 02:03:24 luis Exp $
 * 
 * Copyright (c) 2005 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$checkSession = true;
require_once("../includes/library.php");
$bodyCommand = "onLoad=\"document.leEForm.hr.focus();\"";

if ($demoMode == true) {
    $tmpquery = "WHERE mem.profil NOT IN ('" . PF_ADMINISTRATOR . "','" . PF_CLIENT_USER . "') ORDER BY mem.name";
} else {
    $tmpquery = "WHERE mem.profil NOT IN ('" . PF_ADMINISTRATOR . "','" . PF_CLIENT_USER . "') AND mem.id != '2' ORDER BY mem.name";
}

$assignOwner = new request();
$assignOwner->openMembers($tmpquery);
$comptAssignOwner = count($assignOwner->mem_id);

if ($comptAssignOwner == 0) {
    header("Location: ../leaves/listleaves.php?msg=noAvailableUsers");
    exit;
}

if ($profilSession != PF_ADMINISTRATOR && $profilSession != PF_HR_MANAGER) {
    header("Location: ../general/permissiondenied.php");
    exit;
}

if (isset($_GET['id'])) {
    $id = $_GET['id'];
    $tmpquery = "WHERE lea.id = '$id'";
    $detailLeave = new request();
    $detailLeave->openLeaves($tmpquery);
    $comptDetailLeave = count($detailLeave->lea_id);
}

if (isset($_POST['action'])) {
    $action = $_POST['action'];
    $owner = $_POST['owner'];
    $yr = $_POST['yr'];
    $ty = $_POST['ty'];
    $hr = $_POST['hr'];
    $dd = $_POST['dd'];
    $comm = $_POST['comm'];

    if (empty($hr)) {
        // required field
        $error = lang_strings('hours') . '&nbsp;' . lang_strings('error_required');
        $bodyCommand = "onLoad=\"document.leEForm.hr.focus();\"";
    } else if (!is_numeric($hr)) {
        // we need this to be numeric
        $error = lang_strings('hours') . '&nbsp;' . lang_strings('error_numerical');
        $bodyCommand = "onLoad=\"document.leEForm.hr.focus();document.leEForm.hr.select();\"";
    }

    if ($error == '') {
        // replace quotes by html code in name and address
        $comm = htmlentities($comm, ENT_QUOTES, $htmlEntityCharset);

        // case update user
        if ($action == "update") {
            $tmpquery = "UPDATE " . $tableCollab["leaves"] . " SET owner='$owner',year='$yr',type='$ty',hours='$hr',due_date='$dd',comments='$comm',modified='$dateheure' WHERE id = '$id'";
            connectSql($tmpquery);
            header("Location: ../leaves/listleaves.php?msg=update");
            exit;
        } else 
        // case add user
        if ($action == "add") {
            $tmpquery1 = "INSERT INTO " . $tableCollab["leaves"] . " (owner,year,type,hours,due_date,comments,created) VALUES ('$owner','$yr','$ty','$hr','$dd','$comm','$dateheure')";
            connectSql($tmpquery1);
            header("Location: ../leaves/listleaves.php?msg=add");
            exit;
        }
    } else {
        $hr_highlight = true;
    }
}

if ($error == '') {
    if ($id != "") {
        // set values in form
        $owner = $detailLeave->lea_owner[0];
        $yr = $detailLeave->lea_year[0];
        $ty = $detailLeave->lea_type[0];
        $hr = $detailLeave->lea_hours[0];
        $dd = $detailLeave->lea_due_date[0];
        $comm = html_entity_decode($detailLeave->lea_comments[0], ENT_QUOTES, $htmlEntityCharset);
    } else {
        $yr = date('Y');
        $hr = "8";
        $dd = $yr . "-12-31";
    }
}

require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/listleaves.php?", lang_strings("leave_management"), in));

if ($id == "") {
    $blockPage->itemBreadcrumbs(lang_strings("add_leave"));
} else {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../leaves/viewleave.php?id=$id", "#$id", in));
    $blockPage->itemBreadcrumbs(lang_strings("edit_leave"));
}

$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "leE";

if ($id == "") {
    $block1->openForm("../leaves/editleave.php?#" . $block1->form . "Anchor");
    echo "<input type=\"hidden\" name=\"action\" value=\"add\">\n";
    $block1->heading(lang_strings("add_leave"));
} else {
    $block1->openForm("../leaves/editleave.php?id=$id#" . $block1->form . "Anchor");
    echo "<input type=\"hidden\" name=\"action\" value=\"update\">\n";
    $block1->heading(lang_strings("edit_leave") . " : #" . $detailLeave->lea_id[0]);
}

if ($error != "") {
    $block1->headingError(lang_strings("errors"));
    $block1->contentError($error);
}

$block1->openContent();
$block1->contentTitle(lang_strings("details"));
$ownerSel = "<select name=\"owner\">";

for ($i = 0; $i < $comptAssignOwner; $i++) {
    if ($owner == $assignOwner->mem_id[$i]) {
        $ownerSel .= '<option value="' . $assignOwner->mem_id[$i] . '" selected>' . $assignOwner->mem_login[$i] . ' / ' . $assignOwner->mem_name[$i] . '</option>';
    } else {
        $ownerSel .= '<option value="' . $assignOwner->mem_id[$i] . '">' . $assignOwner->mem_login[$i] . ' / ' . $assignOwner->mem_name[$i] . '</option>';
    }
}

$ownerSel .= "</select>";
$block1->contentRow(lang_strings('owner'), $ownerSel);
$yearSel = '<select name="yr">';

for ($i = date('Y')-3; $i < date('Y')+4; $i++) {
    if ($i == $yr) {
        $yearSel .= '<option value="' . $i . '" selected>' . $i . '</option>';
    } else {
        $yearSel .= '<option value="' . $i . '">' . $i . '</option>';
    }
}

$yearSel .= '</select>';
$block1->contentRow(lang_strings("year"), $yearSel);
$typeSel = "<select name=\"ty\">";

if ($ty == LV_ANNUAL) {
    $typeSel .= "<option value=\"" . LV_ANNUAL . "\" selected>" . $hourCodeArray[LV_ANNUAL] . "</option>";
} else {
    $typeSel .= "<option value=\"" . LV_ANNUAL . "\">" . $hourCodeArray[LV_ANNUAL] . "</option>";
}

if ($ty == LV_SICK) {
    $typeSel .= "<option value=\"" . LV_SICK . "\" selected>" . $hourCodeArray[LV_SICK] . "</option>";
} else {
    $typeSel .= "<option value=\"" . LV_SICK . "\">" . $hourCodeArray[LV_SICK] . "</option>";
}

if ($ty == LV_ABSENCE) {
    $typeSel .= "<option value=\"" . LV_ABSENCE . "\" selected>" . $hourCodeArray[LV_ABSENCE] . "</option>";
} else {
    $typeSel .= "<option value=\"" . LV_ABSENCE . "\">" . $hourCodeArray[LV_ABSENCE] . "</option>";
}

$typeSel .= "</select>";
$block1->contentRow(lang_strings('type'), $typeSel);

if ($hr_highlight) {
    $block1->contentRow("* " . lang_strings("hours"), "<input size='20' value='$hr' class='input_hours_highlight' name='hr' maxlength='6' type='text'>");
} else {
    $block1->contentRow("* " . lang_strings("hours"), "<input size='20' value='$hr' class='input_hours' name='hr' maxlength='6' type='text'>");
}

$block1->contentRow(lang_strings("due_date"), "<input type=\"text\" class=\"input_datetime\" name=\"dd\" id=\"sel3\" size=\"20\" value=\"$dd\" readonly><button type=\"reset\" id=\"trigger_b\">...</button><script type=\"text/javascript\">Calendar.setup({ inputField:\"sel3\", button:\"trigger_b\" });</script>");
$block1->contentRow(lang_strings("comments"), "<textarea rows='3' class='textarea_3rows' name='comm' cols='47'>$comm</textarea>");
echo "<tr class=\"odd\"><td valign=\"top\" class=\"leftvalue\">&nbsp;</td><td><input type=\"submit\" name=\"Save\" value=\"" . lang_strings("save") . "\"></td></tr>";
$block1->closeContent();
$block1->closeForm();
require_once("../themes/" . THEME . "/footer.php");

?>
