<?php // $Revision: 1.2 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: graphtasks.php,v 1.2 2006/09/05 06:34:07 luis Exp $
 * 
 * Copyright (c) 2003 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

// load the jpgraph classes
require_once('../includes/jpgraph/jpgraph.php');
require_once('../includes/jpgraph/jpgraph_gantt.php');

$checkSession = true;
require_once('../includes/library.php');

$tmpquery = "WHERE pro.id = '" . $project . "'";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);

$projectDetail->pro_created[0] = createDate($projectDetail->pro_created[0], $timezoneSession);
$projectDetail->pro_name[0] = str_replace('&quot;', '"', $projectDetail->pro_name[0]);
$projectDetail->pro_name[0] = str_replace("&#39;", "'", $projectDetail->pro_name[0]);

// set up the graph
$graph = new GanttGraph();
$graph->SetBox();
$graph->SetShadow();
$graph->SetMarginColor('gainsboro');

// Set the Locale if you get errors with your environment
//$graph->scale->SetDateLocale('C');

// Add title
$graph->title->Set(' ' . $projectDetail->pro_name[0]);
$graph->title->SetFont(GRAPH_TITLE_FONT,GRAPH_TITLE_FONT_STYLE,12);
$graph->title->SetMargin(10);
//$graph->title->SetBox('lemonchiffon1');
$graph->title->SetBox('linen');
$graph->title->SetShadow();

// month and week scales are always displayed
$graph->scale->month->Show(true);
$graph->scale->week->Show(true);
                                                                                                                      
// Condensed Gantt or not?
if ($_GET['base'] == true) {
    $graph->scale->year->Show(true);
    $graph->scale->day->Show(false);
    $graph->scale->month->SetStyle(MONTHSTYLE_SHORTNAME);
} else {
    $graph->scale->year->Show(false);
    $graph->scale->day->Show(true);
    $graph->scale->month->SetStyle(MONTHSTYLE_SHORTNAMEYEAR4);
}
                                                                                                                      
// week scale properties
$graph->scale->week->SetStyle(WEEKSTYLE_FIRSTDAY);
$graph->scale->week->SetFont(GRAPH_WEEK_FONT);

// month scale properties
$graph->scale->month->SetFontColor('white');
$graph->scale->month->SetBackgroundColor('steelblue4');
                                                                                                                      
// year scale properties
$graph->scale->year->SetFontColor('white');
$graph->scale->year->SetBackgroundColor('steelblue4');

// Modify the appearance of the dividing lines
$graph->scale->divider->SetWeight(4);
$graph->scale->divider->SetColor('steelblue4');
$graph->scale->dividerh->SetWeight(1);
$graph->scale->dividerh->SetColor('black');
$graph->SetBox(true,'black',1);

// holiday scale properties
$tmpquery = "SELECT MIN(start_date) FROM " . $tableCollab['tasks'] . " WHERE project = '" . $project . "' AND start_date != '--' AND due_date != '--'";
$firstTask = new request();
$firstTask->connectClass();
$firstTask->query($tmpquery);

while ($firstTask->fetch()) {
    $firstTask->tas_start_date[] = ($row[0]);
}

$firstTask->close();
$tmpquery = "SELECT MAX(due_date) FROM " . $tableCollab['tasks'] . " WHERE project = '" . $project . "' AND start_date != '--' AND due_date != '--'";
$lastTask = new request();
$lastTask->connectClass();
$lastTask->query($tmpquery);

while ($lastTask->fetch()) {
    $lastTask->tas_due_date[] = ($row[0]);
}

$lastTask->close();
$tmpquery = " WHERE wca.date>='" . $firstTask->tas_start_date[0] . "' AND wca.date<='" . $lastTask->tas_due_date[0] . "' AND wca.hours='0'";
$holidayList = new request();
$holidayList->openWorkCalendar($tmpquery);
$comptHolidayList = count($holidayList->wca_id);

for ($i = 0;$i < $comptHolidayList;$i++) {
    $graph->scale->holidays[] = $holidayList->wca_date[$i];
}

// NetOffice footer, please don't remove
$graph->footer->right->Set('Created by NetOffice');
$graph->footer->right->SetColor('gray6');
$graph->footer->right->SetFont(FF_FONT1);

// Column Titles
$graph->scale->actinfo->SetColTitles(array(lang_strings('name'),lang_strings('duration')));
$graph->scale->actinfo->SetBackgroundColor('steelblue4');
$graph->scale->actinfo->SetFontColor('white');
$graph->scale->actinfo->SetFont(GRAPH_ACTINFO_FONT,GRAPH_ACTINFO_FONT_STYLE);

// query for data
$tmpquery = "WHERE tas.project = '" . $project . "' AND tas.start_date != '--' AND tas.due_date != '--' AND tas.level='0' ORDER BY tas.due_date";
$listTasks = new request();
$listTasks->openTasks($tmpquery);
$comptListTasks = count($listTasks->tas_id);

for ($i = 0;$i < $comptListTasks;$i++) {
    $listTasks->tas_name[$i] = str_replace('&quot;', '"', $listTasks->tas_name[$i]);
    $listTasks->tas_name[$i] = str_replace("&#39;", "'", $listTasks->tas_name[$i]);
    $progress = round($listTasks->tas_completion[$i] / 10, 2);
    $printProgress = $listTasks->tas_completion[$i] * 10;
    $tmpquery = "SELECT id FROM " . $tableCollab['tasks'] . " WHERE parent_task='" . $listTasks->tas_id[$i] . "'";
    $comptSubTasks = compt($tmpquery);

    // get the duration in hours for this task
    if ($listTasks->tas_estimated_time[$i] == "") {
        $duration = diff_hour($listTasks->tas_start_date[$i], $listTasks->tas_due_date[$i]);
    } else {
        $duration = $listTasks->tas_estimated_time[$i] ;
    }

    // get actual time for task
    $taskActualTime = new request();
    $actualTime = $taskActualTime->getTaskTime($listTasks->tas_id[$i]);
    $duration_label = sprintf("%s / %sh", $actualTime, $duration);

    // build an activity bar
    if ($listTasks->tas_milestone[$i]!=MS_YES) {
        $activity = new GanttBar($i, array($listTasks->tas_name[$i],$duration_label), $listTasks->tas_start_date[$i], $listTasks->tas_due_date[$i]);
        $activity->SetPattern(BAND_LDIAG, 'yellow');
        $activity->caption->Set($printProgress . '%');
        $activity->caption->SetFont(ACTIVITY_CAPTION_FONT);

        if (constant("ACTIVITY_TITLE_FONT") != "") {
            $activity->title->SetFont(ACTIVITY_TITLE_FONT);
        }

        if ($comptSubTasks > 0) {
            $activity->SetFillColor('darkgray');
        } else {
            $activity->SetFillColor('gray');
        }

        if ($listTasks->tas_priority[$i] == 4 || $listTasks->tas_priority[$i] == 5) {
            $activity->progress->SetPattern(BAND_SOLID, '#BB0000');
        } else {
            $activity->progress->SetPattern(BAND_SOLID, '#0000BB');
        }

        $activity->progress->Set($progress);
    // build a milestone
    } else {
        $activity = new MileStone($i, array($listTasks->tas_name[$i],""), $listTasks->tas_start_date[$i]);

        if (constant("ACTIVITY_TITLE_FONT") != "") {
            $activity->title->SetFont(ACTIVITY_TITLE_FONT);
        }
    }

    // query for successors
    $tmpquery = " WHERE pre.predecessor='" . $listTasks->tas_id[$i] . "'";
    $listSuccessor = new request();
    $listSuccessor->openTaskPredecessor($tmpquery);
    $comptListSuccessor = count($listSuccessor->pre_id);

    if ($comptListSuccessor!="0") {
        // set constrains
        for ($j=0;$j<$comptListSuccessor;$j++) {
            for ($k=0;$k<$comptListTasks;$k++) {
                if ($listSuccessor->pre_task[$j]==$listTasks->tas_id[$k]) {
                    break;
                }
            }
            if ($k==$comptListTasks) {
                continue;
            }
            switch ($listSuccessor->pre_type[$j]) {
                case "FF":
                    $activity->SetConstrain($k, CONSTRAIN_ENDEND);
                    break;
                case "FS":
                    $activity->SetConstrain($k, CONSTRAIN_ENDSTART);
                    break;
                case "SF":
                    $activity->SetConstrain($k, CONSTRAIN_STARTEND);
                    break;
                case "SS":
                    $activity->SetConstrain($k, CONSTRAIN_STARTSTART);
                    break;
            }
        }
    }

    $graph->Add($activity);

    // Condensed Gantt or not?
    if ($_GET['base'] == false) {
        // Responsible for formatting individual milestones
        if ($listTasks->tas_milestone[$i]==MS_YES) {
            $activity = new GanttVLine($listTasks->tas_start_date[$i]);
            $graph->Add($activity);
        }
    }
} 

$graph->Stroke();

?>
