<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: completed.php,v 1.8 2006/06/29 14:34:38 luis Exp $
 * 
 * Copyright (c) 2003 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * ../reports/completed.php
 * 
 * show completed tasks for a particular timespan
 * 
 * TODO: enable month/year selection, as well as start/end times
 */
// configuration options
// set up the member selection
if ($S_mem == "") {
    if ($_POST['S_ATSEL']) {
        if ($_POST['S_ATSEL'] == 'ALL') {
            $S_mem = "ALL";
        } else {
            $S_mem = implode (',', $_POST['S_ATSEL']);
        }
    } else {
        $S_mem = "ALL";
    }
}

// a date range was selected
if ($dateRange == "") {
    if ($_POST{'S_COMPLETEDATE'} == 'DATERANGE') {
        $dateRange = true; 

        // get the range start date (if given)
        if ($_POST{'S_SDATE2'}) {
            $s_sdate2 = $_POST{'S_SDATE2'};
        } else {
            $s_sdate2 = date("Y-m-d",
                mktime (12, 0, 0, date("m"), "1", date("Y")));
        }

        // get the range end date
        if ($_POST{'S_EDATE2'}) {
            $s_edate2 = $_POST{'S_EDATE2'};
        } else {
            $s_edate2 = date("Y-m-d",
                mktime (12, 0, 0, date("m"), date("d"), date("Y")));
        }
    } else {
        // select all dates
        $dateRange = false;
    }
}

// end of configuration
$checkSession = true;
require_once("../includes/library.php");
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?', lang_strings('reports'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?typeReports=create', lang_strings("create_report"), in) . ' | ' . $blockPage->buildLink('../reports/createreport.php?typeReports=custom', lang_strings('custom_reports'), in) . ' | ' . $blockPage->buildLink("../reports/listreports.php?", lang_strings("my_reports"), in));
$blockPage->itemBreadcrumbs(lang_strings("completed_task_report"));
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messagebox($msgLabel);
}

// start the first block
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/completed.php#" . $block1->form . "Anchor");
$block1->openContent();
$block1->sorting("tasks", $sortingUser->sor_tasks[0], "tas.name ASC", $sortingFields = array(0 => "tas.assigned_to", 1 => "tas.name", 2 => "tas.project", 3 => "tas.complete_date"));
$query = " WHERE tas.status = " . ST_COMPLETED . " AND tas.milestone <> '" . MS_YES . "'";

// a date range was selected
if ($dateRange) {
    $query .= "AND (tas.complete_date <= '$s_edate2'  AND tas.complete_date >= '$s_sdate2')";
}

// a member selection was made
if ($S_mem != "ALL" && $S_mem != "") {
    $query = " INNER JOIN " . $tableCollab['tasks_resource'] . " res ON res.task=tas.id " . $query . " AND res.type='members' AND res.resource IN($S_mem)";
}

$queryS = " ORDER BY $block1->sortingValue";
$listTasks = new request();
$listTasks->openHierarchyOfTasks($query, $queryS);
$comptListTasks = count($listTasks->tas_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListTasks == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListTasks == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListTasks . " " . lang_strings("matches"));
} 

$block0->closeContent();

if ($comptListTasks != "0") {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", lang_strings("export"));
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $exportOptions = ""; // handle date ranges

    if ($dateRange) {
        $exportOptions = "S_COMPLETEDATE=DATERANGE&S_SDATE2=$s_sdate2&S_EDATE2=$s_edate2";
    }

    // a member selection was made
    if ($exportOptions != "") {
        $exportOptions .= "&S_ATSEL=$S_mem";
    } else {
        $exportOptions .= "S_ATSEL=$S_mem";
    }

    $block1->paletteScript(0, "export", "../reports/exportcompleted.php?$exportOptions", "true,false,false", lang_strings("export"));
    $block1->closePaletteScript($comptListOrganizations, $listOrganizations->org_id);
}

// set up the header string
$headerString = lang_strings('completed_task_report') . " ";

if ($dateRange) {
    $headerString .= lang_strings("hours_logged_from") . " " . $s_sdate2 . " " . lang_strings("hours_logged_to") . " " . $s_edate2;
}

$block1->heading($headerString);
echo "<input type=\"hidden\" name=\"S_mem\" value=\"$S_mem\">";
echo "<input type=\"hidden\" name=\"dateRange\" value=\"$dateRange\">";
echo "<input type=\"hidden\" name=\"s_sdate2\" value=\"$s_sdate2\">";
echo "<input type=\"hidden\" name=\"s_edate2\" value=\"$s_edate2\">";

if ($comptListTasks != "0") {
    $block1->openResults($checkbox = "false");
    $block1->labels($labels = array(0 => lang_strings("assigned_to"), 1 => lang_strings("task"), 2 => lang_strings("project"), 3 => lang_strings("complete_date")), "false");

    for ($i = 0;$i < $comptListTasks;$i++) {
        $block1->openRow();
        $block1->checkboxRow($listTasks->tas_id[$i], $checkbox = "false");

        if ($listTasks->tas_assigned_to[$i] == "0") {
            $block1->cellRow(lang_strings("unassigned"));
        } else {
            $tmpquery = " AND res.task='" . $listTasks->tas_id[$i] . "'";
            $resourceUsage = new request();
            $resourceUsage->openTaskHumanResource($tmpquery);
            $comptResourceUsage = count($resourceUsage->res_id);
            $assignedToStrings = "";

            for ($j = 0;$j < $comptResourceUsage;$j++) {
                if ($j > 0) {
                    $assignedToStrings .= "&nbsp;";
                }

                $assignedToStrings .= $blockPage->buildLink($resourceUsage->res_mem_email_work[$j], $resourceUsage->res_mem_login[$j], mail);
            }

            $block1->cellRow($assignedToStrings);
        }

        $block1->cellRow($blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i], in));
        $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listTasks->tas_project[$i], $listTasks->tas_pro_name[$i], in));
        $block1->cellRow($listTasks->tas_complete_date[$i]);
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

$block1->closeFormResults(); 
// close this block
require_once("../themes/" . THEME . "/footer.php");

?>
