<?php // $Revision: 1.6 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: export_person_performance.php,v 1.6 2006/07/03 06:05:29 luis Exp $
 * 
 * Copyright (c) 2004 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */
// configuration options
// set up the member selection
if ($_GET['S_ATSEL']) {
    if ($_GET['S_ATSEL'] == 'ALL') {
        $S_mem = "ALL";
    } else {
        $S_mem = $_GET['S_ATSEL'];
    }
} else {
    $S_mem = "ALL";
}

// a date range was selected
if ($_GET{'S_COMPLETEDATE'} == 'DATERANGE') {
    $dateRange = true; 

    // get the range start date (if given)
    if ($_GET{'S_SDATE2'}) {
        $s_sdate2 = $_GET{'S_SDATE2'};
    } else {
        $s_sdate2 = date("Y-m-d", mktime (12, 0, 0, date("m"), "1", date("Y")));
    }

    // get the range end date
    if ($_GET{'S_EDATE2'}) {
        $s_edate2 = $_GET{'S_EDATE2'};
    } else {
        $s_edate2 = date("Y-m-d", mktime (12, 0, 0, date("m"), date("d"), date("Y")));
    }
} else {
    // select all dates
    $dateRange = false;
}

// set up the evaluation value selection
if ($_POST['S_EVSEL']) {
    if ($_POST['S_EVSEL'] == 'ALL') {
        $S_eval = "ALL";
    } else {
        $S_eval = implode (',', $_POST['S_EVSEL']);
    }
} else {
    $S_eval = "ALL";
}
// end of configuration

// this is the filename the 'save as' file window will bring up by default
$filename = "person_performance";
$checkSession = false;
require_once("../includes/library.php");

function which_crlf()
{
    $the_crlf = "\n"; 

    // The 'NETOFFICE_USR_OS' constant is defined in "../includes/defines.lib.php"
    // Win case
    if (NETOFFICE_USR_OS == 'Win') {
        $the_crlf = "\r\n";
    }
    // Mac case
    else if (NETOFFICE_USR_OS == 'Mac') {
        $the_crlf = "\r";
    }
    // Others
    else {
        $the_crlf = "\n";
    }

    return $the_crlf;
}

@set_time_limit(600);
$crlf = which_crlf();

/**
 * Send headers depending on whether the user choosen to download a dump file
 * or not
 */

$reportHeader = "\"" . lang_strings("person_evaluation") . "\"";
$query = "WHERE eva.submitted = '0'";

// a date range was selected
if ($dateRange) {
    $query .= " AND (eva.modified <= '$s_edate2'  AND eva.modified >= '$s_sdate2')";
    $reportHeader .= ",\"" . lang_strings("hours_logged_from") . "\",\"$s_sdate2\",\"" . lang_strings("hours_logged_to") . "\",\"$s_edate2\"";
}

$reportHeader .= $crlf;

// a member selection was made
if ($S_mem != 'ALL' && $S_mem != "") {
    $query .= " AND eva.member IN($S_mem)";
}

$tmpquery = "$query ORDER BY mem2.name,eva.modified";
$listPersonEvaluations = new request();
$listPersonEvaluations->openPersonEvaluations($tmpquery);
$comptListPersonEvaluations = count($listPersonEvaluations->eva_id);
$dump_buffer = $reportHeader . $crlf;

if ($comptListPersonEvaluations != "0") {
    /**
     * Construct the header row
     */

    $dump_buffer .= "\"" . lang_strings("member") . "\",\"" . lang_strings("type") . "\",\"" . lang_strings("item") . "\",\"" . lang_strings("appraiser") . "\",\"" . lang_strings("date") . "\",\"" . lang_strings("value") . "\"" . $crlf;

    for ($i = 0;$i < $comptListPersonEvaluations;$i++) {
        if ($listPersonEvaluations->eva_type[$i] == 0) {
            $tmpquery = "WHERE tas.id='" . $listPersonEvaluations->eva_item[$i] . "'";
            $taskDetail = new request();
            $taskDetail->openTasks($tmpquery);
            $itemContent = $taskDetail->tas_name[0];

            if ($taskDetail->tas_type[0] >= 0)
                $itemContent .= " (" . $personEvaluationItemArraySets['sets'][$taskDetail->tas_type[0]] . ")";
        } else {
            $itemContent = $personEvaluationItemArraySets['sets'][$listPersonEvaluations->eva_item[$i]];
        }

        /**
         * The individual fields
         */
        // member name
        $dump_buffer .= "\"" . $listPersonEvaluations->eva_mem2_name[$i] . "\","; 
        // evaluation type
        $dump_buffer .= "\"" . $personEvaluationTypeArray[$listPersonEvaluations->eva_type[$i]] . "\","; 
        // evaluation item
        $dump_buffer .= "\"" . $itemContent . "\","; 
        // appraiser name
        $dump_buffer .= "\"" . $listPersonEvaluations->eva_mem_name[$i] . "\","; 
        // date
        $dump_buffer .= "\"" . $listPersonEvaluations->eva_modified[$i] . "\","; 
        // value
        $dump_buffer .= $personEvaluationValueArray[$listPersonEvaluations->eva_value[$i]]['display'];
        $dump_buffer .= $crlf;
    }
}

$ext = 'csv';
$mime_type = 'text/x-csv';
// Send headers
header('Content-Type: ' . $mime_type);
$content_disp = (NETOFFICE_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '.' . $ext . '"');
header('Pragma: no-cache');
header('Expires: 0');
echo $dump_buffer;

?>
