<?php // $Revision: 1.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: exportma.php,v 1.1 2006/03/30 09:52:39 luis Exp $
 * 
 * Copyright (c) 2006 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

//
// Function to calculate the number of working days (YYYY-MM-DD)
function workDays($start, $end)
{
  global $tableCollab, $countEnregTotal;
  $tmpquery = "SELECT * FROM " . $tableCollab['workcalendar'] . " WHERE date>='$start' AND date<='$end' AND hours>0";
  compt($tmpquery);
  return $countEnregTotal;
}

//
// Function to get the headings containg the date
function getDateArray($first, $last, $full=true)
{
    $DateArr[] = lang_strings('project');
    $DateArr[] = lang_strings('task');

    //Convert dates to php format
    while ($first<=$last)
    {
        if ($full) {
            $DateArr[]=$first;
        } else {
            $DateArr[]=date("d",strtotime($first));
        }

        $first=date("Y-m-d", strtotime("+1 days", strtotime($first)));
    }

    return $DateArr;
}

// configuration options
// set up the member selection
$S_mem = $_GET['S_ATSEL'];

// get the range start date (if given)
$s_sdate2 = $_GET{'S_SDATE2'};

// get the range end date
$s_edate2 = $_GET{'S_EDATE2'};

// end of configuration

// this is the filename the 'save as' file window will bring up by default
$filename = "member_allocation";
$checkSession = true;
require_once("../includes/library.php");

function which_crlf()
{
    $the_crlf = "\n"; 
    // The 'NETOFFICE_USR_OS' constant is defined in "../includes/defines.lib.php"
    // Win case
    if (NETOFFICE_USR_OS == 'Win') {
        $the_crlf = "\r\n";
    } 
    // Mac case
    else if (NETOFFICE_USR_OS == 'Mac') {
        $the_crlf = "\r";
    } 
    // Others
    else {
        $the_crlf = "\n";
    } 

    return $the_crlf;
} 

@set_time_limit(600);
$crlf = which_crlf();



//
// Display Member that was selected
if ($S_mem == "ALL" || $S_mem == "") {
    $tmpquery = "WHERE mem.id != '2' AND mem.profil NOT IN ('" . PF_CLIENT_USER . "','" . PF_DISABLED . "','" . PF_DELETED . "') ORDER BY mem.name";
} else {
    $tmpquery = " WHERE mem.id IN ($S_mem) ORDER BY mem.name";
}

$listMembers = new request();
$listMembers->openMembers($tmpquery);
$comptListMembers = count($listMembers->mem_id);
$dump_buffer = "";

//
// Load Workcalendar
$tmpquery = " WHERE wca.date>='$s_sdate2' AND wca.date<='$s_edate2'";
$listWorkCalendar = new request();
$listWorkCalendar->openWorkCalendar($tmpquery);
$comptListWorkCalendar = count($listWorkCalendar->wca_id);

for ($i=0; $i<$comptListWorkCalendar; $i++) {
    $listWorkHours[$listWorkCalendar->wca_date[$i]] = $listWorkCalendar->wca_hours[$i];
}

for ($j=0; $j<$comptListMembers; $j++) {
    //
    // Initialize Member level variables
    $memberName = $listMembers->mem_name[$j];
    $memberId = $listMembers->mem_id[$j];
    $overdueHours = 0;

    //
    // Query to list only open projects (scheduled) and open or not started
    // tasks (currently being worked on or scheduled to be worked on).
    $tmpquery = " AND res.resource='$memberId' AND tas.status IN (" . ST_NOT_STARTED . "," . ST_OPEN . ") AND pro.status='" . ST_OPEN . "' AND tas.start_date<='$s_edate2' AND tas.due_date>='$s_sdate2' ORDER BY pro.name,tas.name";
    $listTaskHumanResource = new request();
    $listTaskHumanResource->openTaskHumanResource($tmpquery);
    $comptListTaskHumanResource = count($listTaskHumanResource->res_id);

    if ($comptListTaskHumanResource != "0") {
        $lblDays = getDateArray($s_sdate2,$s_edate2,false);
        $lblDaysFull = getDateArray($s_sdate2,$s_edate2);

        //
        // Block for Member
        $dump_buffer .= "\"" . $memberName . " - " . $s_sdate2 . " to " . $s_edate2 . "\"" . $crlf;

        //
        // Member headers
        $dump_buffer .= "\"" . lang_strings("project") . "\",\"" . lang_strings("task") . "\"";

        for ($l=2; $l<count($lblDays); $l++) {
            $dump_buffer .= ",\"" . $lblDays[$l] . "\"";
        }

        $dump_buffer .= $crlf;

        //
        // Initialize Member summary
        $sumHours[] = null;
        unset($sumHours);

        for ($a=0; $a<count($lblDays); $a++) {
            $sumHours[] = 0;
        }

        //
        // Sumarize Tasks on each Member
        $taskName = null;

        for ($k=0; $k<$comptListTaskHumanResource; $k++) {
            //
            // Populate task level information
            $projectName = $listTaskHumanResource->res_pro_name[$k];
            $taskName = $listTaskHumanResource->res_tas_name[$k];
            $taskEst = $listTaskHumanResource->res_tas_estimated_time[$k];
            $taskStartDate = $listTaskHumanResource->res_tas_start_date[$k];
            $taskEndDate = $listTaskHumanResource->res_tas_due_date[$k];

            //
            // Determine future number of days left.
            if ($taskStartDate <= $s_sdate2) {
                $numWorkDays = workDays($s_sdate2, $taskEndDate);
            } else {
                $numWorkDays = workDays($taskStartDate, $taskEndDate);
            }

            //
            // Calculate daily hours depending on task percent complete and member percent support.  Negative numHoursPerDay means its past due
            if ($numWorkDays > 0) {
                $numHoursPerDay = round($taskEst / $numWorkDays,2) * ((10 - $listTaskHumanResource->res_tas_completion[$k]) * 0.1) * $listTaskHumanResource->res_support[$k] * 0.1;
            } else {
                $numHoursPerDay = 0;
                $overdueHours += round($taskEst,2) * ((10 - $listTaskHumanResource->res_tas_completion[$k]) * 0.1) * $listTaskHumanResource->res_support[$k] * 0.1;
            }
        
            // Print hours allocated to each day, do not start from first two indexes.
            // Comparisons for date are made on string (YYYY-MM-DD)
            $showRow = false;

            for ($l=2; $l<count($lblDays); $l++) {
                if (($taskStartDate<=$lblDaysFull[$l]) && ($taskEndDate>=$lblDaysFull[$l])) {
                    $showRow = true;
                }
            }

            if ($showRow) {
                $dump_buffer .= "\"" . $projectName . "\"";
                $dump_buffer .= ",\"" . $taskName . "\"";

                for ($l=2; $l<count($lblDays); $l++) {
                    if ($listWorkHours[$lblDaysFull[$l]] > 0) {
                        if (($taskStartDate<=$lblDaysFull[$l]) && ($taskEndDate>=$lblDaysFull[$l])) {
                            $dump_buffer .= "," . $numHoursPerDay;
                            $sumHours[$l] += $numHoursPerDay;
                        } else {
                            $dump_buffer .= ",0";
                        }
                    } else {
                        $dump_buffer .= ",\"\"";
                    }
                }

                $dump_buffer .= $crlf;
            }
        }

        //
        // Summary blank row
        $dump_buffer .= $crlf;
    
        //
        // Summary title cell
        $dump_buffer .= "\"" . lang_strings('ru_total_mem') . "\"";

        //
        // Summary daily totals row
        $dump_buffer .= ",\"" . lang_strings('daily_total') . "\":";

        for ($l=2; $l<count($lblDays); $l++) {
            if ($listWorkHours[$lblDaysFull[$l]] > 0) {
                $dump_buffer .= "," . $sumHours[$l];
            } else {
                $dump_buffer .= ",\"\"";
            }
        }

        $dump_buffer .= $crlf;

        //
        // Summary past required hours row
        $dump_buffer .= "\"\"";
        $dump_buffer .= ",\"" . lang_strings('overdue_hours') . "\":";
        $dump_buffer .= "," . $overdueHours;
        $dump_buffer .= $crlf . $crlf;
    }
}

$ext = 'csv';
$mime_type = 'text/x-csv';
// Send headers
header('Content-Type: ' . $mime_type);
$content_disp = (NETOFFICE_USR_BROWSER_AGENT == 'IE') ? 'inline' : 'attachment';
header('Content-Disposition:  ' . $content_disp . '; filename="' . $filename . '.' . $ext . '"');
header('Pragma: no-cache');
header('Expires: 0');

echo $dump_buffer;

?>
