<?php // $Revision: 1.6 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: graphtasks.php,v 1.6 2006/06/29 14:36:11 luis Exp $
 * 
 * Copyright (c) 2003 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

// load the jpgraph classes
require_once ('../includes/jpgraph/jpgraph.php');
require_once ('../includes/jpgraph/jpgraph_gantt.php');

$checkSession = true;
require_once('../includes/library.php');

$tmpquery = "WHERE id = '" . $report . "'";
$reportDetail = new request();
$reportDetail->openReports($tmpquery);
$S_ORGSEL = $reportDetail->rep_clients[0];
$S_PRJSEL = $reportDetail->rep_projects[0];
$S_ATSEL = $reportDetail->rep_members[0];
$S_STATSEL = $reportDetail->rep_status[0];
$S_PRIOSEL = $reportDetail->rep_priorities[0];
$S_SDATE = $reportDetail->rep_date_due_start[0];
$S_EDATE = $reportDetail->rep_date_due_end[0];
$S_SDATE2 = $reportDetail->rep_date_complete_start[0];
$S_EDATE2 = $reportDetail->rep_date_complete_end[0];

if ($S_SDATE == "" && $S_EDATE == "") {
    $S_DUEDATE = "ALL";
}

if ($S_SDATE2 == "" && $S_EDATE2 == "") {
    $S_COMPLETEDATE = "ALL";
}

if ($S_ORGSEL != "ALL" || $S_PRJSEL != "ALL" || $S_ATSEL != "ALL" || $S_STATSEL != "ALL" || $S_PRIOSEL != "ALL" || $S_DUEDATE != "ALL" || $S_COMPLETEDATE != "ALL") {
    if ($S_ATSEL != "ALL" && $S_ATSEL != "") {
        $queryStart = " INNER JOIN " . $tableCollab['tasks_resource'] . " res ON res.task=tas.id WHERE res.type='members' AND (";
    } else {
        $queryStart = "WHERE (";
    }

    if ($S_PRJSEL != "ALL" && $S_PRJSEL != "") {
        $query = "tas.project IN($S_PRJSEL)";
    }

    if ($S_ORGSEL != "ALL" && $S_ORGSEL != "") {
        if ($query != "") {
            $query .= " AND org.id IN($S_ORGSEL)";
        } else {
            $query .= "org.id IN($S_ORGSEL)";
        }
    }

    if ($S_ATSEL != "ALL" && $S_ATSEL != "") {
        if ($query != "") {
            $query .= " AND res.resource IN($S_ATSEL)";
        } else {
            $query .= "res.resource IN($S_ATSEL)";
        }
    }

    if ($S_STATSEL != "ALL" && $S_STATSEL != "") {
        if ($query != "") {
            $query .= " AND tas.status IN($S_STATSEL)";
        } else {
            $query .= "tas.status IN($S_STATSEL)";
        }
    }

    if ($S_PRIOSEL != "ALL" && $S_PRIOSEL != "") {
        if ($query != "") {
            $query .= " AND tas.priority IN($S_PRIOSEL)";
        } else {
            $query .= "tas.priority IN($S_PRIOSEL)";
        }
    }

    if ($S_DUEDATE != "ALL" && $S_SDATE != "") {
        if ($query != "") {
            $query .= " AND tas.due_date >= '$S_SDATE'";
        } else {
            $query .= "tas.due_date >= '$S_SDATE'";
        }
    }

    if ($S_DUEDATE != "ALL" && $S_EDATE != "") {
        if ($query != "") {
            $query .= " AND tas.due_date <= '$S_EDATE'";
        } else {
            $query .= "tas.due_date <= '$S_EDATE'";
        }
    }

    if ($S_COMPLETEDATE != "ALL" && $S_SDATE2 != "") {
        if ($query != "") {
            $query .= " AND tas.complete_date >= '$S_SDATE2'";
        } else {
            $query .= "tas.complete_date >= '$S_SDATE2'";
        }
    }

    if ($S_COMPLETEDATE != "ALL" && $S_EDATE2 != "") {
        if ($query != "") {
            $query .= " AND tas.complete_date <= '$S_EDATE2'";
        } else {
            $query .= "tas.complete_date <= '$S_EDATE2'";
        }
    }

    $query .= ")";
}

$reportDetail->rep_created[0] = createDate($reportDetail->rep_created[0], $timezoneSession);

// set up the graph
$graph = new GanttGraph();
$graph->SetBox();
$graph->SetShadow();
$graph->SetMarginColor('gainsboro');

// Set the Locale if you get errors with your environment
//$graph->scale->SetDateLocale('C');

// Add title
$graph->title->Set(' ' . lang_strings('report') . ': ' . $reportDetail->rep_name[0]);
$graph->title->SetFont(GRAPH_TITLE_FONT,GRAPH_TITLE_FONT_STYLE,12);
$graph->title->SetMargin(10);
$graph->title->SetBox('linen');
$graph->title->SetShadow();

// month and week scales are always displayed
$graph->scale->month->Show(true);
$graph->scale->week->Show(true);
                                                                                                                      
// Condensed Gantt or not?
if ($_GET['base'] == true) {
    $graph->scale->year->Show(true);
    $graph->scale->day->Show(false);
    $graph->scale->month->SetStyle(MONTHSTYLE_SHORTNAME);
} else {
    $graph->scale->year->Show(false);
    $graph->scale->day->Show(true);
    $graph->scale->month->SetStyle(MONTHSTYLE_SHORTNAMEYEAR4);
}
                                                                                                                      
// week scale properties
$graph->scale->week->SetStyle(WEEKSTYLE_FIRSTDAY);
$graph->scale->week->SetFont(GRAPH_WEEK_FONT);

// month scale properties
$graph->scale->month->SetFontColor('white');
$graph->scale->month->SetBackgroundColor('steelblue4');
                                                                                                                      
// year scale properties
$graph->scale->year->SetFontColor('white');
$graph->scale->year->SetBackgroundColor('steelblue4');

// Modify the appearance of the dividing lines
$graph->scale->divider->SetWeight(4);
$graph->scale->divider->SetColor('steelblue4');
$graph->scale->dividerh->SetWeight(1);
$graph->scale->dividerh->SetColor('black');
$graph->SetBox(true,'black',1);

// NetOffice footer, please don't remove
$graph->footer->right->Set('Created by NetOffice');
$graph->footer->right->SetColor('gray6');
$graph->footer->right->SetFont(FF_FONT1);

// Column Titles
$graph->scale->actinfo->SetColTitles(array('Project','Task','Duration'));
$graph->scale->actinfo->SetBackgroundColor('steelblue4');
$graph->scale->actinfo->SetFontColor('white');
$graph->scale->actinfo->SetFont(GRAPH_ACTINFO_FONT,GRAPH_ACTINFO_FONT_STYLE);

// query for data
$tmpqueryC = "$queryStart $query";
$tmpqueryS = "ORDER BY tas.due_date";
$listTasks = new request();
$listTasks->openHierarchyOfTasks($tmpqueryC, $tmpqueryS);
$comptListTasks = count($listTasks->tas_id);

for ($i = 0;$i < $comptListTasks;$i++) {
    $listTasks->tas_name[$i] = str_replace('&quot;', '"', $listTasks->tas_name[$i]);
    $listTasks->tas_name[$i] = str_replace("&#39;", "'", $listTasks->tas_name[$i]);
    $listTasks->tas_pro_name[$i] = str_replace('&quot;', '"', $listTasks->tas_pro_name[$i]);
    $listTasks->tas_pro_name[$i] = str_replace("&#39;", "'", $listTasks->tas_pro_name[$i]);
    $progress = round($listTasks->tas_completion[$i] / 10, 2);
    $printProgress = $listTasks->tas_completion[$i] * 10;

    // get the duration in hours for this task
    if ($listTasks->tas_estimated_time[$i] == "") {
        $duration = diff_hour($listTasks->tas_start_date[$i], $listTasks->tas_due_date[$i]);
    } else {
        $duration = $listTasks->tas_estimated_time[$i] ;
    }

    // get actual time for task
    $taskActualTime = new request();
    $actualTime = $taskActualTime->getTaskTime($listTasks->tas_id[$i]);
    $duration_label = sprintf("%s / %sh", $actualTime, $duration);

    // build an activity group
    if ($listTasks->tas_task_group[$i]==TG_YES) {
        $activity = new GanttBar($i, array($listTasks->tas_name[$i],$duration_label), $listTasks->tas_start_date[$i], $listTasks->tas_due_date[$i]);

        if (constant("ACTIVITY_TITLE_FONT") != "") {
            $activity->title->SetFont(ACTIVITY_TITLE_FONT);
        }

        $activity->rightMark->Show();
        $activity->rightMark->SetType(MARK_RIGHTTRIANGLE);
        $activity->rightMark->SetWidth(6);
        $activity->rightMark->SetColor('black');
        $activity->rightMark->SetFillColor('black');

        $activity->leftMark->Show();
        $activity->leftMark->SetType(MARK_LEFTTRIANGLE);
        $activity->leftMark->SetWidth(6);
        $activity->leftMark->SetColor('black');
        $activity->leftMark->SetFillColor('black');

        $activity->SetHeight(0.3);
        $activity->SetPattern(BAND_SOLID,'black');

    // build an activity bar
    } else if ($listTasks->tas_milestone[$i]!=MS_YES) {
        $activity = new GanttBar($i, array($listTasks->tas_pro_name[$i], $listTasks->tas_name[$i], $duration_label), $listTasks->tas_start_date[$i], $listTasks->tas_due_date[$i]);
        $activity->SetPattern(BAND_LDIAG, 'yellow');
        $activity->caption->Set($printProgress . '%');
        $activity->caption->SetFont(ACTIVITY_CAPTION_FONT);

        if (constant("ACTIVITY_TITLE_FONT") != "") {
            $activity->title->SetFont(ACTIVITY_TITLE_FONT);
        }

        $activity->SetFillColor('gray');

        if ($listTasks->tas_priority[$i] == 4 || $listTasks->tas_priority[$i] == 5) {
            $activity->progress->SetPattern(BAND_SOLID, '#BB0000');
        } else {
            $activity->progress->SetPattern(BAND_SOLID, '#0000BB');
        }

        $activity->progress->Set($progress);
// build a milestone
    } else {
        $activity = new MileStone($i, array($listTasks->tas_name[$i],""), $listTasks->tas_start_date[$i]);

        if (constant("ACTIVITY_TITLE_FONT") != "") {
            $activity->title->SetFont(ACTIVITY_TITLE_FONT);
        }
    }

    // query for successors
    $tmpquery = " WHERE pre.predecessor='" . $listTasks->tas_id[$i] . "'";
    $listSuccessor = new request();
    $listSuccessor->openTaskPredecessor($tmpquery);
    $comptListSuccessor = count($listSuccessor->pre_id);

    if ($comptListSuccessor!="0") {
        // set constrains
        for ($j=0;$j<$comptListSuccessor;$j++) {
            for ($k=0;$k<$comptListTasks;$k++) {
                if ($listSuccessor->pre_task[$j]==$listTasks->tas_id[$k]) {
                    break;
                }
            }

            if ($k==$comptListTasks) {
                continue;
            }

            switch ($listSuccessor->pre_type[$j]) {
                case "FF":
                    $activity->SetConstrain($k, CONSTRAIN_ENDEND);
                    break;
                case "FS":
                    $activity->SetConstrain($k, CONSTRAIN_ENDSTART);
                    break;
                case "SF":
                    $activity->SetConstrain($k, CONSTRAIN_STARTEND);
                    break;
                case "SS":
                    $activity->SetConstrain($k, CONSTRAIN_STARTSTART);
                    break;
            }
        }
    }

    $graph->Add($activity);

    // Responsible for formatting individual milestones
    if ($listTasks->tas_milestone[$i]==MS_YES) {
        $activity = new GanttVLine($listTasks->tas_start_date[$i]);
        $graph->Add($activity);
    }
}

$graph->Stroke();

?>
