<?php // $Revision: 1.6 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: leaves.php,v 1.6 2006/06/29 14:34:38 luis Exp $
 * 
 * Copyright (c) 2005 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * ../reports/leaves.php
 * 
 */
// configuration options
// set up the member selection
if ($_POST['S_ATSEL']) {
    if ($_POST['S_ATSEL'] == 'ALL') {
        $S_mem = "ALL";
    } else {
        $S_mem = implode (',', $_POST['S_ATSEL']);
    } 
} else {
    $S_mem = "ALL";
} 

// a date range was selected
if ($_POST{'S_COMPLETEDATE'} == 'DATERANGE') {
    $dateRange = true; 
    // get the range start date (if given)
    if ($_POST{'S_SDATE2'}) {
        $s_sdate2 = $_POST{'S_SDATE2'};
    } else {
        $s_sdate2 = date("Y-m-d",
            mktime (12, 0, 0, date("m"), "1", date("Y")));
    } 
    // get the range end date
    if ($_POST{'S_EDATE2'}) {
        $s_edate2 = $_POST{'S_EDATE2'};
    } else {
        $s_edate2 = date("Y-m-d",
            mktime (12, 0, 0, date("m"), date("d"), date("Y")));
    } 
} else {
    // select all dates
    $dateRange = false;
} 

// end of configuration
$checkSession = true;
require_once("../includes/library.php");
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?', lang_strings('reports'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?typeReports=create', lang_strings("create_report"), in) . ' | ' . $blockPage->buildLink('../reports/createreport.php?typeReports=custom', lang_strings('custom_reports'), in) . ' | ' . $blockPage->buildLink("../reports/listreports.php?", lang_strings("my_reports"), in));
$blockPage->itemBreadcrumbs(lang_strings("leave_report"));
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messagebox($msgLabel);
} 

// start the first block
$block1 = new block();
$block1->form = "xleP";
$block1->openForm("../reports/leaves.php#" . $block1->form . "Anchor");
$block1->openContent();
$query = " WHERE wkh.work IN ('" . LV_ANNUAL . "','" . LV_SICK . "','" . LV_ABSENCE . "','" . LV_BANKHOLIDAY . "','" . LV_MOURNING . "','" . LV_HONEYMOON . "','" . LV_MATERNITY . "')";

// a member selection was made
if ($S_mem != 'ALL' && $S_mem != "") {
    $query .= " AND wkh.owner IN($S_mem)";
} 

// a date range was selected
if ($dateRange) {
    $query .= " AND (wkh.date <= '$s_edate2'  AND wkh.date >= '$s_sdate2')";
} 

$tmpquery = "$query ORDER BY wkh.owner";
$listWorkHours = new request();
$listWorkHours->openWorkHours($tmpquery);
$comptListWorkHours = count($listWorkHours->wkh_id);
$lastMember = "";
$comptResults = 0;

for ($i = 0;$i < $comptListWorkHours;$i++) {
    if ($lastMember != $listWorkHours->wkh_owner[$i]) {
        $comptResults++;
        $lastMember = $listWorkHours->wkh_owner[$i];
    }
}

$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptResults == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptResults == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptResults . " " . lang_strings("matches"));
} 

$block0->closeContent();

if ($comptResults != "0") {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", lang_strings("export"));
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $exportOptions = "";

    // handle date ranges
    if ($dateRange) {
        if ($exportOptions != "") {
            $exportOptions = "&S_COMPLETEDATE=DATERANGE&S_SDATE2=$s_sdate2&S_EDATE2=$s_edate2";
        } else {
            $exportOptions = "S_COMPLETEDATE=DATERANGE&S_SDATE2=$s_sdate2&S_EDATE2=$s_edate2";
        }
    }

    // a member selection was made
    if ($S_mem != 'ALL' && $S_mem != "") {
        if ($exportOptions != "") {
            $exportOptions .= "&S_ATSEL=$S_mem";
        } else {
            $exportOptions .= "S_ATSEL=$S_mem";
        }
    }

    $block1->paletteScript(0, "export", "../reports/export_leaves.php?$exportOptions", "true,false,false", lang_strings("export"));
    $block1->closePaletteScript($comptListWorkHours, $listWorkHours->wkh_id);
}

// set up the header string
$block1HeadingText = lang_strings("leaves") . " ";

if ($dateRange) {
    $block1HeadingText .= lang_strings("hours_logged_from") . " " . $s_sdate2 . " " . lang_strings("hours_logged_to") . " " . $s_edate2;
}

$block1->heading($block1HeadingText);
// initialize counters

if ($comptListWorkHours != "0") {
    $lastMember = $listWorkHours->wkh_owner[0];
    $lastMemberName = $listWorkHours->wkh_mem_name[0];
    $totalReport = array(LV_ANNUAL => 0, LV_SICK => 0, LV_ABSENCE => 0, LV_BANKHOLIDAY => 0, LV_MOURNING => 0, LV_HONEYMOON => 0, LV_MATERNITY => 0, 0 => 0);
    $totalMember = array(LV_ANNUAL => 0, LV_SICK => 0, LV_ABSENCE => 0, LV_BANKHOLIDAY => 0, LV_MOURNING => 0, LV_HONEYMOON => 0, LV_MATERNITY => 0, 0 => 0);
    $block1->openResults($checkbox = "false");
    $block1->labels($labels = array(0 => lang_strings("user_name"), 1 => $hourCodeArray[LV_ANNUAL], 2 => $hourCodeArray[LV_SICK], 3 => $hourCodeArray[LV_ABSENCE], 4 => $hourCodeArray[LV_BANKHOLIDAY], 5 => $hourCodeArray[LV_MOURNING], 6 => $hourCodeArray[LV_HONEYMOON], 7 => $hourCodeArray[LV_MATERNITY], 8 => lang_strings("ru_subtotal")), "false");

    for ($i = 0;$i < $comptListWorkHours;$i++) {
        if ($lastMember != $listWorkHours->wkh_owner[$i]) {
            $block1->openRow();
            $block1->checkboxRow($listWorkHours->wkh_id[$i], $checkbox = "false");
            $block1->cellRow($lastMemberName);
            $block1->cellRow($totalMember[LV_ANNUAL]);
            $block1->cellRow($totalMember[LV_SICK]);
            $block1->cellRow($totalMember[LV_ABSENCE]);
            $block1->cellRow($totalMember[LV_BANKHOLIDAY]);
            $block1->cellRow($totalMember[LV_MOURNING]);
            $block1->cellRow($totalMember[LV_HONEYMOON]);
            $block1->cellRow($totalMember[LV_MATERNITY]);
            $block1->cellRow($totalMember[0]);
            $block1->closeRow();
            $lastMember = $listWorkHours->wkh_owner[$i];
            $lastMemberName = $listWorkHours->wkh_mem_name[$i];
            $totalMember = array(LV_ANNUAL => 0, LV_SICK => 0, LV_ABSENCE => 0, LV_BANKHOLIDAY => 0, LV_MOURNING => 0, LV_HONEYMOON => 0, LV_MATERNITY => 0, 0 => 0);
        }

        $totalMember[$listWorkHours->wkh_work[$i]] += $listWorkHours->wkh_hours[$i];
        $totalMember[0] += $listWorkHours->wkh_hours[$i];
        $totalReport[$listWorkHours->wkh_work[$i]] += $listWorkHours->wkh_hours[$i];
        $totalReport[0] += $listWorkHours->wkh_hours[$i];
    } 

    $block1->openRow();
    $block1->checkboxRow("", $checkbox = "false");
    $block1->cellRow($lastMemberName);
    $block1->cellRow($totalMember[LV_ANNUAL]);
    $block1->cellRow($totalMember[LV_SICK]);
    $block1->cellRow($totalMember[LV_ABSENCE]);
    $block1->cellRow($totalMember[LV_BANKHOLIDAY]);
    $block1->cellRow($totalMember[LV_MOURNING]);
    $block1->cellRow($totalMember[LV_HONEYMOON]);
    $block1->cellRow($totalMember[LV_MATERNITY]);
    $block1->cellRow($totalMember[0]);
    $block1->closeRow();
    // print the totals
    $block1->openRow();
    $block1->checkboxRow("", $checkbox = "false");
    $block1->cellRow(lang_strings("hours_total"));
    $block1->cellRow($totalReport[LV_ANNUAL]);
    $block1->cellRow($totalReport[LV_SICK]);
    $block1->cellRow($totalReport[LV_ABSENCE]);
    $block1->cellRow($totalReport[LV_BANKHOLIDAY]);
    $block1->cellRow($totalReport[LV_MOURNING]);
    $block1->cellRow($totalReport[LV_HONEYMOON]);
    $block1->cellRow($totalReport[LV_MATERNITY]);
    $block1->cellRow($totalReport[0]);
    $block1->closeRow();
    $block1->closeResults();
} else {
    $block1->noresults();
} 

// close block1
$block1->closeFormResults();
require_once("../themes/" . THEME . "/footer.php");

?>
