<?php  // $Revision: 1.3 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * Author:     Graham Sutcliffe
 * Date:       9/28/2005
 * File:       /reports/member_allocation.php
 * Reference:  /reports/selectma.php
 *
 * Resource allocation within a date range by Employee.  Keep date range within
 * 4 weeks for decient looking report.
 *
 * Copyright (c) 2006 by RD2, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

//
// Function to calculate the number of working days (YYYY-MM-DD)
function workDays($start, $end)
{
  global $tableCollab, $countEnregTotal;
  $tmpquery = "SELECT * FROM " . $tableCollab['workcalendar'] . " WHERE date>='$start' AND date<='$end' AND hours>0";
  compt($tmpquery);
  return $countEnregTotal;
}

//
// Function to get the headings containg the date
function getDateArray($first, $last, $full=true)
{
    $DateArr[] = lang_strings('project');
    $DateArr[] = lang_strings('task');

    //Convert dates to php format
    while ($first<=$last)
    {
        if ($full) {
            $DateArr[]=$first;
        } else {
            $DateArr[]=date("d",strtotime($first));
        }

        $first=date("Y-m-d", strtotime("+1 days", strtotime($first)));
    }

    return $DateArr;
}

$checkSession = true;
require_once("../includes/library.php");
require_once("../themes/" . THEME . "/header.php");

// today's date
$datenow = date("Y-m-d");

// set up the member selection
if ($_POST['S_ATSEL']) {
    if ($_POST['S_ATSEL'] == 'ALL') {
        $S_mem = "ALL";
    } else {
        $S_mem = implode (',', $_POST['S_ATSEL']);
    }
} else {
    $S_mem = "ALL";
}

// get the range start date (or default to today)
if ($_POST{'S_SDATE2'}) {
    $s_sdate2 = $_POST{'S_SDATE2'};
} else {
    $s_sdate2 = date('Y-m-d');
}
// get the range end date (or default to end of month)
if ($_POST{'S_EDATE2'}) {
    $s_edate2 = $_POST{'S_EDATE2'};
} else {
    $year = date('Y');
    $month = date('m');
    $month++;
    if ($month == '13') {
        $year++;
        $month = '1';
    }
    $s_edate2 = date('Y-m-d', (mktime(0, 0, 0, $month, 1, $year) - 1));
}

//
// Breadcrumb block
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?', lang_strings('reports'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?typeReports=create', lang_strings("create_report"), in) . ' | ' . $blockPage->buildLink('../reports/createreport.php?typeReports=custom', lang_strings('custom_reports'), in) . ' | ' . $blockPage->buildLink("../reports/listreports.php?", lang_strings("my_reports"), in));
$blockPage->itemBreadcrumbs(lang_strings("member_allocation"));
$blockPage->closeBreadcrumbs();
$blockPage->heading(lang_strings('member_allocation'));

//
// Query to list only open projects (scheduled) and open or not started
// tasks (currently being worked on or scheduled to be worked on).
if ($S_mem == "ALL" || $S_mem == "") {
    $tmpquery = " AND mem.id != '2' AND mem.profil NOT IN ('" . PF_CLIENT_USER . "','" . PF_DISABLED . "','" . PF_DELETED . "') AND tas.status IN (" . ST_NOT_STARTED . "," . ST_OPEN . ") AND pro.status='" . ST_OPEN . "' AND tas.start_date<='$s_edate2' AND tas.due_date>='$s_sdate2' ORDER BY pro.name,tas.name";
} else {
    $tmpquery = " AND res.resource IN ($S_mem) AND tas.status IN (" . ST_NOT_STARTED . "," . ST_OPEN . ") AND pro.status='" . ST_OPEN . "' AND tas.start_date<='$s_edate2' AND tas.due_date>='$s_sdate2' ORDER BY pro.name,tas.name";
}

$listTaskHumanResource = new request();
$listTaskHumanResource->openTaskHumanResource($tmpquery);
$comptListTaskHumanResource = count($listTaskHumanResource->res_id);

//
// Display Member that was selected
if ($S_mem == "ALL" || $S_mem == "") {
    $tmpquery = "WHERE mem.id != '2' AND mem.profil NOT IN ('" . PF_CLIENT_USER . "','" . PF_DISABLED . "','" . PF_DELETED . "') ORDER BY mem.name";
} else {
    $tmpquery = " WHERE mem.id IN ($S_mem) ORDER BY mem.name";
}

$listMembers = new request();
$listMembers->openMembers($tmpquery);
$comptListMembers = count($listMembers->mem_id);

// start the first block
$block1 = new block();
$block1->form = "xmaT";
$block1->openForm("../reports/member_allocation.php#" . $block1->form . "Anchor");
$block1->openContent();
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListTaskHumanResource == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListTaskHumanResource == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListTaskHumanResource . " " . lang_strings("matches"));
}

$block0->closeContent();
echo "<input type=\"hidden\" name=\"S_ATSEL\" value=\"$S_mem\">";
echo "<input type=\"hidden\" name=\"S_SDATE2\" value=\"$s_sdate2\">";
echo "<input type=\"hidden\" name=\"S_EDATE2\" value=\"$s_edate2\">";

if ($comptListTaskHumanResource != "0") {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", lang_strings("export"));
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $block1->paletteScript(0, "export", "../reports/exportma.php?S_ATSEL=$S_mem&S_SDATE2=$s_sdate2&S_EDATE2=$s_edate2", "true,false,false", lang_strings("export"));
    $block1->closePaletteScript($comptListMembers, $listMembers->mem_id);

    $tmpquery = " WHERE wca.date>='$s_sdate2' AND wca.date<='$s_edate2'";
    $listWorkCalendar = new request();
    $listWorkCalendar->openWorkCalendar($tmpquery);
    $comptListWorkCalendar = count($listWorkCalendar->wca_id);

    for ($i=0; $i<$comptListWorkCalendar; $i++) {
        $listWorkHours[$listWorkCalendar->wca_date[$i]] = $listWorkCalendar->wca_hours[$i];
    }

    for ($j=0; $j<$comptListMembers; $j++) {
        //
        // Initialize Member level variables
        $memberName = $listMembers->mem_name[$j];
        $memberId = $listMembers->mem_id[$j];
        $overdueHours = 0;

        //
        // Query to list only open projects (scheduled) and open or not started
        // tasks (currently being worked on or scheduled to be worked on).
        $tmpquery = " AND res.resource='$memberId' AND tas.status IN (" . ST_NOT_STARTED . "," . ST_OPEN . ") AND pro.status='" . ST_OPEN . "' AND tas.start_date<='$s_edate2' AND tas.due_date>='$s_sdate2' ORDER BY pro.name,tas.name";
        $listTaskHumanResource = new request();
        $listTaskHumanResource->openTaskHumanResource($tmpquery);
        $comptListTaskHumanResource = count($listTaskHumanResource->res_id);

        if ($comptListTaskHumanResource != "0") {
            //
            // Block for Member
            $block1->heading($memberName." - <i>".$s_sdate2." to ".$s_edate2."</i>");

            //
            // Member headers
            $lblDays = getDateArray($s_sdate2,$s_edate2,false);
            $lblDaysFull = getDateArray($s_sdate2,$s_edate2);
            $block1->openResults($checkbox = "false");
            $block1->labels($labels = $lblDays, "true");

            //
            // Initialize Member summary
            $sumHours[] = null;
            unset($sumHours);

            for ($a=0; $a<count($lblDays); $a++) {
                $sumHours[] = 0;
            }

            //
            // Sumarize Tasks on each Member
            $taskName = null;

            for ($k=0; $k<$comptListTaskHumanResource; $k++) {
                //
                // Populate task level information
                $projectName = $listTaskHumanResource->res_pro_name[$k];
                $taskName = $listTaskHumanResource->res_tas_name[$k];
                $taskEst = $listTaskHumanResource->res_tas_estimated_time[$k];
                $taskStartDate = $listTaskHumanResource->res_tas_start_date[$k];
                $taskEndDate = $listTaskHumanResource->res_tas_due_date[$k];

                //
                // Determine future number of days left.
                if ($taskStartDate <= $s_sdate2) {
                    $numWorkDays = workDays($s_sdate2, $taskEndDate);
                } else {
                    $numWorkDays = workDays($taskStartDate, $taskEndDate);
                }

                //
                // Calculate daily hours depending on task percent complete and member percent support.  Negative numHoursPerDay means its past due
                if ($numWorkDays > 0) {
                    $numHoursPerDay = round($taskEst / $numWorkDays,2) * ((10 - $listTaskHumanResource->res_tas_completion[$k]) * 0.1) * $listTaskHumanResource->res_support[$k] * 0.1;
                } else {
                    $numHoursPerDay = 0;
                    $overdueHours += round($taskEst,2) * ((10 - $listTaskHumanResource->res_tas_completion[$k]) * 0.1) * $listTaskHumanResource->res_support[$k] * 0.1;
                }
            
                // Print hours allocated to each day, do not start from first two indexes.
                // Comparisons for date are made on string (YYYY-MM-DD)
                $showRow = false;

                for ($l=2; $l<count($lblDays); $l++) {
                    if (($taskStartDate<=$lblDaysFull[$l]) && ($taskEndDate>=$lblDaysFull[$l])) {
                        $showRow = true;
                    }
                }

                if ($showRow) {
                    $block1->openRow();
                    $block1->checkboxRow(null, $checkbox = "false");
                    $block1->cellRow($projectName);
                    $block1->cellRow($taskName);

                    for ($l=2; $l<count($lblDays); $l++) {
                        if ($listWorkHours[$lblDaysFull[$l]] > 0) {
                            if (($taskStartDate<=$lblDaysFull[$l]) && ($taskEndDate>=$lblDaysFull[$l])) {
                                $block1->cellRow($numHoursPerDay);
                                $sumHours[$l] += $numHoursPerDay;
                            } else {
                                $block1->cellRow(0);
                            }
                        } else {
                            $block1->cellRow(null);
                        }
                    }

                    $block1->closeRow();
                }
            }

            //
            // Summary blank row
            $block1->openRow();
            $block1->checkboxRow(null, $checkbox = "false");

            for ($l=0; $l<count($lblDays); $l++) {
                $block1->cellRow(null);
            }

            $block1->closeRow();
        
            //
            // Summary title row
            $block1->openRow();
            $block1->checkboxRow(null, $checkbox = "false");
            $block1->cellRow("<strong>" . lang_strings('ru_total_mem') . "</strong>");

            for ($l=1; $l<count($lblDays); $l++) {
                $block1->cellRow(null);
            }

            $block1->closeRow();

            //
            // Summary daily totals row
            $block1->openRow();
            $block1->checkboxRow(null, $checkbox = "false");
            $block1->cellRow(null);
            $block1->cellRow(lang_strings('daily_total') . ":");

            for ($l=2; $l<count($lblDays); $l++) {
                if ($listWorkHours[$lblDaysFull[$l]] > 0) {
                    if ($sumHours[$l] >= $listWorkHours[$lblDaysFull[$l]]) {
                        $block1->cellRow('<strong>' . $sumHours[$l] . '</strong>');
                    } else {
                        $block1->cellRow($sumHours[$l]);
                    }
                } else {
                    $block1->cellRow(null);
                }
            }

            $block1->closeRow();

            //
            // Summary past required hours row
            $block1->openRow();
            $block1->checkboxRow(null, $checkbox = "false");
            $block1->cellRow(null);
            $block1->cellRow(lang_strings('overdue_hours') . ": $overdueHours");

            for ($l=2; $l<count($lblDays); $l++) {
                $block1->cellRow(null);
            }

            $block1->closeRow();
            $block1->closeResults();
            echo "<p><br></p>";
        }
    }
} else {
    $block1->noresults();
}

//
// Display a description of the report
/*
$block0 = new block();
$block0->openContent();
$block0->contentTitle($strings["report_description"]);
$block0->contentRow(null,"<i>Member resource allocation report is shown within date range supplied on previous screen.  This report is summarized by employee and used for determining an individuals future workload.  Only current non-disabled and non-client users are selectable and only open projects and tasks are shown.  Daily hours for a task are calculated by taking the start and end date, determine the number of working days in that range, then spreading the estimated hours over that time period.  When the start date has past, then the remaining days and remaining percent complete are used to calculate a tasks resouce allocated hours required.  At the bottom of each employee, the daily hours required is displayed which is the total number of man hours required.  For example if a report shows that 16 hours are required daily for an employee then RD2 needs to look at reallocating that persons workload.</i>");
$block0->contentRow("<strong>Tasks</strong>","Current open project names and task names that have time required in that timeframe.");
$block0->contentRow("<strong>Dates</strong>","The day number within the timeframe selected on the previous report screen.  Estimated hours for that particular task are given on a daily basis.");
$block0->contentRow("<strong>Daily Totals</strong>","The total number of estimated hours required per day for this particular employee.  This number is used to determine workload and resource requirements for RD2.");
$block0->contentRow("<strong>Overdue Hours</strong>","The total number of hours for work that has not been completed and is now past due.  If this number is anything but zero, then tasks assigned to that person are late on their delivery and still not complete.");
$block0->closeContent();
*/

// close block1
$block1->closeFormResults();
require_once("../themes/" . THEME . "/footer.php");

?>
