<?php // $Revision: 1.6.2.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * Author: Michael Cook <michael@ink.org>
 * Date:   07-14-2003
 * 
 * $Id: overdue.php,v 1.6.2.1 2007/02/10 04:33:01 luis Exp $
 * 
 * Copyright (c) 2003 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * ../reports/overdue.php
 * 
 * show tasks which are overdue
 */
// configuration options
// today's date
$datenow = date("Y-m-d");
// end of configuration
$checkSession = true;
require_once("../includes/library.php");
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?', lang_strings('reports'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?typeReports=create', lang_strings("create_report"), in) . ' | ' . $blockPage->buildLink('../reports/createreport.php?typeReports=custom', lang_strings('custom_reports'), in) . ' | ' . $blockPage->buildLink("../reports/listreports.php?", lang_strings("my_reports"), in));
$blockPage->itemBreadcrumbs(lang_strings("overdue_tasks"));
$blockPage->closeBreadcrumbs();

// start the first block
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/overdue.php#" . $block1->form . "Anchor");
$block1->openContent();
$block1->sorting("home_tasks", $sortingUser->sor_home_tasks[0], "tas.priority DESC", $sortingFields = array(0 => "tas.name", 1 => "pro.name", 2 => "tas.status", 3 => "tas.completion", 4 => "tas.due_date", 5 => "tas.assigned_to", 6 => "tas.priority"));

if ($projectsFilter=='true' && $profilSession!=PF_ADMINISTRATOR && $profilSession!=PF_PROJECT_MANAGER_ADMINISTRATOR && $profilSession!=PF_HR_MANAGER) {
    $query = " WHERE tas.project IN (SELECT tea.project FROM " . $tableCollab["teams"] . " tea WHERE tea.member='$idSession') AND tas.status <> '" . ST_COMPLETED . "' and (tas.due_date < '$datenow' AND tas.due_date <> '--')";
} else {
    $query = " WHERE tas.status <> '" . ST_COMPLETED . "' and (tas.due_date < '$datenow' AND tas.due_date <> '--')";
}

$queryS = " ORDER BY $block1->sortingValue";
$listTasks = new request();
$listTasks->openHierarchyOfTasks($query, $queryS);
$comptListTasks = count($listTasks->tas_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListTasks == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListTasks == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListTasks . " " . lang_strings("matches"));
}

$block0->closeContent();
// set up the header string
$block1->heading(lang_strings('overdue_tasks'));

if ($comptListTasks != "0") {
    $block1->openResults($checkbox = "false");
    $block1->labels($labels = array(0 => lang_strings("task"), 1 => lang_strings("project"), 2 => lang_strings("status"), 3 => lang_strings("completion"), 4 => lang_strings("due_date"), 5 => lang_strings("assigned_to"), 6 => lang_strings("priority")), "true");

    for ($i = 0;$i < $comptListTasks;$i++) {
        if ($listTasks->tas_due_date[$i] == "") {
            $listTasks->tas_due_date[$i] = lang_strings("none");
        } 

        $idStatus = $listTasks->tas_status[$i];
        $idPriority = $listTasks->tas_priority[$i];
        $complValue = ($listTasks->tas_completion[$i] > 0) ? $listTasks->tas_completion[$i] . "0 %": $listTasks->tas_completion[$i] . " %";
        $block1->openRow();
        $block1->checkboxRow($listTasks->tas_id[$i], $checkbox = "false");
        $leadingSpace = '';
        for ($j = 0;$j < $listTasks->tas_level[$i];$j++) {
            $leadingSpace .= '&nbsp;&nbsp;';
        }
        $block1->cellRow($leadingSpace . $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i], in));
        $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listTasks->tas_project[$i], $listTasks->tas_pro_name[$i], in));
        $block1->cellRow($status[$idStatus]);
        $block1->cellRow($complValue);
        $block1->cellRow($listTasks->tas_due_date[$i]);

        if ($listTasks->tas_assigned_to[$i] == "0") {
            $block1->cellRow(lang_strings("unassigned"));
        } else {
            $tmpquery = " AND res.task='" . $listTasks->tas_id[$i] . "'";
            $resourceUsage = new request();
            $resourceUsage->openTaskHumanResource($tmpquery);
            $comptResourceUsage = count($resourceUsage->res_id);

            $assignedToStrings = "";
            for ($j = 0;$j < $comptResourceUsage;$j++) {
                if ($j > 0) {
                    $assignedToStrings .= "&nbsp;";
                }

                $assignedToStrings .= $blockPage->buildLink($resourceUsage->res_mem_email_work[$j], $resourceUsage->res_mem_login[$j], mail);
            }

            $block1->cellRow($assignedToStrings);
        } 

        $block1->cellRow('<img src="../themes/' . THEME . '/gfx_priority/' . $idPriority . '.gif" alt="' . $priority[$idPriority] . '">&nbsp;' . $priority[$idPriority], '', true);
        $block1->closeRow();
    } 

    $block1->closeResults();
} else {
    $block1->noresults();
} 
// close block1
$block1->closeFormResults();

require_once("../themes/" . THEME . "/footer.php");

?>
