<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: person_performance.php,v 1.7 2006/07/03 06:05:29 luis Exp $
 * 
 * Copyright (c) 2004 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * ../reports/person_performance.php
 * 
 */
// configuration options
// set up the member selection
if ($_POST['S_ATSEL']) {
    if ($_POST['S_ATSEL'] == 'ALL') {
        $S_mem = "ALL";
    } else {
        $S_mem = implode (',', $_POST['S_ATSEL']);
    }
} else {
    $S_mem = "ALL";
}

// a date range was selected
if ($_POST{'S_COMPLETEDATE'} == 'DATERANGE') {
    $dateRange = true; 

    // get the range start date (if given)
    if ($_POST{'S_SDATE2'}) {
        $s_sdate2 = $_POST{'S_SDATE2'};
    } else {
        $s_sdate2 = date("Y-m-d",
            mktime (12, 0, 0, date("m"), "1", date("Y")));
    }

    // get the range end date
    if ($_POST{'S_EDATE2'}) {
        $s_edate2 = $_POST{'S_EDATE2'};
    } else {
        $s_edate2 = date("Y-m-d",
            mktime (12, 0, 0, date("m"), date("d"), date("Y")));
    }
} else {
    // select all dates
    $dateRange = false;
}

// set up the evaluation value selection
if ($_POST['S_EVSEL']) {
    if ($_POST['S_EVSEL'] == 'ALL') {
        $S_eval = "ALL";
    } else {
        $S_eval = implode (',', $_POST['S_EVSEL']);
    }
} else {
    $S_eval = "ALL";
}
// end of configuration

$checkSession = true;
require_once("../includes/library.php");
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?', lang_strings('reports'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?typeReports=create', lang_strings("create_report"), in) . ' | ' . $blockPage->buildLink('../reports/createreport.php?typeReports=custom', lang_strings('custom_reports'), in) . ' | ' . $blockPage->buildLink("../reports/listreports.php?", lang_strings("my_reports"), in));
$blockPage->itemBreadcrumbs(lang_strings("person_performance_report"));
$blockPage->closeBreadcrumbs();
// start the first block
$block1 = new block();
$block1->form = "xwpP";
$block1->openForm("../reports/person_performance.php#" . $block1->form . "Anchor");
$block1->openContent();
$query = "WHERE eva.submitted = '" . PE_SUBMITTED . "'";

// a date range was selected
if ($dateRange) {
    $query .= " AND (eva.modified <= '$s_edate2'  AND eva.modified >= '$s_sdate2')";
}

// a member selection was made
if ($S_mem != 'ALL' && $S_mem != "") {
    $query .= " AND eva.member IN($S_mem)";
}

// an evaluation value selection was made
if ($S_eval != 'ALL') {
    $query .= " AND eva.value IN ($S_eval)";
}

$tmpquery = "$query ORDER BY mem2.name,eva.modified";
$listPersonEvaluations = new request();
$listPersonEvaluations->openPersonEvaluations($tmpquery);
$comptListPersonEvaluations = count($listPersonEvaluations->eva_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListPersonEvaluations == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListPersonEvaluations == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListPersonEvaluations . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListPersonEvaluations != "0") {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", lang_strings("export"));
    $block1->closePaletteIcon();
    $block1->openPaletteScript();
    $exportOptions = "";

    // handle date ranges
    if ($dateRange) {
        if ($exportOptions != "") {
            $exportOptions = "&S_COMPLETEDATE=DATERANGE&S_SDATE2=$s_sdate2&S_EDATE2=$s_edate2";
        } else {
            $exportOptions = "S_COMPLETEDATE=DATERANGE&S_SDATE2=$s_sdate2&S_EDATE2=$s_edate2";
        }
    }

    // a member selection was made
    if ($S_mem != 'ALL') {
        if ($exportOptions != "") {
            $exportOptions .= "&S_ATSEL=$S_mem";
        } else {
            $exportOptions .= "S_ATSEL=$S_mem";
        }
    }

    // an evaluation value selection was made
    if ($S_eval != 'ALL') {
        if ($exportOptions != "") {
            $exportOptions .= "&S_EVSEL=$S_eval";
        } else {
            $exportOptions .= "S_EVSEL=$S_eval";
        }
    }

    $block1->paletteScript(0, "export", "../reports/export_person_performance.php?$exportOptions", "true,false,false", lang_strings("export"));
    $block1->closePaletteScript($comptListPersonEvaluation, $listPersonEvaluations->eva_id);
}

// set up the header string
$block1HeadingText = lang_strings("person_evaluation") . " ";

if ($dateRange) {
    $block1HeadingText .= lang_strings("hours_logged_from") . " " . $s_sdate2 . " " . lang_strings("hours_logged_to") . " " . $s_edate2;
}

$block1->heading($block1HeadingText);

// initialize counters
foreach ($personEvaluationValueArray as $idx => $val) {
    $totalMemValue[$idx] = 0;
}

echo "<input type=\"hidden\" name=\"S_mem\" value=\"$S_mem\">";
echo "<input type=\"hidden\" name=\"S_eval\" value=\"$S_eval\">";
echo "<input type=\"hidden\" name=\"dateRange\" value=\"$dateRange\">";
echo "<input type=\"hidden\" name=\"s_sdate2\" value=\"$s_sdate2\">";
echo "<input type=\"hidden\" name=\"s_edate2\" value=\"$s_edate2\">";

if ($comptListPersonEvaluations != "0") {
    $lastMember = $listPersonEvaluations->eva_mem2_name[0];
    $block1->openResults($checkbox = "false");
    $block1->labels($labels = array(0 => lang_strings("member"), 1 => lang_strings("type"), 2 => lang_strings("item"), 3 => lang_strings("appraiser"), 4 => lang_strings("date"), 5 => lang_strings("value")), "false");

    for ($i = 0;$i < $comptListPersonEvaluations;$i++) {
        if ($lastMember != $listPersonEvaluations->eva_mem2_name[$i]) {
            foreach ($personEvaluationValueArray as $idx => $val) {
                if ($totalMemValue[$idx] == 0) continue;

                // print the totals
                $block1->openRow();
                $block1->checkboxRow($listPersonEvaluations->eva_id[$i], $checkbox = "false");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow($val['display'] . ":");
                $block1->cellRow($totalMemValue[$idx]);
                $block1->closeRow();
                $totalMemValue[$idx] = 0;
            }

            $lastMember = $listPersonEvaluations->eva_mem2_name[$i];
        }

        if ($listPersonEvaluations->eva_type[$i] == 0) {
            $tmpquery = "WHERE tas.id='" . $listPersonEvaluations->eva_item[$i] . "'";
            $taskDetail = new request();
            $taskDetail->openTasks($tmpquery);
            $itemContent = $taskDetail->tas_name[0];

            if ($taskDetail->tas_type[0] >= 0)
                $itemContent .= " (" . $personEvaluationItemArraySets['sets'][$taskDetail->tas_type[0]] . ")";
        } else {
            $itemContent = $personEvaluationItemArraySets['sets'][$listPersonEvaluations->eva_item[$i]];
        }

        $block1->openRow();
        $block1->checkboxRow($listPersonEvaluations->eva_id[$i], $checkbox = "false");
        $block1->cellRow($listPersonEvaluations->eva_mem2_name[$i]);
        $block1->cellRow($personEvaluationTypeArray[$listPersonEvaluations->eva_type[$i]]);
        $block1->cellRow($itemContent);
        $block1->cellRow($listPersonEvaluations->eva_mem_name[$i]);
        $block1->cellRow($listPersonEvaluations->eva_modified[$i]);
        $block1->cellRow($personEvaluationValueArray[$listPersonEvaluations->eva_value[$i]]['display']);
        $block1->closeRow(); 
        // add to total evaluation value
        $totalMemValue[$listPersonEvaluations->eva_value[$i]]++;
    }

    foreach ($personEvaluationValueArray as $idx => $val) {
        if ($totalMemValue[$idx] == 0) continue;

        // print the totals
        $block1->openRow();
        $block1->checkboxRow($listPersonEvaluations->eva_id[$i], $checkbox = "false");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow($val['display'] . ":");
        $block1->cellRow($totalMemValue[$idx]);
        $block1->closeRow();
    }

    $block1->closeResults();
} else {
    $block1->noresults();
}

// close block1
$block1->closeFormResults();
require_once("../themes/" . THEME . "/footer.php");

?>
