<?php // $Revision: 1.3.2.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: projectbreakdown.php,v 1.3.2.1 2007/02/10 04:33:01 luis Exp $
 * 
 * Copyright (c) 2003 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * ../reports/projectbreakdown.php
 * 
 * list projects by manager
 * 
 * TODO: add export to CSV capabilities
 */
// configuration options
// end of configuration
$checkSession = true;
require_once("../includes/library.php");
require_once("../themes/" . THEME . "/header.php");

$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?', lang_strings('reports'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?typeReports=create', lang_strings("create_report"), in) . ' | ' . $blockPage->buildLink('../reports/createreport.php?typeReports=custom', lang_strings('custom_reports'), in) . ' | ' . $blockPage->buildLink("../reports/listreports.php?", lang_strings("my_reports"), in));
$blockPage->itemBreadcrumbs(lang_strings("project_breakdown"));
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messagebox($msgLabel);
}

if ($projectsFilter=='true' && $profilSession!=PF_ADMINISTRATOR && $profilSession!=PF_PROJECT_MANAGER_ADMINISTRATOR && $profilSession!=PF_HR_MANAGER) {
    $query = " WHERE pro.id IN (SELECT tea.project FROM " . $tableCollab["teams"] . " tea WHERE tea.member='$idSession')";
}

// start the first block
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/projectbreakdown.php#" . $block1->form . "Anchor");
$block1->openContent();
$block1->sorting("projects", $sortingUser->sor_projects[0], "mem.name ASC", $sortingFields = array(0 => "mem.name", 1 => "pro.name", 2 => "org.name", 3 => "pro.status"));
$tmpquery = "$query ORDER BY $block1->sortingValue";
$listProjects = new request();
$listProjects->openProjects($tmpquery);
$comptListProjects = count($listProjects->pro_id);
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListProjects == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} 

if ($comptListProjects == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} 

if ($comptListProjects > "1") {
    $block1->contentRow("", $comptListProjects . " " . lang_strings("matches"));
} 

$block0->closeContent();

/*
$block1->openPaletteIcon();
$block1->paletteIcon(0,"export",lang_strings("export"));
$block1->closePaletteIcon();

$block1->openPaletteScript();
$block1->paletteScript(0,"export","../reports/exportcompleted.php?s_date2=$s_date2&","true,false,false",lang_strings("export"));
$block1->closePaletteScript($comptListOrganizations,$listOrganizations->org_id);
*/
// set up the header string
$headerString = lang_strings('project_breakdown');

$block1->heading($headerString);

if ($comptListProjects != "0") {
    $block1->openResults($checkbox = "false");
    $block1->labels($labels = array(0 => lang_strings("owner"), 1 => lang_strings("project"), 2 => lang_strings("organization"), 3 => lang_strings("status")), "false");

    for ($i = 0;$i < $comptListProjects;$i++) {
        $idStatus = $listProjects->pro_status[$i];
        $block1->openRow();
        $block1->checkboxRow($listProjects->pro_id[$i], $checkbox = "false");

        if ($listProjects->pro_owner[$i] == "0") {
            $block1->cellRow(lang_strings("unassigned"));
        } else {
            $block1->cellRow($blockPage->buildLink($listProjects->pro_mem_email_work[$i], $listProjects->pro_mem_name[$i], mail));
        } 

        $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listProjects->pro_id[$i], $listProjects->pro_name[$i], in));
        $block1->cellRow($blockPage->buildLink("../clients/viewclient.php?id=" . $listProjects->pro_org_id[$i], $listProjects->pro_org_name[$i], in)); 
        // $block1->cellRow($listProjects->pro_status[$i]);
        $block1->cellRow('<img src="../themes/' . THEME . '/gfx_status/' . $idStatus . '.gif" alt="' . $status[$idStatus] . '">&nbsp;' . $status[$idStatus], '', true);
        $block1->closeRow();
    } 

    $block1->closeResults();
} else {
    $block1->noresults();
} 

$block1->closeFormResults(); 
// close this block
require_once("../themes/" . THEME . "/footer.php");

?>
