<?php // $Revision: 1.8 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: resource_usage.php,v 1.8 2006/06/29 14:34:38 luis Exp $
 * 
 * Copyright (c) 2003 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * ../reports/resource_usage.php
 * 
 * display total hours logged in a given time frame by project and
 * organization
 */
// configuration options
// set up the member selection
if ($S_mem == "") {
    if ($_POST['S_ATSEL']) {
        if ($_POST['S_ATSEL'] == 'ALL') {
            $S_mem = "ALL";
        } else {
            $S_mem = implode (',', $_POST['S_ATSEL']);
        } 
    } else {
        $S_mem = "ALL";
    } 
}
// a date range was selected
if ($dateRange == "") {
    if ($_POST{'S_COMPLETEDATE'} == 'DATERANGE') {
        $dateRange = true; 
        // get the range start date (if given)
        if ($_POST{'S_SDATE2'}) {
            $s_sdate2 = $_POST{'S_SDATE2'};
        } else {
            $s_sdate2 = date("Y-m-d",
                mktime (12, 0, 0, date("m"), "1", date("Y")));
        } 
        // get the range end date
        if ($_POST{'S_EDATE2'}) {
            $s_edate2 = $_POST{'S_EDATE2'};
        } else {
            $s_edate2 = date("Y-m-d",
                mktime (12, 0, 0, date("m"), date("d"), date("Y")));
        } 
    } else {
        // select all dates
        $dateRange = false;
    } 
}
// display itemized member hours
if ($displayMemHourItems == "") {
    if ($_REQUEST['S_MEMITEM']) {
        $displayMemHourItems = true;
    } else {
        $displayMemHourItems = false;
    }
} 
// display total project hours
if ($displayProjTotals == "") {
    if ($_REQUEST['S_PROJTOTAL']) {
        $displayProjTotals = true;
    } else {
        $displayProjTotals = false;
    } 
}
// display total project hours
if ($displayOrgTotals == "") {
    if ($_REQUEST['S_ORGTOTAL']) {
        $displayOrgTotals = true;
    } else {
        $displayOrgTotals = false;
    } 
}
// display total member hours for project
if ($displayMemTotals == "") {
    if ($_REQUEST['S_MEMTOTAL']) {
        $displayMemTotals = true;
    } else {
        $displayMemTotals = false;
    } 
}
// display total member hours for period
if ($displayMemPTotals == "") {
    if ($_REQUEST['S_MEMPTOTAL']) {
        $displayMemPTotals = true;
    } else {
        $displayMemPTotals = false;
    } 
}
// billing selection
if ($billingSelection == "") {
    $billingSelection = $_POST{'S_BILLING'};
}
// end of configuration
$checkSession = true;
require_once("../includes/library.php");

require_once("../themes/" . THEME . "/header.php");

$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?', lang_strings('reports'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?typeReports=create', lang_strings("create_report"), in) . ' | ' . $blockPage->buildLink('../reports/createreport.php?typeReports=custom', lang_strings('custom_reports'), in) . ' | ' . $blockPage->buildLink("../reports/listreports.php?", lang_strings("my_reports"), in));
$blockPage->itemBreadcrumbs(lang_strings("resource_usage"));
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messagebox($msgLabel);
} 
// start the first block
$block1 = new block();
$block1->form = "xwbT";
$block1->openForm("../reports/selectru.php#" . $block1->form . "Anchor");
$block1->openContent();
// handle date ranges, if supplied
if ($dateRange) {
    if ($query != "") {
        $query .= "AND (tim.date <= '$s_edate2'  AND tim.date >= '$s_sdate2')";
    } else {
        $query .= "WHERE (tim.date <= '$s_edate2'  AND tim.date >= '$s_sdate2')";
    } 
} 
// a member selection was made
if ($S_mem != 'ALL' && $S_mem != "") {
    if ($query != "") {
        $query .= " AND tim.owner IN($S_mem)";
    } else {
        $query .= "WHERE tim.owner IN($S_mem)";
    } 
} 
// billing selection
if ($billingSelection != 'ALL') {
    if ($query != "") {
        $query1 = " AND tim.billing='$billingSelection'";
    } else {
        $query1 = "WHERE tim.billing='$billingSelection'";
    }
}

$comptListHours = 0;

$tmpquery = $query . $query1;
$listHours1 = new request();
$listHours1->openTaskTime($tmpquery);
$comptListHours1 = count($listHours1->tim_id);
for ($i=0; $i<$comptListHours1; $i++) {
    $listHours->tim_id[$comptListHours] = $listHours1->tim_id[$i];
    $listHours->tim_org_name[$comptListHours] = $listHours1->tim_org_name[$i];
    $listHours->tim_project[$comptListHours] = $listHours1->tim_project[$i];
    $listHours->tim_pro_name[$comptListHours] = $listHours1->tim_pro_name[$i];
    $listHours->tim_pro_type[$comptListHours] = $listHours1->tim_pro_type[$i];
    $listHours->tim_owner[$comptListHours] = $listHours1->tim_owner[$i];
    $listHours->tim_mem_name[$comptListHours] = $listHours1->tim_mem_name[$i];
    $listHours->tim_date[$comptListHours] = $listHours1->tim_date[$i];
    $listHours->tim_task_name[$comptListHours] = $listHours1->tim_task_name[$i];
    $listHours->tim_hours[$comptListHours] = $listHours1->tim_hours[$i];
    $comptListHours++;
}

if ($billingSelection != BF_YES) {
    $tmpquery = str_replace("tim", "mti", $query);
    $tmpquery = str_replace("tas", "mee", $tmpquery);
    $listHours1 = new request();
    $listHours1->openMeetingTime($tmpquery);
    $comptListHours1 = count($listHours1->mti_id);
    for ($i=0; $i<$comptListHours1; $i++) {
        $listHours->tim_id[$comptListHours] = $listHours1->mti_id[$i];
        $listHours->tim_org_name[$comptListHours] = $listHours1->mti_org_name[$i];
        $listHours->tim_project[$comptListHours] = $listHours1->mti_project[$i];
        $listHours->tim_pro_name[$comptListHours] = $listHours1->mti_pro_name[$i];
        $listHours->tim_pro_type[$comptListHours] = $listHours1->mti_pro_type[$i];
        $listHours->tim_owner[$comptListHours] = $listHours1->mti_owner[$i];
        $listHours->tim_mem_name[$comptListHours] = $listHours1->mti_mem_name[$i];
        $listHours->tim_date[$comptListHours] = $listHours1->mti_date[$i];
        $listHours->tim_task_name[$comptListHours] = $listHours1->mti_meeting_name[$i];
        $listHours->tim_hours[$comptListHours] = $listHours1->mti_hours[$i];
        $comptListHours++;
    }
}

$tmpquery = $query . $query1;
$tmpquery = str_replace("tim", "wkh", $tmpquery);
$tmpquery = str_replace("tas.name", "wkh.work", $tmpquery);

if ($tmpquery != "") {
    $tmpquery .= " AND wkh.project<>'0'";
} else {
    $tmpquery .= "WHERE wkh.project<>'0'";
}

$listHours1 = new request();
$listHours1->openWorkHours($tmpquery);
$comptListHours1 = count($listHours1->wkh_id);
for ($i=0; $i<$comptListHours1; $i++) {
    $listHours->tim_id[$comptListHours] = $listHours1->wkh_id[$i];
    if ($listHours1->wkh_project[$i] == 0) {
        $listHours->tim_org_name[$comptListHours] = '';
        $listHours->tim_project[$comptListHours] = '';
        $listHours->tim_pro_name[$comptListHours] = '';
        $listHours->tim_pro_type[$comptListHours] = '';
    } else {
        $listHours->tim_org_name[$comptListHours] = $listHours1->wkh_org_name[$i];
        $listHours->tim_project[$comptListHours] = $listHours1->wkh_project[$i];
        $listHours->tim_pro_name[$comptListHours] = $listHours1->wkh_pro_name[$i];
        $listHours->tim_pro_type[$comptListHours] = $listHours1->wkh_pro_type[$i];
    }
    $listHours->tim_owner[$comptListHours] = $listHours1->wkh_owner[$i];
    $listHours->tim_mem_name[$comptListHours] = $listHours1->wkh_mem_name[$i];
    $listHours->tim_date[$comptListHours] = $listHours1->wkh_date[$i];
    $listHours->tim_task_name[$comptListHours] = $hourCodeArray[$listHours1->wkh_work[$i]];
    $listHours->tim_hours[$comptListHours] = $listHours1->wkh_hours[$i];
    $comptListHours++;
}
array_multisort($listHours->tim_org_name, SORT_ASC, SORT_STRING, $listHours->tim_pro_name, SORT_ASC, SORT_STRING, $listHours->tim_mem_name, SORT_ASC, SORT_STRING, $listHours->tim_project, $listHours->tim_pro_type, $listHours->tim_owner, $listHours->tim_date, $listHours->tim_id, $listHours->tim_task_name, $listHours->tim_hours);

$block0 = new block();

$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListHours == "0") {
    $block1->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListHours == "1") {
    $block1->contentRow("", "1 " . lang_strings("match"));
} else {
    $block1->contentRow("", $comptListHours . " " . lang_strings("matches"));
} 

$block0->closeContent();

if ($comptListHours != "0") {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "export", lang_strings("export"));
    $block1->closePaletteIcon();

    $block1->openPaletteScript();

    $exportOptions = "";
    // handle date ranges
    if ($dateRange) {
        if ($exportOptions != "") {
            $exportOptions = "&S_COMPLETEDATE=DATERANGE&S_SDATE2=$s_sdate2&S_EDATE2=$s_edate2";
        } else {
            $exportOptions = "S_COMPLETEDATE=DATERANGE&S_SDATE2=$s_sdate2&S_EDATE2=$s_edate2";
        } 
    } 
    // a member selection was made
    if ($S_mem != 'ALL' && $S_mem != "") {
        if ($exportOptions != "") {
            $exportOptions .= "&S_ATSEL=$S_mem";
        } else {
            $exportOptions .= "S_ATSEL=$S_mem";
        } 
    } 
    // billing selection
    if ($exportOptions != "") {
        $exportOptions .= "&S_BILLING=$billingSelection";
    } else {
        $exportOptions .= "S_BILLING=$billingSelection";
    }

    $block1->paletteScript(0, "export", "../reports/exportru.php?$exportOptions", "true,false,false", lang_strings("export"));
    $block1->closePaletteScript($comptListHours, $listHours->tim_id);
}

// set up the header string
$block1HeadingText = lang_strings("ru_detail") . " ";
if ($dateRange) {
    $block1HeadingText .= lang_strings("ru_detail_from") . " " . $s_sdate2 . " " . lang_strings("ru_detail_to") . " " . $s_edate2;
}
$block1->heading($block1HeadingText);
// set up an organization name placeholder
$total_project_hours = 0;
$total_org_hours = 0;
$total_mem_hours = 0;
$total_task_hours = 0;
$project_name = "!@#$%^&*()";
$org_name = "!@#$%^&*()";
$mem_name = "!@#$%^&*()";
$task_name = "!@#$%^&*()";
$grand_total_member_hours = array();

echo "<input type=\"hidden\" name=\"S_mem\" value=\"$S_mem\">";
echo "<input type=\"hidden\" name=\"dateRange\" value=\"$dateRange\">";
echo "<input type=\"hidden\" name=\"s_sdate2\" value=\"$s_sdate2\">";
echo "<input type=\"hidden\" name=\"s_edate2\" value=\"$s_edate2\">";
echo "<input type=\"hidden\" name=\"displayMemHourItems\" value=\"$displayMemHourItems\">";
echo "<input type=\"hidden\" name=\"displayProjTotals\" value=\"$displayProjTotals\">";
echo "<input type=\"hidden\" name=\"displayOrgTotals\" value=\"$displayOrgTotals\">";
echo "<input type=\"hidden\" name=\"displayMemTotals\" value=\"$displayMemTotals\">";
echo "<input type=\"hidden\" name=\"displayMemPTotals\" value=\"$displayMemPTotals\">";
echo "<input type=\"hidden\" name=\"billingSelection\" value=\"$billingSelection\">";

if ($comptListHours != "0") {
    $block1->openResults($checkbox = "false");
    $block1->labels($labels = array(0 => lang_strings("organization"), 1 => lang_strings("project"), 2 => lang_strings("name"), 3 => lang_strings("task"), 4 => lang_strings("hours")), "true");

    for ($i = 0;$i < $comptListHours;$i++) {
        // NEW ORGANIZATION
        if ($org_name != $listHours->tim_org_name[$i]) {
            // this is a new organization
            // print the totalled hours
            if ($org_name != "!@#$%^&*()") {
                // display the individual task
                $nice_print = sprintf("%01.2f", $total_task_hours);

                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("<i>" . $mem_name . "</i>");
                $block1->cellRow("<i>" . $task_name . "</i>");
                $block1->cellRow("<i>$nice_print</i>");
                $block1->closeRow();
                // display the individual member
                if ($displayMemTotals) {
                    $nice_print = sprintf("%01.2f", $total_mem_hours);

                    $block1->openRow();
                    $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow("$mem_name");
                    $block1->cellRow(lang_strings('ru_subtotal'));
                    $block1->cellRow("$nice_print");
                    $block1->closeRow();
                } 
                // print the project totals
                if ($displayProjTotals) {
                    $block1->openRow();
                    $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow("<b>" . lang_strings('ru_total_project') . "</b>");
                    $nice_print = sprintf("%01.2f", $total_project_hours);
                    $block1->cellRow($nice_print);
                    $block1->closeRow();
                } 

                if ($displayOrgTotals) {
                    $block1->openRow();
                    $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow("<b>" . lang_strings('ru_total_org') . "</b>");
                    $nice_print = sprintf("%01.2f", $total_org_hours);
                    $block1->cellRow("<b>" . $nice_print . "</b>");
                    $block1->closeRow();
                } 
            } 
            // reset the counter
            $total_project_hours = 0;
            $project_name = $listHours->tim_pro_name[$i];
            $total_org_hours = 0;
            $org_name = $listHours->tim_org_name[$i];
            $total_mem_hours = 0;
            $mem_name = $listHours->tim_mem_name[$i]; 
            $total_task_hours = 0;
            $task_name = $listHours->tim_task_name[$i];
            // print a header row
            if ($org_name != "") {
                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow($org_name);
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->closeRow();
            }
            if ($project_name != "") {
                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow("");
                $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listHours->tim_project[$i], $listHours->tim_pro_name[$i], in));
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->closeRow();
            }
        } 
        // NEW PROJECT
        if ($project_name != $listHours->tim_pro_name[$i]) {
            // this is a new project
            // print the totalled hours
            if ($project_name != "!@#$%^&*()") {
                // display the individual task
                $nice_print = sprintf("%01.2f", $total_task_hours);

                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("<i>" . $mem_name . "</i>");
                $block1->cellRow("<i>" . $task_name . "</i>");
                $block1->cellRow("<i>$nice_print</i>");
                $block1->closeRow();
                // display the individual member
                if ($displayMemTotals) {
                    // this is a new member
                    // print the line for the other member
                    $nice_print = sprintf("%01.2f", $total_mem_hours);

                    $block1->openRow();
                    $block1->checkboxRow($listHours->tim_id[$i],
                        $checkbox = "false");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow($mem_name);
                    $block1->cellRow(lang_strings('ru_subtotal'));
                    $block1->cellRow($nice_print);
                    $block1->closeRow();
                } 
                if ($displayProjTotals) {
                    $block1->openRow();
                    $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow("<b>" . lang_strings('ru_total_project') . "</b>");
                    $nice_print = sprintf("<b>%01.2f</b>", $total_project_hours);
                    $block1->cellRow($nice_print);
                    $block1->closeRow();
                } 
            }
            // reset the counter
            $total_project_hours = 0;
            $project_name = $listHours->tim_pro_name[$i];
            $total_mem_hours = 0;
            $mem_name = $listHours->tim_mem_name[$i];
            $total_task_hours = 0;
            $task_name = $listHours->tim_task_name[$i];
            // print a new header row
            if ($project_name != "") {
                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow("");
                $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listHours->tim_project[$i], $listHours->tim_pro_name[$i], in));
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->closeRow(); 
            }
        } 
        // NEW MEMBER
        if ($mem_name != $listHours->tim_mem_name[$i]) {
            // this is a new member
            // print the line for the other member
            if ($mem_name != "!@#$%^&*()") {
                // display the individual task
                $nice_print = sprintf("%01.2f", $total_task_hours);

                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("<i>" . $mem_name . "</i>");
                $block1->cellRow("<i>" . $task_name . "</i>");
                $block1->cellRow("<i>$nice_print</i>");
                $block1->closeRow();
                if ($displayMemTotals) {
                    $nice_print = sprintf("%01.2f", $total_mem_hours);

                    $block1->openRow();
                    $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                    $block1->cellRow("");
                    $block1->cellRow("");
                    $block1->cellRow($mem_name);
                    $block1->cellRow(lang_strings('ru_subtotal'));
                    $block1->cellRow($nice_print);
                    $block1->closeRow();
                } 
            } 
            // reset the counter
            $total_mem_hours = 0;
            $mem_name = $listHours->tim_mem_name[$i];
            $total_task_hours = 0;
            $task_name = $listHours->tim_task_name[$i];
        } 
        // increment the grand total
        $grand_total_member_hours [$listHours->tim_owner[$i]] += $listHours->tim_hours[$i];

        // NEW TASK
        if ($task_name != $listHours->tim_task_name[$i]) {
            // this is a new task
            // print the line for the other task
            if ($task_name != "!@#$%^&*()") {
                $nice_print = sprintf("%01.2f", $total_task_hours);

                $block1->openRow();
                $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
                $block1->cellRow("");
                $block1->cellRow("");
                $block1->cellRow("<i>" . $mem_name . "</i>");
                $block1->cellRow("<i>" . $task_name . "</i>");
                $block1->cellRow("<i>$nice_print</i>");
                $block1->closeRow();
            }
            // reset the counter
            $total_task_hours = 0;
            $task_name = $listHours->tim_task_name[$i];
        }

        $total_task_hours += $listHours->tim_hours[$i];
        $total_mem_hours += $listHours->tim_hours[$i];
        $total_org_hours += $listHours->tim_hours[$i];
        $total_project_hours += $listHours->tim_hours[$i];
    } 
    // pick up the last straggler
    $nice_print = sprintf("%01.2f", $total_task_hours);

    $block1->openRow();
    $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
    $block1->cellRow("");
    $block1->cellRow("");
    $block1->cellRow("<i>" . $mem_name . "</i>");
    $block1->cellRow("<i>" . $task_name . "</i>");
    $block1->cellRow("<i>$nice_print</i>");
    $block1->closeRow();

    if ($displayMemTotals) {
        $nice_print = sprintf("%01.2f", $total_mem_hours);

        $block1->openRow();
        $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow($mem_name);
        $block1->cellRow(lang_strings('ru_subtotal'));
        $block1->cellRow($nice_print);
        $block1->closeRow();
    } 

    if ($displayProjTotals) {
        $block1->openRow();
        $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
        $block1->cellRow("");
        $block1->cellRow($blockPage->buildLink("../projects/viewproject.php?id=" . $listHours->$project_name, $listHours->tim_pro_name[$i], in));
        $block1->cellRow("");
        $block1->cellRow("<b>" . lang_strings('ru_total_project') . "</b>");
        $nice_print = sprintf("%01.2f", $total_project_hours);
        $block1->cellRow("<b>$nice_print</b>");
        $block1->closeRow();
    } 

    if ($displayOrgTotals) {
        $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow("<b>" . lang_strings('ru_total_org') . "</b>");
        $nice_print = sprintf("%01.2f", $total_org_hours);
        $block1->cellRow("<b>$nice_print</b>");
        $block1->closeRow();
    } 
    // show a member total
    if ($displayMemPTotals) {
        $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
        $block1->closeRow(); 
        $block1->checkboxRow($listHours->tim_id[$i], $checkbox = "false");
        $block1->cellRow("<b>" . lang_strings('ru_total_mem') . "</b>");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->cellRow("");
        $block1->closeRow(); 
        foreach ($grand_total_member_hours as $mem_id => $hrs) {
            $tmpquery = "WHERE mem.id = " . $mem_id;
            $listMembers = new request();
            $listMembers->openMembers($tmpquery);

            $mem_name = "Unknown";

            if ($listMembers->mem_name[0] != "") {
                $mem_name = $listMembers->mem_name[0];
            } 

            $nice_print = sprintf("%01.2f", $hrs);
            $block1->openRow();
            $block1->checkboxRow("", $checkbox = "false");
            $block1->cellRow("");
            $block1->cellRow("");
            $block1->cellRow("");
            $block1->cellRow($mem_name);
            $block1->cellRow($nice_print);
            $block1->closeRow();
        } 
    } 

    $block1->closeResults();
} else {
    $block1->noresults();
} 
// close block1
$block1->closeFormResults();

require_once("../themes/" . THEME . "/footer.php");

?>
