<?php // $Revision: 1.4.2.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * Author: Michael Cook <michael@ink.org>
 * Date:   07-14-2003
 * 
 * $Id: snapshot.php,v 1.4.2.1 2007/02/10 04:33:02 luis Exp $
 * 
 * Copyright (c) 2003 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * 
 * ../reports/snapshot.php
 * 
 * show a basic overview of all projects for a project manager
 */

$checkSession = true;
require_once("../includes/library.php");
require_once("../themes/" . THEME . "/header.php");

$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?', lang_strings('reports'), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink('../reports/createreport.php?typeReports=create', lang_strings("create_report"), in) . ' | ' . $blockPage->buildLink('../reports/createreport.php?typeReports=custom', lang_strings('custom_reports'), in) . ' | ' . $blockPage->buildLink("../reports/listreports.php?", lang_strings("my_reports"), in));
$blockPage->itemBreadcrumbs(lang_strings("project_snapshot"));
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messagebox($msgLabel);
}

$query = " WHERE pro.owner = '$idSession' and pro.status IN (" . ST_NOT_STARTED . "," . ST_OPEN . "," . ST_SUSPENDED . ")";
$tmpquery = "$query ORDER BY pro.name";
$listProjects = new request();
$listProjects->openProjects($tmpquery);
$comptListProjects = count($listProjects->pro_id);
// show the nice number-of-results header
$block0 = new block();
$block0->openContent();
$block0->contentTitle(lang_strings("report_results"));

if ($comptListProjects == "0") {
    $blockPage->contentRow("", "0 " . lang_strings("matches") . "<br>" . lang_strings("no_results_report"));
} else if ($comptListProjects == "1") {
    $blockPage->contentRow("", "1 " . lang_strings("match"));
} else {
    $blockPage->contentRow("", $comptListProjects . " " . lang_strings("matches"));
}

$block0->closeContent();

if ($comptListProjects != "0") {
    for ($j = 0;$j < $comptListProjects;$j++) {
        $projectTitle = $listProjects->pro_name[$j];
        $projectId = $listProjects->pro_id[$j];
        $projectPriority = $listProjects->pro_priority[$j];
        $blockProject = new block();
        $blockProject->openContent();
        $blockProject->heading($blockPage->buildLink("../projects/viewproject.php?id=" . $projectId, $projectTitle, in));
        $blockProject->contentTitle(lang_strings("details"));
        $blockProject->contentRow(lang_strings("priority"), "<img src=\"../themes/" . THEME . "/gfx_priority/" . $projectPriority . ".gif\" alt=\"\">&nbsp;" . $priority[$projectPriority]);
        $blockProject->contentRow(lang_strings("created"), createDate($listProjects->pro_created[$j], $timezoneSession));
        $blockProject->contentRow(lang_strings("modified"), createDate($listProjects->pro_modified[$j], $timezoneSession));

        if ($listProjects->pro_org_id[$j] == "1") {
            $blockProject->contentRow(lang_strings("organization"),
                lang_strings("none"));
        } else {
            $blockProject->contentRow(lang_strings("organization"), $blockPage->buildLink("../clients/viewclient.php?id=" . $listProjects->pro_org_id[$j], $listProjects->pro_org_name[$j], in));
        }

        $blockProject->contentRow(lang_strings("status"), $status[$listProjects->pro_status[$j]]);
        $queryTask = " WHERE tas.project = '$projectId'";
        $tmpqueryTask = "$queryTask ORDER BY tas.due_date";
        $listTasks = new request();
        $listTasks->openTasks($tmpqueryTask);
        $comptListTasks = count($listTasks->tas_id);

        if ($comptListTasks != "0") {
            $blockProject->openResults($checkbox = "false");
            $blockProject->labels($labels = array(0 => lang_strings("task"), 1 => lang_strings("priority"), 2 => lang_strings("status"), 3 => lang_strings("due_date"), 4 => lang_strings("completed"), 5 => lang_strings("assigned_to"), 6 => lang_strings("published")), "true");

            for ($i = 0;$i < $comptListTasks;$i++) {
                if ($listTasks->tas_due_date[$i] == "--" or
                    $listTasks->tas_due_date[$i] == "") {
                    $listTasks->tas_due_date[$i] = lang_strings("none");
                } 

                $idStatus = $listTasks->tas_status[$i];
                $idPriority = $listTasks->tas_priority[$i];
                $idPublished = $listTasks->tas_published[$i];
                $complValue = ($listTasks->tas_completion[$i] > 0) ? $listTasks->tas_completion[$i] . "0 %": $listTasks->tas_completion[$i] . " %";

                $blockProject->openRow();
                $blockProject->checkboxRow($listTasks->tas_id[$i], $checkbox = "false");
                $blockProject->cellRow($blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i], in));

                $blockProject->cellRow('<img src="../themes/' . THEME . '/gfx_priority/' . $idPriority . '.gif" alt="' . $priority[$idPriority] . '">&nbsp;' . $priority[$idPriority], '', true);
                $blockProject->cellRow($status[$idStatus]);
                $blockProject->cellRow($listTasks->tas_due_date[$i]);

                if ($complValue != "100 %") {
                    $blockProject->cellRow($complValue);
                } else {
                    $blockProject->cellRow($listTasks->tas_complete_date[$i]);
                }

                if ($listTasks->tas_assigned_to[$i] == "0") {
                    $blockProject->cellRow(lang_strings("unassigned"));
                } else {
                    $tmpquery = " AND res.task='" . $blockProject->tas_id[$i] . "'";
                    $resourceUsage = new request();
                    $resourceUsage->openTaskHumanResource($tmpquery);
                    $comptResourceUsage = count($resourceUsage->res_id);
                    $assignedToStrings = "";

                    for ($j = 0;$j < $comptResourceUsage;$j++) {
                        if ($j > 0) {
                            $assignedToStrings .= "&nbsp;";
                        }

                        $assignedToStrings .= $blockPage->buildLink($resourceUsage->res_mem_email_work[$j], $resourceUsage->res_mem_login[$j], mail);
                    }

                    $blockProject->cellRow($assignedToStrings);
                }

                $blockProject->cellRow($statusPublish[$idPublished]);
                $blockProject->closeRow();
            }

            $blockProject->closeResults();
        } 

        $blockProject->closeContent();
    }
}

require_once("../themes/" . THEME . "/footer.php");

?>
