<?php // $Revision: 1.7 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: viewrequest.php,v 1.7 2006/08/14 06:02:05 luis Exp $
 * 
 * Copyright (c) 2003 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$checkSession = true;
require_once("../includes/library.php");

if ($enableHelpSupport != "true") {
    header("Location: ../general/permissiondenied.php");
    exit;
} 

if ($supportType == "admin") {
    if ($profilSession != PF_ADMINISTRATOR) {
        header("Location: ../general/permissiondenied.php");
        exit;
    } 
} 

$tmpquery = "WHERE sr.id = '$id'";
$requestDetail = new request();
$requestDetail->openSupportRequests($tmpquery);

$tmpquery = "WHERE sp.request_id = '$id' ORDER BY sp.date DESC";
$listPosts = new request();
$listPosts->openSupportPosts($tmpquery);
$comptListPosts = count($listPosts->sp_id);

$teamMember = "false";
$tmpquery = "WHERE tea.project = '" . $requestDetail->sr_project[0] . "' AND tea.member = '$idSession'";
$memberTest = new request();
$memberTest->openTeams($tmpquery);
$comptMemberTest = count($memberTest->tea_id);
if ($comptMemberTest == "0") {
    $teamMember = "false";
} else {
    $teamMember = "true";
} 

require_once("../themes/" . THEME . "/header.php");

$blockPage = new block();
$blockPage->openBreadcrumbs();
if ($supportType == "team") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), in));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $requestDetail->sr_project[0], $requestDetail->sr_pro_name[0], in));
} else if ($supportType == "admin") {
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), in));
    $blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/support.php?", lang_strings("support_management"), in));
} 
$blockPage->itemBreadcrumbs($blockPage->buildLink("../support/listrequests.php?id=" . $requestDetail->sr_project[0], lang_strings("support_requests"), in));
$blockPage->itemBreadcrumbs($requestDetail->sr_subject[0]);
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messagebox($msgLabel);
} 

$block1 = new block();

$block1->form = "sdt";
$block1->openForm("");

if ($error != "") {
    $block1->headingError(lang_strings("errors"));
    $block1->contentError($error);
} 

$block1->heading(lang_strings("support_request") . " : " . $requestDetail->sr_subject[0]);
if ($teamMember == "true" || $profilSession == PF_ADMINISTRATOR) {
    $block1->openPaletteIcon();
    $block1->paletteIcon(0, "edit", lang_strings("edit_status"));
    $block1->paletteIcon(1, "remove", lang_strings("delete"));
    $block1->closePaletteIcon();
} 
$block1->openContent();
$block1->contentTitle(lang_strings("info"));

$comptSupStatus = count($requestStatus);
for ($i = 0;$i < $comptSupStatus;$i++) {
    if ($requestDetail->sr_status[0] == $i) {
        $status = $requestStatus[$i];
    } 
} 
$comptPri = count($priority);
for ($i = 0;$i < $comptPri;$i++) {
    if ($requestDetail->sr_priority[0] == $i) {
        $requestPriority = $priority[$i];
    } 
} 

$block1->contentRow(lang_strings("project"), $blockPage->buildLink("../projects/viewproject.php?id=" . $requestDetail->sr_project[0], $requestDetail->sr_pro_name[0], in));
$block1->contentRow(lang_strings("subject"), $requestDetail->sr_subject[0]);
$block1->contentRow(lang_strings("priority"), $requestPriority);
$block1->contentRow(lang_strings("status"), $status);
$block1->contentRow(lang_strings("date"), $requestDetail->sr_date_open[0]);
$block1->contentRow(lang_strings("user"), $blockPage->buildLink($requestDetail->sr_mem_email_work[0], $requestDetail->sr_mem_name[0], mail));
$block1->contentRow(lang_strings("message"), nl2br(html_entity_decode($requestDetail->sr_message[0], ENT_QUOTES, $htmlEntityCharset)));

$block1->contentTitle(lang_strings("responses"));

if ($teamMember == "true" || $profilSession != PF_ADMINISTRATOR) {
    $block1->contentRow("", $blockPage->buildLink("../support/addpost.php?id=" . $requestDetail->sr_id[0], lang_strings("add_support_response"), in));
} 

for ($i = 0;$i < $comptListPosts;$i++) {
    $block1->contentRow(lang_strings("posted_by"), $blockPage->buildLink($listPosts->sp_mem_email_work[$i], $listPosts->sp_mem_name[$i], mail));
    $block1->contentRow(lang_strings("date"), createDate($listPosts->sp_date[$i], $timezoneSession));

    if ($teamMember == "true" || $profilSession == PF_ADMINISTRATOR) {
        $block1->contentRow($blockPage->buildLink("../support/deleterequests.php?action=deleteP&amp;id=" . $listPosts->sp_id[$i], lang_strings("delete_message"), in), nl2br(html_entity_decode($listPosts->sp_message[$i], ENT_QUOTES, $htmlEntityCharset)));
    } else {
        $block1->contentRow("", nl2br(html_entity_decode($listPosts->sp_message[$i], ENT_QUOTES, $htmlEntityCharset)));
    } 
    $block1->contentRow("", "", "true");
} 

if ($status == $requestStatus[0]) {
    $status = "new";
} elseif ($status == $requestStatus[1]) {
    $status = "open";
} elseif ($status == $requestStatus[2]) {
    $status = "complete";
} 

$block1->closeContent();
$block1->openPaletteScript();
$block1->paletteScript(0, "edit", "../support/addpost.php?action=status&id=" . $requestDetail->sr_id[0] . "", "true,true,true", lang_strings("edit_status"));
$block1->paletteScript(1, "remove", "../support/deleterequests.php?action=deleteR&sendto=$status&id=" . $requestDetail->sr_id[0] . "", "true,true,true", lang_strings("delete"));
$block1->closePaletteScript($comptListRequests, $listRequests->sr_id);
$block1->closeForm();

require_once("../themes/" . THEME . "/footer.php");

?>
