<?php // $Revision: 1.11 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: editpredecessor.php,v 1.11 2006/07/31 02:03:24 luis Exp $
 * 
 * Copyright (c) 2003 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$checkSession = true;
require_once("../includes/library.php");

$taskgroupList = array();

function add_taskgroup_to_changelist($parent, $level)
{
    global $taskgroupList;

    if (array_key_exists($parent, $taskgroupList))
        return;

    $taskgroupList[$parent] = $level;

    $tmpquery = "WHERE tas.id='$parent'";
    $parentDetail = new request();
    $parentDetail->openTasks($tmpquery);

    if ($parentDetail->tas_parent_task[0] != 0) {
        add_taskgroup_to_changelist($parentDetail->tas_parent_task[0], $parentDetail->tas_level[0]);
    }
}

function change_parent_task($parent)
{
    global $tableCollab, $dateheures;

    $tmpquery = "WHERE tas.parent_task='$parent'";
    $subtaskList = new request();
    $subtaskList->openTasks($tmpquery);
    $newSubtask = count($subtaskList->tas_id);

    for ($i = 0;$i < $newSubtask;$i++) {
        $priority = $subtaskList->tas_priority[$i];
        $status = $subtaskList->tas_status[$i];
        $completion = $subtaskList->tas_completion[$i];
        $start_date = $subtaskList->tas_start_date[$i];
        $due_date = $subtaskList->tas_due_date[$i];
        $estimated_time = $subtaskList->tas_estimated_time[$i];
        $actual_time = $subtaskList->tas_actual_time[$i];
        $complete_date = $subtaskList->tas_complete_date[$i];
        $published = $subtaskList->tas_published[$i];

        if ($i > 0) {
            if ($newPriority < $priority) {
                $newPriority = $priority;
            }
            if ($status == ST_NOT_STARTED || $newStatus == ST_NOT_STARTED) {
                $newStatus = ST_NOT_STARTED;
            } else if ($status == ST_OPEN || $newStatus == ST_OPEN) {
                $newStatus = ST_OPEN;
            } else if ($status == ST_SUSPENDED || $newStatus == ST_SUSPENDED) {
                $newStatus = ST_SUSPENDED;
            } else if ($status == ST_CLIENT_COMPLETED || $newStatus == ST_CLIENT_COMPLETED) {
                $newStatus = ST_CLIENT_COMPLETED;
            }
            $newCompletion += $completion;
            if ($newStartDate > $start_date) {
                $newStartDate = $start_date;
            }
            if ($newDueDate < $due_date) {
                $newDueDate = $due_date;
            }
            $newEstimatedTime += $estimated_time;
            $newActualTime += $actual_time;
            if ($newStatus == ST_COMPLETED) {
                if ($newCompleteDate < $complete_date) {
                    $newCompleteDate = $complete_date;
                }
            } else {
                $newCompleteDate = '--';
            }
            if ($published == PB_YES) {
                $newPublished = PB_YES;
            }
        } else {
            $newPriority = $priority;
            $newStatus = $status;
            $newCompletion = $completion;
            $newStartDate = $start_date;
            $newDueDate = $due_date;
            $newEstimatedTime = $estimated_time;
            $newActualTime = $actual_time;
            if ($newStatus == ST_COMPLETED) {
                $newCompleteDate = $complete_date;
            } else {
                $newCompleteDate = '--';
            }
            $newPublished = $published;
        }
    }
    $newCompletion = substr($newCompletion / $newSubtask, 0, 1);

    $tmpquery = "UPDATE " . $tableCollab['tasks'] . " SET priority='$newPriority', status='$newStatus', completion='$newCompletion', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', published='$newPublished', complete_date='$newCompleteDate', modified='$dateheures', task_group='" . TG_YES . "', subtask='$newSubtask' WHERE id='$parent'";
    connectSql("$tmpquery");
}

$tmpquery = "WHERE pro.id = '$project'";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);

if ($action == "edit") {
    if ($old_ty == $ty && $old_la == $la) {
        header("Location: ../tasks/viewtask.php?id=$task");
        exit;
    }

    $criticalSection = enter_critical_section();
    if ($criticalSection == -1) {
        header("Location: ../tasks/viewtask.php?id=$task&msg=$msg");
        exit;
    }

    $tmpquery = " WHERE tas.id='$task'";
    $orgTask = new request();
    $orgTask->openTasks($tmpquery);

    // Adjust task start & due date with predecessor tasks
    $tmpquery = " WHERE pre.task = '$task'";
    $predecessorList = new request();
    $predecessorList->openTaskPredecessor($tmpquery);
    $comptPredecessorList = count($predecessorList->pre_id);
    for ($i=0;$i<$comptPredecessorList;$i++) {
        if ($predecessorList->pre_id[$i] == $id) {
            $predecessorList->pre_type[$i] = $ty;
            $predecessorList->pre_lag[$i] = $la;
            break;
        }
    }
    $sdLowerLimit = -1;
    $sdUpperLimit = -1;
    $ddLowerLimit = -1;
    $ddUpperLimit = -1;
    $timestampSD = date2timestamp($orgTask->tas_start_date[0]);
    $timestampDD = date2timestamp($orgTask->tas_due_date[0]);
    for ($i = 0; $i < $comptPredecessorList; $i++) {
        $timestampSD2 = date2timestamp($predecessorList->pre_tas2_start_date[$i]);
        $timestampDD2 = date2timestamp($predecessorList->pre_tas2_due_date[$i]);
        $timestampSD3 = date2timestamp(hours_after(date('Y-m-d', $timestampSD2), $predecessorList->pre_lag[$i]+1));
        $timestampDD3 = date2timestamp(hours_after(date('Y-m-d', $timestampDD2), $predecessorList->pre_lag[$i]+1));
        switch ($predecessorList->pre_type[$i]) {
            case 'FF':
                if ($ddLowerLimit < $timestampDD2) {
                    $ddLowerLimit = $timestampDD2;
                }
                if ($ddUpperLimit == -1 || $ddUpperLimit > $timestampDD3) {
                    $ddUpperLimit = $timestampDD3;
                }
                break;
            case 'FS':
                if ($sdLowerLimit < $timestampDD2) {
                    $sdLowerLimit = $timestampDD2;
                }
                if ($sdUpperLimit == -1 || $sdUpperLimit > $timestampDD3) {
                    $sdUpperLimit = $timestampDD3;
                }
                break;
            case 'SF':
                if ($ddLowerLimit < $timestampSD2) {
                    $ddLowerLimit = $timestampSD2;
                }
                if ($ddUpperLimit == -1 || $ddUpperLimit > $timestampSD3) {
                    $ddUpperLimit = $timestampSD3;
                }
                break;
            case 'SS':
                if ($sdLowerLimit < $timestampSD2) {
                    $sdLowerLimit = $timestampSD2;
                }
                if ($sdUpperLimit == -1 || $sdUpperLimit > $timestampSD3) {
                    $sdUpperLimit = $timestampSD3;
                }
                break;
        }
        if (($sdLowerLimit != -1 && $sdUpperLimit != -1 && $sdLowerLimit > $sdUpperLimit)
         || ($ddLowerLimit != -1 && $ddUpperLimit != -1 && $ddLowerLimit > $ddUpperLimit)
         || ($orgTask->tas_fixed_duration[0] == FD_YES && $sdUpperLimit != -1 && $ddLowerLimit != -1 && date2timestamp(hours_after(date('Y-m-d', $sdUpperLimit), $orgTask->tas_estimated_time[0])) < $ddLowerLimit)
         || ($orgTask->tas_fixed_duration[0] == FD_YES && $sdLowerLimit != -1 && $ddUpperLimit != -1 && date2timestamp(hours_after(date('Y-m-d', $sdLowerLimit), $orgTask->tas_estimated_time[0])) > $ddUpperLimit)
         || ($orgTask->tas_milestone[0] == MS_YES && $sdUpperLimit != -1 && $ddLowerLimit != -1 && $sdUpperLimit < $ddLowerLimit)) {

            leave_critical_section($criticalSection);

            header("Location: ../tasks/viewtask.php?id=$task&msg=taskDependency");
            exit;
        }
        if ($orgTask->tas_milestone[0] == MS_YES) {
            if ($ddLowerLimit != -1 && $sdLowerLimit < $ddLowerLimit) {
                $sdLowerLimit = $ddLowerLimit;
            }
            if ($sdUpperLimit != -1 && $sdUpperLimit < $ddUpperLimit) {
                $ddUpperLimit = $sdUpperLimit;
            }
            switch ($predecessorList->pre_type[$i]) {
                case 'FF':
                case 'SF':
                    if ($timestampDD < $ddLowerLimit || $timestampDD > $ddUpperLimit) {
                        $timestampDD = $ddUpperLimit;
                        $timestampSD = $timestampDD;
                    }
                    break;
                    break;
                case 'FS':
                case 'SS':
                    if ($timestampSD < $sdLowerLimit || $timestampSD > $sdUpperLimit) {
                        $timestampDD = $sdUpperLimit;
                        $timestampSD = $timestampDD;
                    }
                    break;
            }
        } else if ($orgTask->tas_fixed_duration[0] == FD_YES) {
            if ($sdLowerLimit != -1 && $ddLowerLimit != -1 && date2timestamp(hours_after(date('Y-m-d', $sdLowerLimit), $orgTask->tas_estimated_time[0])) < $ddLowerLimit) {
                $sdLowerLimit = date2timestamp(hours_before(date('Y-m-d', $ddLowerLimit), $orgTask->tas_estimated_time[0]));
            }
            if ($sdUpperLimit != -1 && $ddUpperLimit != -1 && date2timestamp(hours_after(date('Y-m-d', $sdUpperLimit), $orgTask->tas_estimated_time[0])) < $ddUpperLimit) {
                $ddUpperLimit = date2timestamp(hours_after(date('Y-m-d', $sdUpperLimit), $orgTask->tas_estimated_time[0]));
            }
            switch ($predecessorList->pre_type[$i]) {
                case 'FF':
                case 'SF':
                    if ($timestampDD <= $ddLowerLimit) {
                        if ($predecessorList->pre_lag[$i] < "8") {
                            $timestampDD = $ddLowerLimit;
                        } else {
                            $timestampDD = date2timestamp(hours_after(date('Y-m-d', $ddLowerLimit), 9));
                        }
                    } else if ($timestampDD > $ddUpperLimit) {
                        $timestampDD = $ddUpperLimit;
                    }
                    $timestampSD = date2timestamp(hours_before(date('Y-m-d', $timestampDD), $orgTask->tas_estimated_time[0]));
                    break;
                case 'FS':
                case 'SS':
                    if ($timestampSD <= $sdLowerLimit) {
                        if ($predecessorList->pre_lag[$i] < "8") {
                            $timestampSD = $sdLowerLimit;
                        } else {
                            $timestampSD = date2timestamp(hours_after(date('Y-m-d', $sdLowerLimit), 9));
                        }
                    } else if ($timestampSD > $sdUpperLimit) {
                        $timestampSD = $sdUpperLimit;
                    }
                    $timestampDD = date2timestamp(hours_after(date('Y-m-d', $timestampSD), $orgTask->tas_estimated_time[0]));
                    break;
            }
        } else {
            switch ($predecessorList->pre_type[$i]) {
                case 'FF':
                case 'SF':
                    if ($timestampDD <= $ddLowerLimit) {
                        if ($predecessorList->pre_lag[$i] < "8") {
                            $timestampDD = $ddLowerLimit;
                        } else {
                            $timestampDD = date2timestamp(hours_after(date('Y-m-d', $ddLowerLimit), 9));
                        }
                    } else if ($timestampDD > $ddUpperLimit) {
                        $timestampDD = $ddUpperLimit;
                    }
                    if ($timestampSD > $timestampDD) {
                        $timestampSD = $timestampDD;
                    }
                    break;
                case 'FS':
                case 'SS':
                    if ($timestampSD <= $sdLowerLimit) {
                        if ($predecessorList->pre_lag[$i] < "8") {
                            $timestampSD = $sdLowerLimit;
                        } else {
                            $timestampSD = date2timestamp(hours_after(date('Y-m-d', $sdLowerLimit), 9));
                        }
                    } else if ($timestampSD > $sdUpperLimit) {
                        $timestampSD = $sdUpperLimit;
                    }
                    if ($timestampDD < $timestampSD) {
                        $timestampDD = $timestampSD;
                    }
                    break;
            }
        }
    }
    $sd = date('Y-m-d', $timestampSD);
    $dd = date('Y-m-d', $timestampDD);
    if ($orgTask->tas_fixed_duration[0] != FD_YES) {
        $etm = diff_hour($sd, $dd);
    }

    $tmpquery = "UPDATE " . $tableCollab["tasks_predecessor"] . " SET type='$ty', lag='$la', modified='$dateheures' WHERE id='$id'";
    connectSql("$tmpquery");

    $tmpquery = "";
    if ($sd != $orgTask->tas_start_date[0]) {
        $tmpquery .= "start_date='$sd',";
    }
    if ($dd != $orgTask->tas_due_date[0]) {
        $tmpquery .= "due_date='$dd',";
    }
    if ($orgTask->tas_milestone[0] != MS_YES && $orgTask->tas_fixed_duration[0] != FD_YES && $etm != $orgTask->tas_estimated_time[0]) {
        $tmpquery .= "estimated_time='$etm',";
    }
    if ($tmpquery!="") {
        $tmpquery = "UPDATE " . $tableCollab["tasks"] . " SET " . $tmpquery . "modified='$dateheures' WHERE id='$task'";
        connectSql("$tmpquery");

        $cUp = "\n[datedue:$dd]";
        $cUp = htmlentities($cUp, ENT_QUOTES, $htmlEntityCharset);
        $tmpquery2 = "INSERT INTO " . $tableCollab["updates"] . "(type,item,member,comments,created) VALUES ('1','$task','$idSession','$cUp','$dateheures')";
        connectSql("$tmpquery2");

        if ($orgTask->tas_parent_task[0] != '0') {
            add_taskgroup_to_changelist($orgTask->tas_parent_task[0], $orgTask->tas_level[0]);
        }

        // Adjust task successors
        $adjArray = array($task);
        while (count($adjArray) > 0) {
            $adjTaskID = array_shift($adjArray);
            $tmpquery2 = " WHERE pre.predecessor='$adjTaskID'";
            $successorList = new request();
            $successorList->openTaskPredecessor($tmpquery2);
            $comptSuccessorList = count($successorList->pre_id);
            for ($i = 0; $i < $comptSuccessorList; $i++) {
                $timestampSD = date2timestamp($successorList->pre_tas_start_date[$i]);
                $timestampDD = date2timestamp($successorList->pre_tas_due_date[$i]);
                $timestampSD2 = date2timestamp($successorList->pre_tas2_start_date[$i]);
                $timestampDD2 = date2timestamp($successorList->pre_tas2_due_date[$i]);
                $timestampSD3 = date2timestamp(hours_after(date('Y-m-d', $timestampSD2), $successorList->pre_lag[$i]+1));
                $timestampDD3 = date2timestamp(hours_after(date('Y-m-d', $timestampDD2), $successorList->pre_lag[$i]+1));
                switch ($successorList->pre_type[$i]) {
                    case 'FF':
                        if ($timestampDD>$timestampDD3) {
                            $timestampDD = $timestampDD3;
                        } else if ($timestampDD<=$timestampDD2) {
                            if ($successorList->pre_lag[$i]<"8") {
                                $timestampDD = $timestampDD2;
                            } else {
                                $timestampDD = date2timestamp(hours_after(date('Y-m-d', $timestampDD2), 9));
                            }
                        }
                        if ($successorList->pre_tas_milestone[$i]==MS_YES) {
                            $timestampSD = $timestampDD;
                        } else if ($successorList->pre_tas_fixed_duration[$i] == FD_YES) {
                            $timestampSD = date2timestamp(hours_before(date('Y-m-d', $timestampDD), $successorList->pre_tas_estimated_time[$i]));
                        }
                        break;
                    case 'FS':
                        if ($timestampSD>$timestampDD3) {
                            $timestampSD = $timestampDD3;
                        } else if ($timestampSD<=$timestampDD2) {
                            if ($successorList->pre_lag[$i]<"8") {
                                $timestampSD = $timestampDD2;
                            } else {
                                $timestampSD = date2timestamp(hours_after(date('Y-m-d', $timestampDD2), 9));
                            }
                        }
                        if ($successorList->pre_tas_milestone[$i]==MS_YES) {
                            $timestampDD = $timestampSD;
                        } else if ($successorList->pre_tas_fixed_duration[$i] == FD_YES) {
                            $timestampDD = date2timestamp(hours_after(date('Y-m-d', $timestampSD), $successorList->pre_tas_estimated_time[$i]));
                        }
                        break;
                    case 'SF':
                        if ($timestampDD>$timestampSD3) {
                            $timestampDD = $timestampSD3;
                        } else if ($timestampDD<=$timestampSD2) {
                            if ($successorList->pre_lag[$i]<"8") {
                                $timestampDD = $timestampSD2;
                            } else {
                                $timestampDD = date2timestamp(hours_after(date('Y-m-d', $timestampSD2), 9));
                            }
                        }
                        if ($successorList->pre_tas_milestone[$i]==MS_YES) {
                            $timestampSD = $timestampDD;
                        } else if ($successorList->pre_tas_fixed_duration[$i] == FD_YES) {
                            $timestampSD = date2timestamp(hours_before(date('Y-m-d', $timestampDD), $successorList->pre_tas_estimated_time[$i]));
                        }
                        break;
                    case 'SS':
                        if ($timestampSD>$timestampSD3) {
                            $timestampSD = $timestampSD3;
                        } else if ($timestampSD<=$timestampSD2) {
                            if ($successorList->pre_lag[$i]<"8") {
                                $timestampSD = $timestampSD2;
                            } else {
                                $timestampSD = date2timestamp(hours_after(date('Y-m-d', $timestampSD2), 9));
                            }
                        }
                        if ($successorList->pre_tas_milestone[$i]==MS_YES) {
                            $timestampDD = $timestampSD;
                        } else if ($successorList->pre_tas_fixed_duration[$i] == FD_YES) {
                            $timestampDD = date2timestamp(hours_after(date('Y-m-d', $timestampSD), $successorList->pre_tas_estimated_time[$i]));
                        }
                        break;
                }
                $new_sd = date("Y-m-d", $timestampSD);
                $new_dd = date("Y-m-d", $timestampDD);
                $new_etm = diff_hour($new_sd, $new_dd);
                $tmpquery3 = "";
                if ($new_sd != $successorList->pre_tas_start_date[$i]) {
                    $tmpquery3 .= "start_date='$new_sd',";
                }
                if ($new_dd != $successorList->pre_tas_due_date[$i]) {
                    $tmpquery3 .= "due_date='$new_dd',";
                }
                if ($new_etm != $successorList->pre_tas_estimated_time[$i]) {
                    $tmpquery3 .= "estimated_time='$new_etm',";
                }
                if ($tmpquery3 != "") {
                    array_push($adjArray, $successorList->pre_task[$i]);
                    $tmpquery3 = "UPDATE " . $tableCollab["tasks"] . " SET " . $tmpquery3 . "modified='$dateheures' WHERE id = '" . $successorList->pre_task[$i] . "'";
                    connectSql("$tmpquery3");

                    $cUp = "\n[datedue:$new_dd]";
                    $cUp = htmlentities($cUp, ENT_QUOTES, $htmlEntityCharset);
                    $tmpquery3 = "INSERT INTO " . $tableCollab["updates"] . "(type,item,member,comments,created) VALUES ('1','" . $successorList->pre_task[$i] . "','$idSession','$cUp','$dateheures')";
                    connectSql("$tmpquery3");

                    if ($successorList->pre_tas_parent_task[$i] != '0') {
                        add_taskgroup_to_changelist($successorList->pre_tas_parent_task[$i], $successorList->pre_tas_level[$i]);
                    }
                }
            }
        }

        if (count($taskgroupList) > 0) {
            arsort($taskgroupList, SORT_NUMERIC);
            reset($taskgroupList);
            while (list($parentTask, $level) = each($taskgroupList)) {
                change_parent_task($parentTask);
            }
        }

        if ($projectDetail->pro_phase_set[0] != "0") {
            // change parent phase status
            $tmpquery = " WHERE tas.parent_phase='" . $orgTask->tas_parent_phase[0] . "'";
            $statusList = new request();
            $statusList->openTasks($tmpquery);
            $comptStatusList = count($statusList->tas_id);
            $statusArray = array(0, 0, 0, 0, 0);
            for ($i = 0;$i < $comptStatusList; $i++) {
                $statusArray[$statusList->status[$i]]++;
            }
            if ($comptStatusList == 0) {
                $parentPhaseStatus = PS_NOT_STARTED;
            } else if ($statusArray[ST_COMPLETED] == $comptStatusList) {
                $parentPhaseStatus = PS_COMPLETE;
            } else if ($statusArray[ST_NOT_STARTED] == $comptStatusList) {
                $parentPhaseStatus = PS_NOT_STARTED;
            } else if ($statusArray[ST_SUSPENDED] == $comptStatusList) {
                $parentPhaseStatus = PS_SUSPENDED;
            } else {
                $parentPhaseStatus = PS_OPEN;
            }
            $tmpquery = " WHERE pha.id='" . $orgTask->tas_parent_phase[0] . "'";
            $phaseStatus = new request();
            $phaseStatus->openPhases($tmpquery);
            if ($phaseStatus->pha_status[0] != $parentPhaseStatus) {
                $tmpquery = "UPDATE " . $tableCollab["phases"] . " SET status='$parentPhaseStatus' WHERE id='" . $orgTask->tas_parent_phase[0] . "'";
                connectSql("$tmpquery");
            }
        }
    }

    leave_critical_section($criticalSection);

    header("Location: ../tasks/viewtask.php?id=$task&msg=update");
    exit;
} 

$teamMember = "false";
$tmpquery = "WHERE tea.project = '$project' AND tea.member = '$idSession'";
$memberTest = new request();
$memberTest->openTeams($tmpquery);
$comptMemberTest = count($memberTest->tea_id);

if ($comptMemberTest == "0") {
    $teamMember = "false";
} else {
    $teamMember = "true";
} 

if (!(($teamMember == 'true' && $profilSession == PF_PROJECT_MANAGER) || $profilSession == PF_PROJECT_MANAGER_ADMINISTRATOR || $profilSession == PF_HR_MANAGER || $profilSession == PF_ADMINISTRATOR)) {
    header('Location: ../general/permissiondenied.php');
    exit;
} 

$tmpquery = "WHERE tas.id = '$task'";
$taskDetail = new request();
$taskDetail->openTasks($tmpquery);

$tmpquery = " WHERE pre.id = '$id'";
$predecessorDetail = new request();
$predecessorDetail->openTaskPredecessor($tmpquery);

require_once("../themes/" . THEME . "/header.php");

$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=$project", $projectDetail->pro_name[0], in));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/listtasks.php?project=$project", lang_strings("tasks"), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../tasks/viewtask.php?id=$task", $taskDetail->tas_name[0], in));
$blockPage->itemBreadcrumbs(lang_strings("edit_predecessor"));
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messagebox($msgLabel);
} 

$block1 = new block();

$block1->form = "predecessordetails";

echo "<a name=\"predecessordetailsAnchor\"></a>";

echo "<form accept-charset=\"UNKNOWN\" method=\"POST\" action=\"../tasks/editpredecessor.php?action=edit&amp;project=$project&amp;task=$task&amp;id=$id\" name=\"predecessordetailsForm\" enctype=\"multipart/form-data\">";

$block1->heading(lang_strings("edit_predecessor"));

$block1->openContent();
$block1->contentTitle(lang_strings("details"));

echo "<input type=\"hidden\" name=\"old_ty\" value=\"" . $predecessorDetail->pre_type[0] . "\">";
echo "<input type=\"hidden\" name=\"old_la\" value=\"" . $predecessorDetail->pre_lag[0] . "\">";

echo "<tr class=\"odd\"><td valign=\"top\" class=\"leftvalue\">" . lang_strings("predecessor") . " :</td><td>" . $predecessorDetail->pre_tas2_name[0] . "</td></tr>
<tr class=\"odd\"><td valign=\"top\" class=\"leftvalue\">" . lang_strings("type") . " :</td><td><select name=\"ty\">";

foreach ($taskPredecessorTypes as $key => $value) {
    if ($key == $predecessorDetail->pre_type[0]) {
        echo "<option value=\"$key\" selected>$value</option>";
    } else {
        echo "<option value=\"$key\">$value</option>";
    }
}
echo"</select></td></tr>
<tr class=\"odd\"><td valign=\"top\" class=\"leftvalue\">" . lang_strings("lag") . " :</td><td><input size=\"10\" value=\"" . $predecessorDetail->pre_lag[0] . "\" class=\"input_hours\" name=\"la\" maxlength=\"5\" type=\"TEXT\">&nbsp;" . lang_strings('hours') . "</td></tr>
<tr class=\"odd\"><td valign=\"top\" class=\"leftvalue\">&nbsp;</td><td><input type=\"SUBMIT\" value=\"" . lang_strings("save") . "\"></td></tr>";

$block1->closeContent();
$block1->closeForm();

require_once("../themes/" . THEME . "/footer.php");

?>
