<?php // $Revision: 1.16 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: listtasks.php,v 1.16 2006/03/17 01:48:57 luis Exp $
 * 
 * Copyright (c) 2003 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$checkSession = true;
require_once("../includes/library.php");

$taskgroupList = array();

function add_taskgroup_to_changelist($parent, $level)
{
    global $taskgroupList;

    if (array_key_exists($parent, $taskgroupList))
        return;

    $taskgroupList[$parent] = $level;

    $tmpquery = "WHERE tas.id='$parent'";
    $parentDetail = new request();
    $parentDetail->openTasks($tmpquery);

    if ($parentDetail->tas_parent_task[0] != 0) {
        add_taskgroup_to_changelist($parentDetail->tas_parent_task[0], $parentDetail->tas_level[0]);
    }
}

function change_parent_task($parent)
{
    global $tableCollab, $dateheures;

    $tmpquery = "WHERE tas.parent_task='$parent'";
    $subtaskList = new request();
    $subtaskList->openTasks($tmpquery);
    $newSubtask = count($subtaskList->tas_id);

    for ($i = 0;$i < $newSubtask;$i++) {
        $priority = $subtaskList->tas_priority[$i];
        $status = $subtaskList->tas_status[$i];
        $completion = $subtaskList->tas_completion[$i];
        $start_date = $subtaskList->tas_start_date[$i];
        $due_date = $subtaskList->tas_due_date[$i];
        $estimated_time = $subtaskList->tas_estimated_time[$i];
        $actual_time = $subtaskList->tas_actual_time[$i];
        $complete_date = $subtaskList->tas_complete_date[$i];
        $published = $subtaskList->tas_published[$i];

        if ($i > 0) {
            if ($newPriority < $priority) {
                $newPriority = $priority;
            }
            if ($status == ST_NOT_STARTED || $newStatus == ST_NOT_STARTED) {
                $newStatus = ST_NOT_STARTED;
            } else if ($status == ST_OPEN || $newStatus == ST_OPEN) {
                $newStatus = ST_OPEN;
            } else if ($status == ST_SUSPENDED || $newStatus == ST_SUSPENDED) {
                $newStatus = ST_SUSPENDED;
            } else if ($status == ST_CLIENT_COMPLETED || $newStatus == ST_CLIENT_COMPLETED) {
                $newStatus = ST_CLIENT_COMPLETED;
            }
            $newCompletion += $completion;
            if ($newStartDate > $start_date) {
                $newStartDate = $start_date;
            }
            if ($newDueDate < $due_date) {
                $newDueDate = $due_date;
            }
            $newEstimatedTime += $estimated_time;
            $newActualTime += $actual_time;
            if ($newStatus == ST_COMPLETED) {
                if ($newCompleteDate < $complete_date) {
                    $newCompleteDate = $complete_date;
                }
            } else {
                $newCompleteDate = '--';
            }
            if ($published == PB_YES) {
                $newPublished = PB_YES;
            }
        } else {
            $newPriority = $priority;
            $newStatus = $status;
            $newCompletion = $completion;
            $newStartDate = $start_date;
            $newDueDate = $due_date;
            $newEstimatedTime = $estimated_time;
            $newActualTime = $actual_time;
            if ($newStatus == ST_COMPLETED) {
                $newCompleteDate = $complete_date;
            } else {
                $newCompleteDate = '--';
            }
            $newPublished = $published;
        }
    }
    $newCompletion = substr($newCompletion / $newSubtask, 0, 1);

    $tmpquery = "UPDATE " . $tableCollab['tasks'] . " SET priority='$newPriority', status='$newStatus', completion='$newCompletion', start_date='$newStartDate', due_date='$newDueDate', estimated_time='$newEstimatedTime', actual_time='$newActualTime', published='$newPublished', complete_date='$newCompleteDate', modified='$dateheures', task_group='" . TG_YES . "', subtask='$newSubtask' WHERE id='$parent'";
    connectSql("$tmpquery");
}

$tmpquery = "WHERE pro.id = '$project'";
$projectDetail = new request();
$projectDetail->openProjects($tmpquery);
$teamMember = "false";
$tmpquery = "WHERE tea.project = '$project' AND tea.member = '$idSession'";
$memberTest = new request();
$memberTest->openTeams($tmpquery);
$comptMemberTest = count($memberTest->tea_id);

if ($comptMemberTest == "0") {
    $teamMember = "false";
} else {
    $teamMember = "true";
} 

if ($teamMember == 'false' && $projectsFilter == 'true' && $profilSession != PF_PROJECT_MANAGER_ADMINISTRATOR && $profilSession != PF_HR_MANAGER && $profilSession != PF_ADMINISTRATOR) {
    header("Location:../general/permissiondenied.php");
    exit;
} 

if ($action == "publish") {
    if ($addToSite == "true" || $removeToSite == "true") {
        $criticalSection = enter_critical_section();

        if ($criticalSection == -1) {
            header("Location: ../tasks/listtasks.php?project=$project&msg=$msg");
            exit;
        }

        $id = str_replace("**", ",", $id);

        if ($addToSite == "true") {
            $tmpquery1 = "UPDATE " . $tableCollab["tasks"] . " SET published='" . PB_YES . "' WHERE id IN($id)";
            $msg = "addToSite";
        } else {
            $tmpquery1 = "UPDATE " . $tableCollab["tasks"] . " SET published='" . PB_NO . "' WHERE id IN($id)";
            $msg = "removeToSite";
        }

        connectSql("$tmpquery1");
        $tmpquery = "WHERE tas.id IN ($id)";
        $listTasks = new request();
        $listTasks->openTasks($tmpquery);
        $comptListTasks = count($listTasks->tas_id);

        for ($i=0; $i<$comptListTasks; $i++) {
            add_taskgroup_to_changelist($listTasks->tas_parent_task[$i], $listTasks->tas_level[$i]);
        }

        if (count($taskgroupList) > 0) {
            arsort($taskgroupList, SORT_NUMERIC);
            reset($taskgroupList);

            while (list($parentTask, $level) = each($taskgroupList)) {
                change_parent_task($parentTask);
            }
        }

        leave_critical_section($criticalSection);
    }
} 

require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/listprojects.php?", lang_strings("projects"), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../projects/viewproject.php?id=" . $projectDetail->pro_id[0], $projectDetail->pro_name[0], in));
$blockPage->itemBreadcrumbs(lang_strings("tasks"));
$blockPage->closeBreadcrumbs();

if ($msg != "") {
    require_once("../includes/messages.php");
    $blockPage->messagebox($msgLabel);
} 

$blockPage->bornesNumber = "1";
$block1 = new block();
$block1->form = "saT";
$block1->openForm("../tasks/listtasks.php?project=$project#" . $block1->form . "Anchor");
$block1->heading(lang_strings("tasks"));
$block1->openPaletteIcon();

if (($teamMember == 'true' && $profilSession == PF_PROJECT_MANAGER) || $profilSession == PF_PROJECT_MANAGER_ADMINISTRATOR || $profilSession == PF_HR_MANAGER || $profilSession == PF_ADMINISTRATOR) {
    $block1->paletteIcon(0, "add", lang_strings("add"));
    $block1->paletteIcon(1, "remove", lang_strings("delete"));
    $block1->paletteIcon(2, "copy", lang_strings("copy")); 
    // $block1->paletteIcon(3,"export",lang_strings("export"));

    if ($sitePublish == "true") {
        $block1->paletteIcon(4, "add_projectsite", lang_strings("add_project_site"));
        $block1->paletteIcon(5, "remove_projectsite", lang_strings("remove_project_site"));
    } 
} 

$block1->paletteIcon(6, "info", lang_strings("view"));

if ($teamMember == 'true' || $profilSession == PF_PROJECT_MANAGER_ADMINISTRATOR || $profilSession == PF_HR_MANAGER || $profilSession == PF_ADMINISTRATOR) {
    $block1->paletteIcon(7, "edit", lang_strings("edit"));
    $block1->paletteIcon(8, "timelog", lang_strings("loghours"));
}

if (($teamMember == 'true' && $profilSession == PF_PROJECT_MANAGER) || $profilSession == PF_PROJECT_MANAGER_ADMINISTRATOR || $profilSession == PF_HR_MANAGER || $profilSession == PF_ADMINISTRATOR) {
    $block1->paletteIcon(9, "dependency", lang_strings("add_predecessor"));
    $block1->paletteIcon(10, "unlink", lang_strings("delete_dependencies"));
    $block1->paletteIcon(11, "indentation", lang_strings("indentation"));
    $block1->paletteIcon(12, "unindentation", lang_strings("unindentation"));
    $block1->paletteIcon(13, "add_taskgroup", lang_strings("add_taskgroup"));
} 

$block1->closePaletteIcon();
$block1->borne = $blockPage->returnBorne("1");
$block1->rowsLimit = "20";
$block1->sorting("tasks", $sortingUser->sor_tasks[0], "tas.name ASC", $sortingFields = array(0 => "tas.id", 1 => "tas.name", 2 => "tas.priority", 3 => "tas.status", 4 => "tas.completion", 5 => "tas.due_date", 6 => "tas.assigned_to", 7 => "tas.published"));
$tmpqueryC = "WHERE tas.project = '$project'";
$tmpqueryS = "ORDER BY $block1->sortingValue";
$listTasks = new request();
$listTasks->openHierarchyOfTasks($tmpqueryC, $tmpqueryS);
$block1->recordsTotal = count($listTasks->tas_id);
$listTasks = new request();
$listTasks->openHierarchyOfTasks($tmpqueryC, $tmpqueryS, $block1->borne, $block1->rowsLimit);
$comptListTasks = count($listTasks->tas_id);

if ($comptListTasks != "0") {
    $block1->openResults();

    $block1->labels($labels = array(0 => lang_strings('id'), 1 => lang_strings('task'), 2 => lang_strings('priority'), 3 => lang_strings('status'), 4 => lang_strings('completion'), 5 => lang_strings('due_date'), 6 => lang_strings('assigned_to'), 7 => lang_strings('published')), 'true');

    for ($i = 0;$i < $comptListTasks;$i++) {
        if ($listTasks->tas_due_date[$i] == "") {
            $listTasks->tas_due_date[$i] = lang_strings("none");
        } 

        $idStatus = $listTasks->tas_status[$i];
        $idPriority = $listTasks->tas_priority[$i];

        $idPublish = $listTasks->tas_published[$i];
        $complValue = ($listTasks->tas_completion[$i] > 0) ? $listTasks->tas_completion[$i] . "0 %": $listTasks->tas_completion[$i] . " %";

        $block1->openRow();
        $block1->checkboxRow($listTasks->tas_id[$i]);

        $block1->cellRow($blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_id[$i], in));

        $leadingSpace = '';
        for ($j = 0;$j < $listTasks->tas_level[$i];$j++) {
            $leadingSpace .= '&nbsp;&nbsp;';
        }
        if ($idStatus == ST_COMPLETED) {
            $block1->cellRow($leadingSpace . $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i], instrike));
        } else {
            $block1->cellRow($leadingSpace. $blockPage->buildLink("../tasks/viewtask.php?id=" . $listTasks->tas_id[$i], $listTasks->tas_name[$i], in));
        } 

        if ($listTasks->tas_milestone[$i] == MS_YES) {
            $block1->cellRow("");
            $block1->cellRow("");
            $block1->cellRow("");
        } else {
            $block1->cellRow('<img src="../themes/' . THEME . '/gfx_priority/' . $idPriority . '.gif" alt="' . $priority[$idPriority] . '">&nbsp;' . $priority[$idPriority], '', true);
            $block1->cellRow('<img src="../themes/' . THEME . '/gfx_status/' . $idStatus . '.gif" alt="' . $status[$idStatus] . '">&nbsp;' . $status[$idStatus], '', true);
            $block1->cellRow($complValue);
        }

        if ($listTasks->tas_milestone[$i] == MS_YES) {
            $block1->cellRow($listTasks->tas_due_date[$i]);
        } else if ($listTasks->tas_due_date[$i] <= $date && $listTasks->tas_completion[$i] != "10") {
            $block1->cellRow("<b>" . $listTasks->tas_due_date[$i] . "</b>");
        } else {
            $block1->cellRow($listTasks->tas_due_date[$i]);
        } 

        if ($listTasks->tas_start_date[$i] != "--" && $listTasks->tas_due_date[$i] != "--") {
            $gantt = "true";
        } 

        if ($listTasks->tas_milestone[$i] == MS_YES) {
            $block1->cellRow("");
        } else if ($listTasks->tas_assigned_to[$i] == "0") {
            $block1->cellRow(lang_strings("unassigned"));
        } else {
            $tmpquery = " AND res.task='" . $listTasks->tas_id[$i] . "'";
            $resourceUsage = new request();
            $resourceUsage->openTaskHumanResource($tmpquery);
            $comptResourceUsage = count($resourceUsage->res_id);

            $assignedToStrings = "";
            for ($j = 0;$j < $comptResourceUsage;$j++) {
                if ($j > 0) {
                    $assignedToStrings .= "&nbsp;";
                }

                $assignedToStrings .= $blockPage->buildLink($resourceUsage->res_mem_email_work[$j], $resourceUsage->res_mem_login[$j], mail);
            }

            $block1->cellRow($assignedToStrings);
        } 

        if ($sitePublish == "true") {
            $block1->cellRow($statusPublish[$idPublish]);
        }

        $block1->closeRow();
    } 

    $block1->closeResults();
    $block1->bornesFooter("1", $blockPage->bornesNumber, "", "project=$project");

    if ($activeJpgraph == "true" && $gantt == "true") {
        // show the expanded or compact Gantt Chart
        if ($_GET['base'] == 1) {
            echo "<a href='listtasks.php?project=$project'>expand</a><br>";
        } else {
            echo "<a href='listtasks.php?project=$project&amp;base=1'>compact</a><br>";
        }

        echo "<img src=\"graphtasks.php?project=" . $projectDetail->pro_id[0] . "&amp;base=" . $_GET['base'] . "\" alt=\"\"><br><span class=\"listEvenBold\">" . $blockPage->buildLink("http://www.aditus.nu/jpgraph/", "JpGraph", powered) . "</span>";
    } 
} else {
    $block1->noresults();
} 

$block1->closeFormResults();
$block1->openPaletteScript();

if (($teamMember == 'true' && $profilSession == PF_PROJECT_MANAGER) || $profilSession == PF_PROJECT_MANAGER_ADMINISTRATOR || $profilSession == PF_HR_MANAGER || $profilSession == PF_ADMINISTRATOR) {
    $block1->paletteScript(0, "add", "../tasks/edittask.php?project=$project", "true,false,false", lang_strings("add"));
    $block1->paletteScript(1, "remove", "../tasks/deletetasks.php?project=$project", "false,true,true", lang_strings("delete"));
    $block1->paletteScript(2, "copy", "../tasks/edittask.php?project=$project&cpy=true", "false,true,false", lang_strings("copy")); 
    // $block1->paletteScript(3,"export","export.php?","false,true,true",lang_strings("export"));

    if ($sitePublish == "true") {
        $block1->paletteScript(4, "add_projectsite", "../tasks/listtasks.php?addToSite=true&project=" . $projectDetail->pro_id[0] . "&action=publish", "false,true,true", lang_strings("add_project_site"));
        $block1->paletteScript(5, "remove_projectsite", "../tasks/listtasks.php?removeToSite=true&project=" . $projectDetail->pro_id[0] . "&action=publish", "false,true,true", lang_strings("remove_project_site"));
    } 
} 

$block1->paletteScript(6, "info", "../tasks/viewtask.php?", "false,true,false", lang_strings("view"));

if ($teamMember == 'true' || $profilSession == PF_PROJECT_MANAGER_ADMINISTRATOR || $profilSession == PF_HR_MANAGER || $profilSession == PF_ADMINISTRATOR) {
    $block1->paletteScript(7, "edit", "../tasks/edittask.php?project=$project", "false,true,true", lang_strings("edit"));
    $block1->paletteScript(8, "timelog", "../tasks/addtasktime.php?", "false,true,false", lang_strings("loghours"));
}

if (($teamMember == 'true' && $profilSession == PF_PROJECT_MANAGER) || $profilSession == PF_PROJECT_MANAGER_ADMINISTRATOR || $profilSession == PF_HR_MANAGER || $profilSession == PF_ADMINISTRATOR) {
    $block1->paletteScript(9, "dependency", "../tasks/addpredecessor.php?project=$project", "false,true,false", lang_strings("add_predecessor"));
    $block1->paletteScript(10, "unlink", "../tasks/deletedependencies.php?project=$project", "false,true,false", lang_strings("delete_dependencies"));
    $block1->paletteScript(11, "indentation", "../tasks/indentation.php?project=$project", "false,true,false", lang_strings("indentation"));
    $block1->paletteScript(12, "unindentation", "../tasks/unindentation.php?project=$project", "false,true,false", lang_strings("unindentation"));
    $block1->paletteScript(13, "add_taskgroup", "../tasks/edittask.php?action=taskgroup&project=$project", "false,false,true", lang_strings("add_taskgroup"));
} 

$block1->closePaletteScript($comptListTasks, $listTasks->tas_id);

require_once("../themes/" . THEME . "/footer.php");

?>
