<?php // $Revision: 1.9 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: emailusers.php,v 1.9 2006/07/14 01:44:59 luis Exp $
 * 
 * Copyright (c) 2003 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$checkSession = true;
require_once("../includes/library.php");
$bodyCommand = "onLoad=\"document.sdEForm.subject.focus();\"";

// this limits it to just Admin & hr manager
if ($profilSession != PF_ADMINISTRATOR && $profilSession != PF_HR_MANAGER) {
    header("Location:../general/permissiondenied.php");
    exit;
}

$id = $_GET['id'];
$ids = str_replace("**", ",", $id);

if (isset($_POST['action'])) {
    $action = $_POST['action'];
    $subject = $_POST['subject'];
    $message = $_POST['message'];

    if ($subject == '') {
        $error = lang_strings("blank_fields");
        $bodyCommand = "onLoad=\"document.sdEForm.subject.focus();\"";
        $subject_highlight = true;
    } else if ($message == '') {
        $error = lang_strings("blank_fields");
        $bodyCommand = "onLoad=\"document.sdEForm.message.focus();\"";
        $message_highlight = true;
    }

    if ($action == "email" && $error == '') {
        $idList = split(",", $ids);
        $mail = new notification();
        $mail->getUserinfo($idSession, "from");

        foreach ($idList as $val) {
            $mail->getUserinfo($val, "to");
        }

        $mail->partMessage = "";
        $mail->openBody();
        $mail->Body .= $message . "\n";
        $mail->AltBody .= str_replace("\r\n", "\n", stripslashes($message)) . "\n";
        $mail->closeBody();
        $mail->Subject = stripslashes($subject);
        $mail->Priority = "3";
        $mail->Send();
        header("Location:../users/listusers.php?msg=email");
        exit;
    }
}

// start main page
require_once("../themes/" . THEME . "/header.php");
$blockPage = new block();
$blockPage->openBreadcrumbs();
$blockPage->itemBreadcrumbs($blockPage->buildLink("../administration/admin.php?", lang_strings("administration"), in));
$blockPage->itemBreadcrumbs($blockPage->buildLink("../users/listusers.php?", lang_strings("user_management"), in));
$blockPage->itemBreadcrumbs(lang_strings("email_users"));
$blockPage->closeBreadcrumbs();
$block1 = new block();
$block1->form = "sdE";
$block1->openForm("../users/emailusers.php?id=$id#" . $block1->form . "Anchor");
echo "<input type=\"hidden\" name=\"action\" value=\"email\">";

if ($error != "") {
    $block1->headingError(lang_strings("errors"));
    $block1->contentError($error);
}

$block1->heading(lang_strings("email_users"));
$block1->openContent();
$block1->contentTitle(lang_strings("email_following"));
$tmpquery = "WHERE mem.id IN ($ids) ORDER BY mem.name";
$listMembers = new request();
$listMembers->openMembers($tmpquery);
$comptListMembers = count($listMembers->mem_id);

for ($i = 0;$i < $comptListMembers;$i++) {
    if ($listMembers->mem_email_work[$i] != "") {
        $block1->contentRow("", $listMembers->mem_login[$i] . " / " . $listMembers->mem_name[$i]);
    } else {
        $block1->contentRow("", $listMembers->mem_login[$i] . " / " . $listMembers->mem_name[$i] . "&nbsp;&nbsp;" . lang_strings("no_email"));
    }
}

$block1->contentTitle(lang_strings("email"));

if ($subject_highlight) {
    $block1->contentRow("* " . lang_strings("subject"), "<input size=\"44\" class=\"input_text_highlight\" name=\"subject\" value=\"$subject\" maxlength=\"100\" type=\"text\">");
} else {
    $block1->contentRow("* " . lang_strings("subject"), "<input size=\"44\" class=\"input_text\" name=\"subject\" value=\"$subject\" maxlength=\"100\" type=\"text\">");
}

if ($message_highlight) {
    $block1->contentRow("* " . lang_strings("message"), "<textarea rows=\"3\" class=\"textarea_3rows_highlight\" name=\"message\" cols=\"47\">$message</textarea>");
} else {
    $block1->contentRow("* " . lang_strings("message"), "<textarea rows=\"3\" class=\"textarea_3rows\" name=\"message\" cols=\"47\">$message</textarea>");
}

$block1->contentRow("", "<input type=\"submit\" name=\"delete\" value=\"" . lang_strings("send") . "\"> <input type=\"button\" name=\"cancel\" value=\"" . lang_strings("cancel") . "\" onClick=\"history.back();\">");
$block1->closeContent();
$block1->closeForm();
require_once("../themes/" . THEME . "/footer.php");

?>
