<?php // $Revision: 1.1 $
/* vim: set expandtab ts=4 sw=4 sts=4: */

/**
 * $Id: server.php,v 1.1 2006/09/25 07:56:03 luis Exp $
 * 
 * Copyright (c) 2006 by the NetOffice developers
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 */

$checkSession = false;
require_once('../includes/library.php');
include("../xmlrpc/lib/xmlrpc.inc");
include("../xmlrpc/lib/xmlrpcs.inc");
include("../xmlrpc/lib/xmlrpcerruser.inc");
$xmlRpcErrCod = "";

function check_session($memberId, $sessionId)
{
    global $tableCollab, $xmlRpcErrCod;
    $xmlRpcErrCod = "";
    $tmpquery = "WHERE log.session='$sessionId' AND mem.id='$memberId' AND connected IS NOT NULL";
    $registerLog = new request();
    $registerLog->openLogs($tmpquery);
    $comptRegisterLog = count($registerLog->log_id);

    if ($comptRegisterLog > 0) {
        $dateunix = date('U');

        if ($registerLog->log_connected[0] > $dateunix-5*60) {
            $tmpquery1 = 'UPDATE ' . $tableCollab['logs'] . " SET connected='$dateunix' WHERE id='" . $registerLog->log_id[0] . "'";
            connectSql($tmpquery1);
        } else {
            $xmlRpcErrCod = 'session_false';
        }
    } else {
        $xmlRpcErrCod = 'session_false';
    }
}

function convert_dateTime_iso8601($dt)
{
    return substr($dt, 0, 4) . substr($dt, 5, 2) . substr($dt, 8, 2) . "T" . substr($dt, 11, 8);
}

function get_project($id, $depth, $breadcrumbs)
{
    global $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $tmpquery = "WHERE pro.id='$id'";
    $projectDetail = new request();
    $projectDetail->openProjects($tmpquery);
    $comptProjectDetail = count($projectDetail->pro_id);

    if ($comptProjectDetail == 0) {
        $xmlRpcErrCod = 'blank_project';
        error_log(lang_strings($xmlRpcErrCod) . " id=" . $id);
        return new xmlrpcval();
    } else {
        if ($depth == 0 || $breadcrumbs['project'][$id]) {
            return new xmlrpcval($id, $xmlrpcI4);
        }

        $breadcrumbs['project'][$id] = true;
        $organizationVal = get_organization($projectDetail->pro_organization[0], $depth-1, $breadcrumbs);

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        $ownerVal = get_member($projectDetail->pro_owner[0], $depth-1, $breadcrumbs);

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        $tmpquery = "WHERE tas.project='" . $projectDetail->pro_id[0] . "'";
        $listTasks = new request();
        $listTasks->openTasks($tmpquery);
        $comptListTasks = count($listTasks->tas_id);
        $tmpquery = "WHERE tea.project='" . $projectDetail->pro_id[0] . "'";
        $listMembers = new request();
        $listMembers->openTeams($tmpquery);
        $comptListMembers = count($listMembers->tea_id);
        $tmpquery = "WHERE fil.project='" . $projectDetail->pro_id[0] . "'";
        $listFiles = new request();
        $listFiles->openFiles($tmpquery);
        $comptListFiles = count($listFiles->fil_id);

        for ($i=0; $i<$comptListTasks && $xmlRpcErrCod == ""; $i++) {
            $taskArray[] = get_task($listTasks->tas_id[$i], $depth-1, $breadcrumbs);
        }

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        for ($i=0; $i<$comptListMembers && $xmlRpcErrCod == ""; $i++) {
            $memberArray[] = get_member($listMembers->tea_member[$i], $depth-1, $breadcrumbs);
        }

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        for ($i=0; $i<$comptListFiles && $xmlRpcErrCod == ""; $i++) {
            $fileArray[] = get_file($listFiles->fil_id[$i], $depth-1, $breadcrumbs);
        }

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        $projectVal['organization'] = $organizationVal;
        $projectVal['owner'] = $ownerVal;
        $projectVal['priority'] = new xmlrpcval((integer)($projectDetail->pro_priority[0]), $xmlrpcI4);
        $projectVal['status'] = new xmlrpcval((integer)($projectDetail->pro_status[0]), $xmlrpcI4);
        $projectVal['name'] = new xmlrpcval($projectDetail->pro_name[0], $xmlrpcString);
        $projectVal['description'] = new xmlrpcval($projectDetail->pro_description[0], $xmlrpcString);
        $projectVal['url_dev'] = new xmlrpcval($projectDetail->pro_url_dev[0], $xmlrpcString);
        $projectVal['url_prod'] = new xmlrpcval($projectDetail->pro_url_prod[0], $xmlrpcString);
        $projectVal['created'] = new xmlrpcval(convert_dateTime_iso8601($projectDetail->pro_created[0]), $xmlrpcDateTime);

        if ($projectDetail->pro_modified[0] != "") {
            $projectVal['modified'] = new xmlrpcval(convert_dateTime_iso8601($projectDetail->pro_modified[0]), $xmlrpcDateTime);
        }

        $projectVal['published'] = new xmlrpcval(($projectDetail->pro_published[0]==PB_YES?1:0), $xmlrpcBoolean);
        $projectVal['upload_max'] = new xmlrpcval((integer)($projectDetail->pro_upload_max[0]), $xmlrpcI4);
        $projectVal['phase_set'] = new xmlrpcval((integer)($projectDetail->pro_phase_set[0]), $xmlrpcI4);
        $projectVal['type'] = new xmlrpcval((integer)($projectDetail->pro_type[0]), $xmlrpcI4);

        if (count($taskArray) > 0) {
            $projectVal['tasks'] = new xmlrpcval($taskArray, $xmlrpcArray);
        }

        if (count($memberArray) > 0) {
            $projectVal['team'] = new xmlrpcval($memberArray, $xmlrpcArray);
        }

        if (count($fileArray) > 0) {
            $projectVal['linked_content'] = new xmlrpcval($fileArray, $xmlrpcArray);
        }

        return new xmlrpcval($projectVal, $xmlrpcStruct);
    }
}

function get_task($id, $depth, $breadcrumbs)
{
    global $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $tmpquery = "WHERE tas.id='$id'";
    $taskDetail = new request();
    $taskDetail->openTasks($tmpquery);
    $comptTaskDetail = count($taskDetail->tas_id);

    if ($comptTaskDetail == 0) {
        $xmlRpcErrCod = 'blank_task';
        error_log(lang_strings($xmlRpcErrCod) . " id=" . $id);
        return new xmlrpcval();
    } else {
        if ($depth == 0 || $breadcrumbs['task'][$id]) {
            return new xmlrpcval($id, $xmlrpcI4);
        }

        $breadcrumbs['task'][$id] = true;
        $projectVal = get_project($taskDetail->tas_project[0], $depth-1, $breadcrumbs);

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        $ownerVal = get_member($taskDetail->tas_owner[0], $depth-1, $breadcrumbs);

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        $tmpquery = " AND res.task='$id'";
        $listMembers = new request();
        $listMembers->openTaskHumanResource($tmpquery);
        $comptListMembers = count($listMembers->res_id);

        if ($taskDetail->tas_parent_task[0] > 0) {
            $parentTaskVal = get_task($taskDetail->tas_parent_task[0], $depth-1, $breadcrumbs);

            if ($xmlRpcErrCod != "") return new xmlrpcval();
        }

        $tmpquery = "WHERE tas.parent_task='$id'";
        $listSubTasks = new request();
        $listSubTasks->openTasks($tmpquery);
        $comptListSubTasks = count($listSubTasks->tas_id);
        $tmpquery = "WHERE pre.task='$id'";
        $listPredecessors = new request();
        $listPredecessors->openTaskPredecessor($tmpquery);
        $comptListPredecessors = count($listPredecessors->pre_id);
        $tmpquery = "WHERE fil.task='$id'";

        for ($i=0; $i<$comptListMembers && $xmlRpcErrCod == ""; $i++) {
            $memberArray[] = get_member($listMembers->res_resource[$i], $depth-1, $breadcrumbs);
        }

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        for ($i=0; $i<$comptListSubTasks && $xmlRpcErrCod == ""; $i++) {
            $subTaksArray[] = get_task($listSubTasks->tas_id[$i], $depth-1, $breadcrumbs);
        }

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        for ($i=0; $i<$comptListPredecessors && $xmlRpcErrCod == ""; $i++) {
            $taskPVal = get_task($listPredecessors->pre_predecessor[$i], $depth-1, $breadcrumbs);
            $predecessorArray[] = new xmlrpcval(
                array("task" => $taskPVal,
                      "type" => new xmlrpcval($listPredecessors->pre_type[$i], $xmlrpcString),
                      "lag" => new xmlrpcval((double)($listPredecessors->pre_lag[$i]), $xmlrpcDouble)),
                $xmlrpcStruct);
        }

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        $taskVal['project'] = $projectVal;
        $taskVal['priority'] = new xmlrpcval((integer)($taskDetail->tas_priority[0]), $xmlrpcI4);
        $taskVal['status'] = new xmlrpcval((integer)($taskDetail->tas_status[0]), $xmlrpcI4);
        $taskVal['owner'] = $ownerVal;

        if (count($memberArray) > 0) {
            $taskVal['assigned_to'] = new xmlrpcval($memberArray, $xmlrpcArray);
        }

        $taskVal['name'] = new xmlrpcval($taskDetail->tas_name[0], $xmlrpcString);
        $taskVal['description'] = new xmlrpcval($taskDetail->tas_description[0], $xmlrpcString);
        $taskVal['start_date'] = new xmlrpcval(convert_dateTime_iso8601($taskDetail->tas_start_date[0]), $xmlrpcDateTime);
        $taskVal['due_date'] = new xmlrpcval(convert_dateTime_iso8601($taskDetail->tas_due_date[0]), $xmlrpcDateTime);
        $taskVal['estimated_time'] = new xmlrpcval((double)($taskDetail->tas_estimated_time[0]), $xmlrpcDouble);
        $taskVal['actual_time'] = new xmlrpcval((double)($taskDetail->tas_actual_time[0]), $xmlrpcDouble);
        $taskVal['comments'] = new xmlrpcval($taskDetail->tas_comments[0], $xmlrpcString);
        $taskVal['completion'] = new xmlrpcval((integer)($taskDetail->tas_completion[0]), $xmlrpcI4);
        $taskVal['created'] = new xmlrpcval(convert_dateTime_iso8601($taskDetail->tas_created[0]), $xmlrpcDateTime);

        if ($taskDetail->tas_modified[0] != "") {
            $taskVal['modified'] = new xmlrpcval(convert_dateTime_iso8601($taskDetail->tas_modified[0]), $xmlrpcDateTime);
        }

        if ($taskDetail->tas_assigned[0] != "") {
            $taskVal['assigned'] = new xmlrpcval(convert_dateTime_iso8601($taskDetail->tas_assigned[0]), $xmlrpcDateTime);
        }

        $taskVal['published'] = new xmlrpcval(($taskDetail->tas_published[0]==PB_YES?1:0), $xmlrpcBoolean);
        $taskVal['parent_phase'] = new xmlrpcval((integer)($taskDetail->tas_parent_phase[0]), $xmlrpcI4);

        if ($taskDetail->tas_complete_date[0] != "") {
            $taskVal['complete_date'] = new xmlrpcval(convert_dateTime_iso8601($taskDetail->tas_complete_date[0]), $xmlrpcDateTime);
        }

        $taskVal['milestone'] = new xmlrpcval(($taskDetail->tas_milestone[0]==MS_YES?1:0), $xmlrpcBoolean);
        $taskVal['type'] = new xmlrpcval((integer)($taskDetail->tas_type[0]), $xmlrpcI4);
        $taskVal['task_group'] = new xmlrpcval(($taskDetail->tas_task_group[0]==TG_YES?1:0), $xmlrpcBoolean);
        $taskVal['level'] = new xmlrpcval((integer)($taskDetail->tas_level[0]), $xmlrpcI4);

        if ($taskDetail->tas_parent_task[0] > 0) {
            $taskVal['parent_task'] = $parentTaskVal;
        }

        if (count($subTaskArray) > 0) {
            $taskVal['subtasks'] = new xmlrpcval($subTaskArray, $xmlrpcArray);
        }

        if (count($predecessorArray) > 0) {
            $taskVal['predecessors'] = new xmlrpcval($predecessorArray, $xmlrpcArray);
        }

        return new xmlrpcval($taskVal, $xmlrpcStruct);
    }
}

function get_member($id, $depth, $breadcrumbs)
{
    global $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $tmpquery = "WHERE mem.id='$id'";
    $memberDetail = new request();
    $memberDetail->openMembers($tmpquery);
    $comptMemberDetail = count($memberDetail->mem_id);

    if ($comptMemberDetail == 0) {
        $xmlRpcErrCod = 'blank_user';
        error_log(lang_strings($xmlRpcErrCod) . " id=" . $id);
        return new xmlrpcval();
    } else {
        if ($depth == 0 || $breadcrumbs['member'][$id]) {
            return new xmlrpcval($id, $xmlrpcI4);
        }

        $breadcrumbs['member'][$id] = true;
        $organizationVal = get_organization($memberDetail->mem_organization[0], $depth-1, $breadcrumbs);

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        if ($memberDetail->mem_supervisor[0] > 0) {
            $supervisorVal = get_member($memberDetail->mem_supervisor[0], $depth-1, $breadcrumbs);

            if ($xmlRpcErrCod != "") return new xmlrpcval();
        }

        if ($memberDetail->mem_agent[0] > 0) {
            $agentVal = get_member($memberDetail->mem_agent[0], $depth-1, $breadcrumbs);

            if ($xmlRpcErrCod != "") return new xmlrpcval();
        }

        $memberVal['organization'] = $organizationVal;
        $memberVal['login'] = new xmlrpcval($memberDetail->mem_login[0], $xmlrpcString);
        $memberVal['name'] = new xmlrpcval($memberDetail->mem_name[0], $xmlrpcString);
        $memberVal['title'] = new xmlrpcval($memberDetail->mem_title[0], $xmlrpcString);
        $memberVal['email_work'] = new xmlrpcval($memberDetail->mem_email_work[0], $xmlrpcString);
        $memberVal['email_home'] = new xmlrpcval($memberDetail->mem_email_home[0], $xmlrpcString);
        $memberVal['phone_work'] = new xmlrpcval($memberDetail->mem_phone_work[0], $xmlrpcString);
        $memberVal['phone_home'] = new xmlrpcval($memberDetail->mem_phone_home[0], $xmlrpcString);
        $memberVal['mobile'] = new xmlrpcval($memberDetail->mem_mobile[0], $xmlrpcString);
        $memberVal['fax'] = new xmlrpcval($memberDetail->mem_fax[0], $xmlrpcString);
        $memberVal['comments'] = new xmlrpcval($memberDetail->mem_comments[0], $xmlrpcString);
        $memberVal['profile'] = new xmlrpcval((integer)($memberDetail->mem_profil[0]), $xmlrpcI4);

        if ($memberDetail->mem_supervisor[0] > 0) {
            $memberVal['supervisor'] = $supervisorVal;
        }

        if ($memberDetail->mem_agent[0] > 0) {
            $memberVal['agent'] = $agentVal;
        }

        return new xmlrpcval($memberVal, $xmlrpcStruct);
    }
}

function get_organization($id, $depth, $breadcrumbs)
{
    global $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $tmpquery = "WHERE org.id='$id'";
    $organizationDetail = new request();
    $organizationDetail->openOrganizations($tmpquery);
    $comptOrganizationDetail = count($organizationDetail->org_id);

    if ($comptOrganizationDetail == 0) {
        $xmlRpcErrCod = 'blank_organization';
        error_log(lang_strings($xmlRpcErrCod) . " id=" . $id);
        return new xmlrpcval();
    } else {
        if ($depth == 0 || $breadcrumbs['organization'][$id]) {
            return new xmlrpcval($id, $xmlrpcI4);
        }

        $breadcrumbs['organization'][$id] = true;

        if ($id > 1) {
            $ownerVal = get_member($organizationDetail->org_owner[0], $depth-1, $breadcrumbs);
        }

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        $address = $organizationDetail->org_address1[0] . $organizationDetail->org_address2[0];
        $logFile = '../logos_clients/' . $id . '.' . $organizationDetail->org_extension_logo[0];

        if (file_exists($logFile)) {
            $existFile = true;
            $logFileVal = new xmlrpcval(file_get_contents($logFile), $xmlrpcBase64);
        }

        $organizationVal['name'] = new xmlrpcval($organizationDetail->org_name[0], $xmlrpcString);
        $organizationVal['address'] = new xmlrpcval($address, $xmlrpcString);
        $organizationVal['zip_code'] = new xmlrpcval($organizationDetail->org_zip_code[0], $xmlrpcString);
        $organizationVal['city'] = new xmlrpcval($organizationDetail->org_city[0], $xmlrpcString);
        $organizationVal['country'] = new xmlrpcval($organizationDetail->org_country[0], $xmlrpcString);
        $organizationVal['phone'] = new xmlrpcval($organizationDetail->org_phone[0], $xmlrpcString);
        $organizationVal['fax'] = new xmlrpcval($organizationDetail->org_fax[0], $xmlrpcString);
        $organizationVal['url'] = new xmlrpcval($organizationDetail->org_url[0], $xmlrpcString);
        $organizationVal['email'] = new xmlrpcval($organizationDetail->org_email[0], $xmlrpcString);
        $organizationVal['comments'] = new xmlrpcval($organizationDetail->org_comments[0], $xmlrpcString);
        $organizationVal['created'] = new xmlrpcval(convert_dateTime_iso8601($organizationDetail->org_created[0]), $xmlrpcString);

        if ($id > 1) {
            $organizationVal['owner'] = $ownerVal;
        }

        if ($existFile) {
            $organizationVal['extension_logo'] = new xmlrpcval($organizationDetail->org_extension_logo[0], $xmlrpcString);
            $organizationVal['logo'] = $logFileVal;
        }

        return new xmlrpcval($organizationVal, $xmlrpcStruct);
    }
}

function get_file($id, $depth, $breadcrumbs)
{
    global $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $tmpquery = "WHERE fil.id='$id'";
    $fileDetail = new request();
    $fileDetail->openFiles($tmpquery);
    $comptFileDetail = count($fileDetail->fil_id);

    if ($comptFileDetail == 0) {
        $xmlRpcErrCod = 'missing_file';
        error_log(lang_strings($xmlRpcErrCod) . " id=" . $id);
        return new xmlrpcval();
    } else {
        if ($depth == 0 || $breadcrumbs['file'][$id]) {
            return new xmlrpcval($id, $xmlrpcI4);
        }

        $breadcrumbs['file'][$id] = true;
        $ownerVal = get_member($fileDetail->fil_owner[0], $depth-1, $breadcrumbs);

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        $projectVal = get_project($fileDetail->fil_project[0], $depth-1, $breadcrumbs);

        if ($xmlRpcErrCod != "") return new xmlrpcval();

        if ($fileDetail->fil_task[0] > 0) {
            $taskVal = get_task($fileDetail->fil_task[0], $depth-1, $breadcrumbs);

            if ($xmlRpcErrCod != "") return new xmlrpcval();
        }

        if ($fileDetail->fil_approver[0] > 0) {
            $approverVal = get_member($fileDetail->fil_approver[0], $depth-1, $breadcrumbs);

            if ($xmlRpcErrCod != "") return new xmlrpcval();
        }

        if ($fileDetail->fil_vc_parent[0] > 0) {
            $parentVal = get_file($fileDetail->fil_vc_parent[0], $depth-1, $breadcrumbs);

            if ($xmlRpcErrCod != "") return new xmlrpcval();
        }

        if ($fileDetail->fil_task[0] > 0) {
            $fileName = "files/" . $fileDetail->fil_project[0] . "/" . $fileDetail->fil_task[0] . "/" . $fileDetail->fil_name[0];
        } else {
            $fileName = "files/" . $fileDetail->fil_project[0] . "/" . $fileDetail->fil_name[0];
        }

        if (fileExists($fileName)) {
            $contentVal = new xmlrpcval(fileContent($fileName), $xmlrpcBase64);
        } else {
            $xmlRpcErrCod = "missing_file";
            return new xmlrpcval();
        }

        $fileVal['owner'] = $ownerVal;
        $fileVal['project'] = $projectVal;

        if ($fileDetail->fil_task[0] > 0) {
            $fileVal['task'] = $taskVal;
        }

        $fileVal['name'] = new xmlrpcval($fileDetail->fil_name[0], $xmlrpcString);
        $fileVal['date'] = new xmlrpcval(convert_dateTime_iso8601($fileDetail->fil_date[0]), $xmlrpcDateTime);
        $fileVal['size'] = new xmlrpcval($fileDetail->fil_size[0], $xmlrpcString);
        $fileVal['extension'] = new xmlrpcval($fileDetail->fil_extension[0], $xmlrpcString);
        $fileVal['comments'] = new xmlrpcval($fileDetail->fil_comments[0], $xmlrpcString);

        if ($fileDetail->fil_approver[0] > 0) {
            $fileVal['comments_approval'] = new xmlrpcval($fileDetail->fil_comments_approval[0], $xmlrpcString);
            $fileVal['approver'] = $approverVal;
            $fileVal['date_approval'] = new xmlrpcval(convert_dateTime_iso8601($fileDetail->fil_date_approval[0]), $xmlrpcDateTime);
        }

        $fileVal['upload'] = new xmlrpcval(convert_dateTime_iso8601($fileDetail->fil_upload[0]), $xmlrpcDateTime);
        $fileVal['published'] = new xmlrpcval(($fileDetail->fil_published[0]==PB_YES?1:0), $xmlrpcBoolean);
        $fileVal['status'] = new xmlrpcval((integer)($fileDetail->fil_status[0]), $xmlrpcI4);
        $fileVal['vc_status'] = new xmlrpcval((integer)($fileDetail->fil_vc_status[0]), $xmlrpcI4);
        $fileVal['vc_version'] = new xmlrpcval($fileDetail->fil_vc_version[0], $xmlrpcString);

        if ($fileDetail->fil_vc_parent[0] > 0) {
            $fileVal['vc_parent'] = $parentVal;
        }

        $fileVal['phase'] = new xmlrpcval((integer)($fileDetail->fil_phase[0]), $xmlrpcI4);
        $fileVal['content'] = $contentVal;
        return new xmlrpcval($fileVal, $xmlrpcStruct);
    }
}

function netoffice_login($m)
{
    global $xmlRpcErrUser, $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $xmlRpcErrCod = "";
    $param1 = $m->getParam(0);
    $loginVal = $param1->structmem("login");
    $passwordVal = $param1->structmem("password");
    $loginForm = $loginVal->scalarval();
    $passwordForm = $passwordVal->scalarval();

    if ($loginForm == '') {
        $xmlRpcErrCod = 'login_username';
    } else if ($passwordForm == '') {
        $xmlRpcErrCod = 'login_password';
    } else {
        $tmpquery = "WHERE mem.login = '$loginForm' AND mem.login != 'demo' AND mem.profil NOT IN ('" . PF_DISABLED . "','" . PF_DELETED . "')";
        $loginUser = new request();
        $loginUser->openMembers($tmpquery);
        $comptLoginUser = count($loginUser->mem_id);

        if ($comptLoginUser == '0') {
            $xmlRpcErrCod = 'invalid_login';
        } else if (!is_password_match($loginForm, $passwordForm, $loginUser->mem_password[0])) {
            $xmlRpcErrCod = 'invalid_login';
        }
    }

    if ($xmlRpcErrCod == "") {
        // encrypt password in session using the defined loginMethod from settings.php
        $passwordForm = get_password($passwordForm);
        // get the ip addr
        $ip = SESS_REMOTE_ADDR;
        // insert into or update log
        $tmpquery = "WHERE log.login = '$loginForm'";
        $registerLog = new request();
        $registerLog->openLogs($tmpquery);
        $comptRegisterLog = count($registerLog->log_id);
        $session = session_id();
        $dateunix = date('U');

        if ($comptRegisterLog == '0') {
            $tmpquery1 = "INSERT INTO " . $tableCollab['logs'] . "(login,password,ip,session,compt,last_visite,connected) VALUES('$loginForm','$passwordForm','$ip','$session','1','$dateheure','$dateunix')";
            connectSql($tmpquery1);
        } else {
            $_SESSION['lastvisiteSession'] = $registerLog->log_last_visite[0];
            $increm = $registerLog->log_compt[0] + 1;
            $tmpquery1 = "UPDATE " . $tableCollab['logs'] . " SET ip='$ip',session='$session',compt='$increm',last_visite='$dateheure',connected='$dateunix' WHERE login = '$loginForm'";
            connectSql($tmpquery1);
        }

        $responseVal = new xmlrpcval(
            array(
                "member_id" => new xmlrpcval((integer)($loginUser->mem_id[0]), $xmlrpcI4),
                "session_id" => new xmlrpcval($session, $xmlrpcString)),
            $xmlrpcStruct);
        return new xmlrpcresp($responseVal);
    } else {
        return new xmlrpcresp(0, $xmlRpcErrUser[$xmlRpcErrCod][0], $xmlRpcErrUser[$xmlRpcErrCod][1]);
    }
}

function netoffice_logout($m)
{
    global $xmlRpcErrUser, $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $xmlRpcErrCod = "";
    $param1 = $m->getParam(0);
    $memberIdVal = $param1->structmem("member_id");
    $sessionIdVal = $param1->structmem("session_id");
    $memberId = $memberIdVal->scalarval();
    $sessionId = $sessionIdVal->scalarval();
    $tmpquery = "WHERE log.session='$sessionId' AND mem.id='$memberId'";
    $registerLog = new request();
    $registerLog->openLogs($tmpquery);
    $comptRegisterLog = count($registerLog->log_id);

    if ($comptRegisterLog > 0) {
        // update the logs table before logout
        $tmpquery1 = "UPDATE " . $tableCollab['logs'] . " SET connected=NULL ";
        $tmpquery1 .= "WHERE id='" . $registerLog->log_id[0] . "'";
        connectSql($tmpquery1);
    } else {
        $xmlRpcErrCod = 'session_false';
    } 

    if ($xmlRpcErrCod == "") {
        $responseVal = new xmlrpcval(
            array(
                "member_id" => new xmlrpcval((integer)($memberId), $xmlrpcI4)),
            $xmlrpcStruct);
        return new xmlrpcresp($responseVal);
    } else {
        return new xmlrpcresp(0, $xmlRpcErrUser[$xmlRpcErrCod][0], $xmlRpcErrUser[$xmlRpcErrCod][1]);
    }
}

function projectlist_get($m)
{
    global $xmlRpcErrUser, $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $xmlRpcErrCod = "";
    $param1 = $m->getParam(0);
    $param2 = $m->getParam(1);
    $memberIdVal = $param1->structmem("member_id");
    $sessionIdVal = $param1->structmem("session_id");
    $depthVal = $param2->structmem("depth");
    $memberId = $memberIdVal->scalarval();
    $sessionId = $sessionIdVal->scalarval();
    $depth = $depthVal->scalarval();
    check_session($memberId, $sessionId);

    if ($depth <= 0) {
        $xmlRpcErrCod = "invalid_depth";
    }

    if ($xmlRpcErrCod == "") {
        $tmpquery = "WHERE tea.member='$memberId'";
        $listProjects = new request();
        $listProjects->openTeams($tmpquery);
        $comptListProjects = count($listProjects->tea_id);

        if ($comptListProjects == 0) {
            $xmlRpcErrCod = "no_items";
        } else {
            for ($i=0; $i<$comptListProjects && $xmlRpcErrCod == ""; $i++) {
                $a[] = get_project($listProjects->tea_pro_id[$i], $depth-1, $breadcrumbs);
            }
        }
    }

    if ($xmlRpcErrCod == "") {
        $responseVal = new xmlrpcval($a, $xmlrpcArray);
        return new xmlrpcresp($responseVal);
    } else {
        return new xmlrpcresp(0, $xmlRpcErrUser[$xmlRpcErrCod][0], $xmlRpcErrUser[$xmlRpcErrCod][1]);
    }
}

function tasklist_get($m)
{
    global $xmlRpcErrUser, $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $xmlRpcErrCod = "";
    $param1 = $m->getParam(0);
    $param2 = $m->getParam(1);
    $memberIdVal = $param1->structmem("member_id");
    $sessionIdVal = $param1->structmem("session_id");
    $depthVal = $param2->structmem("depth");
    $memberId = $memberIdVal->scalarval();
    $sessionId = $sessionIdVal->scalarval();
    $depth = $depthVal->scalarval();
    check_session($memberId, $sessionId);

    if ($depth <= 0) {
        $xmlRpcErrCod = "invalid_depth";
    }

    if ($xmlRpcErrCod == "") {
        $tmpquery = " AND res.resource='$memberId'";
        $listTasks = new request();
        $listTasks->openTaskHumanResource($tmpquery);
        $comptListTasks = count($listTasks->res_id);

        if ($comptListTasks == 0) {
            $xmlRpcErrCod = "no_items";
        } else {
            for ($i=0; $i<$comptListTasks && $xmlRpcErrCod == ""; $i++) {
                $a[] = get_task($listTasks->res_task[$i], $depth-1, $breadcrumbs);
            }
        }
    }

    if ($xmlRpcErrCod == "") {
        $responseVal = new xmlrpcval($a, $xmlrpcArray);
        return new xmlrpcresp($responseVal);
    } else {
        return new xmlrpcresp(0, $xmlRpcErrUser[$xmlRpcErrCod][0], $xmlRpcErrUser[$xmlRpcErrCod][1]);
    }
}

function project_get($m)
{
    global $xmlRpcErrUser, $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $xmlRpcErrCod = "";
    $param1 = $m->getParam(0);
    $param2 = $m->getParam(1);
    $memberIdVal = $param1->structmem("member_id");
    $sessionIdVal = $param1->structmem("session_id");
    $projectIdVal = $param2->structmem("project_id");
    $depthVal = $param2->structmem("depth");
    $memberId = $memberIdVal->scalarval();
    $sessionId = $sessionIdVal->scalarval();
    $projectId = $projectIdVal->scalarval();
    $depth = $depthVal->scalarval();
    check_session($memberId, $sessionId);

    if ($depth <= 0) {
        $xmlRpcErrCod = "invalid_depth";
    }

    if ($xmlRpcErrCod == "") {
        $responseVal = get_project($projectId, $depth, $breadcrumbs);
    }

    if ($xmlRpcErrCod == "") {
        return new xmlrpcresp($responseVal);
    } else {
        return new xmlrpcresp(0, $xmlRpcErrUser[$xmlRpcErrCod][0], $xmlRpcErrUser[$xmlRpcErrCod][1]);
    }
}

function task_get($m)
{
    global $xmlRpcErrUser, $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $xmlRpcErrCod = "";
    $param1 = $m->getParam(0);
    $param2 = $m->getParam(1);
    $memberIdVal = $param1->structmem("member_id");
    $sessionIdVal = $param1->structmem("session_id");
    $taskIdVal = $param2->structmem("task_id");
    $depthVal = $param2->structmem("depth");
    $memberId = $memberIdVal->scalarval();
    $sessionId = $sessionIdVal->scalarval();
    $taskId = $taskIdVal->scalarval();
    $depth = $depthVal->scalarval();
    check_session($memberId, $sessionId);

    if ($depth <= 0) {
        $xmlRpcErrCod = "invalid_depth";
    }

    if ($xmlRpcErrCod == "") {
        $responseVal = get_task($taskId, $depth, $breadcrumbs);
    }

    if ($xmlRpcErrCod == "") {
        return new xmlrpcresp($responseVal);
    } else {
        return new xmlrpcresp(0, $xmlRpcErrUser[$xmlRpcErrCod][0], $xmlRpcErrUser[$xmlRpcErrCod][1]);
    }
}

function member_get($m)
{
    global $xmlRpcErrUser, $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $xmlRpcErrCod = "";
    $param1 = $m->getParam(0);
    $param2 = $m->getParam(1);
    $memberIdVal = $param1->structmem("member_id");
    $sessionIdVal = $param1->structmem("session_id");
    $memberIdVal2 = $param2->structmem("member_id");
    $depthVal = $param2->structmem("depth");
    $memberId = $memberIdVal->scalarval();
    $sessionId = $sessionIdVal->scalarval();
    $memberId2 = $memberIdVal2->scalarval();
    $depth = $depthVal->scalarval();
    check_session($memberId, $sessionId);

    if ($depth <= 0) {
        $xmlRpcErrCod = "invalid_depth";
    }

    if ($xmlRpcErrCod == "") {
        $responseVal = get_member($memberId2, $depth, $breadcrumbs);
    }

    if ($xmlRpcErrCod == "") {
        return new xmlrpcresp($responseVal);
    } else {
        return new xmlrpcresp(0, $xmlRpcErrUser[$xmlRpcErrCod][0], $xmlRpcErrUser[$xmlRpcErrCod][1]);
    }
}

function organization_get($m)
{
    global $xmlRpcErrUser, $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $xmlRpcErrCod = "";
    $param1 = $m->getParam(0);
    $param2 = $m->getParam(1);
    $memberIdVal = $param1->structmem("member_id");
    $sessionIdVal = $param1->structmem("session_id");
    $organizationIdVal = $param2->structmem("organization_id");
    $depthVal = $param2->structmem("depth");
    $memberId = $memberIdVal->scalarval();
    $sessionId = $sessionIdVal->scalarval();
    $organizationId = $organizationIdVal->scalarval();
    $depth = $depthVal->scalarval();
    check_session($memberId, $sessionId);

    if ($depth <= 0) {
        $xmlRpcErrCod = "invalid_depth";
    }

    if ($xmlRpcErrCod == "") {
        $responseVal = get_organization($organizationId, $depth, $breadcrumbs);
    }

    if ($xmlRpcErrCod == "") {
        return new xmlrpcresp($responseVal);
    } else {
        return new xmlrpcresp(0, $xmlRpcErrUser[$xmlRpcErrCod][0], $xmlRpcErrUser[$xmlRpcErrCod][1]);
    }
}

function document_get($m)
{
    global $xmlRpcErrUser, $tableCollab, $xmlRpcErrCod;
    global $xmlrpcI4, $xmlrpcInt, $xmlrpcBoolean, $xmlrpcDouble, $xmlrpcString, $xmlrpcDateTime, $xmlrpcBase64, $xmlrpcArray, $xmlrpcStruct;
    $xmlRpcErrCod = "";
    $param1 = $m->getParam(0);
    $param2 = $m->getParam(1);
    $memberIdVal = $param1->structmem("member_id");
    $sessionIdVal = $param1->structmem("session_id");
    $documentIdVal = $param2->structmem("document_id");
    $depthVal = $param2->structmem("depth");
    $memberId = $memberIdVal->scalarval();
    $sessionId = $sessionIdVal->scalarval();
    $documentId = $documentIdVal->scalarval();
    $depth = $depthVal->scalarval();
    check_session($memberId, $sessionId);

    if ($depth <= 0) {
        $xmlRpcErrCod = "invalid_depth";
    }

    if ($xmlRpcErrCod == "") {
        $responseVal = get_file($documentId, $depth, $breadcrumbs);
    }

    if ($xmlRpcErrCod == "") {
        return new xmlrpcresp($responseVal);
    } else {
        return new xmlrpcresp(0, $xmlRpcErrUser[$xmlRpcErrCod][0], $xmlRpcErrUser[$xmlRpcErrCod][1]);
    }
}


$a = array(
    "netOffice.Login" => array("function" => "netoffice_login"),
    "netOffice.Logout" => array("function" => "netoffice_logout"),
    "ProjectList.Get" => array("function" => "projectlist_get"),
    "TaskList.Get" => array("function" => "tasklist_get"),
    "Project.Get" => array("function" => "project_get"),
    "Task.Get" => array("function" => "task_get"),
    "Member.Get" => array("function" => "member_get"),
    "Organization.Get" => array("function" => "organization_get"),
    "Document.Get" => array("function" => "document_get")
    );

$s = new xmlrpc_server($a, false);
//$s->setdebug(3); // debug only ***********************************************
//$s->compress_response = true;

// out-of-band information: let the client manipulate the server operations.
// we do this to help the testsuite script: do not reproduce in production!
if (isset($_GET['RESPONSE_ENCODING'])) {
    $s->response_charset_encoding = $_GET['RESPONSE_ENCODING'];
}
//$s->response_charset_encoding = 'UTF-8';

$s->service();

?>
